/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 42 "parser.yy"

#define YYDEBUG_LEXER_TEXT (yylval)						// lexer loads this up each time
#define YYDEBUG 1										// get the pretty debugging code to compile

#undef __GNUC_MINOR__

#include <cstdio>
#include <stack>
#include "lex.h"
#include "parser.h"
#include "ParseNode.h"
#include "TypedefTable.h"
#include "TypeData.h"
#include "LinkageSpec.h"
using namespace std;

extern DeclarationNode * parseTree;
extern LinkageSpec::Spec linkage;
extern TypedefTable typedefTable;

stack< LinkageSpec::Spec > linkageStack;

void appendStr( string *to, string *from ) {
	// "abc" "def" "ghi" => "abcdefghi", remove new text from quotes and insert before last quote in old string.
	to->insert( to->length() - 1, from->substr( 1, from->length() - 2 ) );
} // appendStr

DeclarationNode * distAttr( DeclarationNode * specifier, DeclarationNode * declList ) {
	// distribute declaration_specifier across all declared variables, e.g., static, const, __attribute__.
	DeclarationNode * cur = declList, * cl = (new DeclarationNode)->addType( specifier );
	//cur->addType( specifier );
	for ( cur = dynamic_cast< DeclarationNode * >( cur->get_next() ); cur != nullptr; cur = dynamic_cast< DeclarationNode * >( cur->get_next() ) ) {
		cl->cloneBaseType( cur );
	} // for
	declList->addType( cl );
//	delete cl;
	return declList;
} // distAttr

void distExt( DeclarationNode * declaration ) {
	// distribute EXTENSION across all declarations
	for ( DeclarationNode *iter = declaration; iter != nullptr; iter = (DeclarationNode *)iter->get_next() ) {
		iter->set_extension( true );
	} // for
} // distExt


/* Line 268 of yacc.c  */
#line 119 "Parser/parser.cc"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TYPEDEF = 258,
     AUTO = 259,
     EXTERN = 260,
     REGISTER = 261,
     STATIC = 262,
     INLINE = 263,
     FORTRAN = 264,
     CONST = 265,
     VOLATILE = 266,
     RESTRICT = 267,
     FORALL = 268,
     LVALUE = 269,
     VOID = 270,
     CHAR = 271,
     SHORT = 272,
     INT = 273,
     LONG = 274,
     FLOAT = 275,
     DOUBLE = 276,
     SIGNED = 277,
     UNSIGNED = 278,
     ZERO_T = 279,
     ONE_T = 280,
     VALIST = 281,
     BOOL = 282,
     COMPLEX = 283,
     IMAGINARY = 284,
     TYPEOF = 285,
     LABEL = 286,
     ENUM = 287,
     STRUCT = 288,
     UNION = 289,
     OTYPE = 290,
     FTYPE = 291,
     DTYPE = 292,
     TTYPE = 293,
     TRAIT = 294,
     SIZEOF = 295,
     OFFSETOF = 296,
     ATTRIBUTE = 297,
     EXTENSION = 298,
     IF = 299,
     ELSE = 300,
     SWITCH = 301,
     CASE = 302,
     DEFAULT = 303,
     DO = 304,
     WHILE = 305,
     FOR = 306,
     BREAK = 307,
     CONTINUE = 308,
     GOTO = 309,
     RETURN = 310,
     CHOOSE = 311,
     DISABLE = 312,
     ENABLE = 313,
     FALLTHRU = 314,
     TRY = 315,
     CATCH = 316,
     CATCHRESUME = 317,
     FINALLY = 318,
     THROW = 319,
     THROWRESUME = 320,
     AT = 321,
     ASM = 322,
     ALIGNAS = 323,
     ALIGNOF = 324,
     ATOMIC = 325,
     GENERIC = 326,
     NORETURN = 327,
     STATICASSERT = 328,
     THREADLOCAL = 329,
     IDENTIFIER = 330,
     QUOTED_IDENTIFIER = 331,
     TYPEDEFname = 332,
     TYPEGENname = 333,
     ATTR_IDENTIFIER = 334,
     ATTR_TYPEDEFname = 335,
     ATTR_TYPEGENname = 336,
     INTEGERconstant = 337,
     CHARACTERconstant = 338,
     STRINGliteral = 339,
     REALDECIMALconstant = 340,
     REALFRACTIONconstant = 341,
     FLOATINGconstant = 342,
     ZERO = 343,
     ONE = 344,
     ARROW = 345,
     ICR = 346,
     DECR = 347,
     LS = 348,
     RS = 349,
     LE = 350,
     GE = 351,
     EQ = 352,
     NE = 353,
     ANDAND = 354,
     OROR = 355,
     ELLIPSIS = 356,
     MULTassign = 357,
     DIVassign = 358,
     MODassign = 359,
     PLUSassign = 360,
     MINUSassign = 361,
     LSassign = 362,
     RSassign = 363,
     ANDassign = 364,
     ERassign = 365,
     ORassign = 366,
     ATassign = 367,
     THEN = 368
   };
#endif
/* Tokens.  */
#define TYPEDEF 258
#define AUTO 259
#define EXTERN 260
#define REGISTER 261
#define STATIC 262
#define INLINE 263
#define FORTRAN 264
#define CONST 265
#define VOLATILE 266
#define RESTRICT 267
#define FORALL 268
#define LVALUE 269
#define VOID 270
#define CHAR 271
#define SHORT 272
#define INT 273
#define LONG 274
#define FLOAT 275
#define DOUBLE 276
#define SIGNED 277
#define UNSIGNED 278
#define ZERO_T 279
#define ONE_T 280
#define VALIST 281
#define BOOL 282
#define COMPLEX 283
#define IMAGINARY 284
#define TYPEOF 285
#define LABEL 286
#define ENUM 287
#define STRUCT 288
#define UNION 289
#define OTYPE 290
#define FTYPE 291
#define DTYPE 292
#define TTYPE 293
#define TRAIT 294
#define SIZEOF 295
#define OFFSETOF 296
#define ATTRIBUTE 297
#define EXTENSION 298
#define IF 299
#define ELSE 300
#define SWITCH 301
#define CASE 302
#define DEFAULT 303
#define DO 304
#define WHILE 305
#define FOR 306
#define BREAK 307
#define CONTINUE 308
#define GOTO 309
#define RETURN 310
#define CHOOSE 311
#define DISABLE 312
#define ENABLE 313
#define FALLTHRU 314
#define TRY 315
#define CATCH 316
#define CATCHRESUME 317
#define FINALLY 318
#define THROW 319
#define THROWRESUME 320
#define AT 321
#define ASM 322
#define ALIGNAS 323
#define ALIGNOF 324
#define ATOMIC 325
#define GENERIC 326
#define NORETURN 327
#define STATICASSERT 328
#define THREADLOCAL 329
#define IDENTIFIER 330
#define QUOTED_IDENTIFIER 331
#define TYPEDEFname 332
#define TYPEGENname 333
#define ATTR_IDENTIFIER 334
#define ATTR_TYPEDEFname 335
#define ATTR_TYPEGENname 336
#define INTEGERconstant 337
#define CHARACTERconstant 338
#define STRINGliteral 339
#define REALDECIMALconstant 340
#define REALFRACTIONconstant 341
#define FLOATINGconstant 342
#define ZERO 343
#define ONE 344
#define ARROW 345
#define ICR 346
#define DECR 347
#define LS 348
#define RS 349
#define LE 350
#define GE 351
#define EQ 352
#define NE 353
#define ANDAND 354
#define OROR 355
#define ELLIPSIS 356
#define MULTassign 357
#define DIVassign 358
#define MODassign 359
#define PLUSassign 360
#define MINUSassign 361
#define LSassign 362
#define RSassign 363
#define ANDassign 364
#define ERassign 365
#define ORassign 366
#define ATassign 367
#define THEN 368




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 139 "parser.yy"

	Token tok;
	ParseNode * pn;
	ExpressionNode * en;
	DeclarationNode * decl;
	DeclarationNode::Aggregate aggKey;
	DeclarationNode::TypeClass tclass;
	StatementNode * sn;
	ConstantExpr * constant;
	ForCtl * fctl;
	LabelNode * label;
	InitializerNode * in;
	OperKinds op;
	std::string * str;
	bool flag;



/* Line 293 of yacc.c  */
#line 400 "Parser/parser.cc"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 412 "Parser/parser.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  240
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   11898

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  138
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  249
/* YYNRULES -- Number of rules.  */
#define YYNRULES  775
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1582

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   368

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   126,     2,     2,     2,   129,   123,     2,
     114,   115,   122,   124,   121,   125,   118,   128,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   135,   137,
     130,   136,   131,   134,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   116,     2,   117,   132,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   119,   133,   120,   127,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     5,     7,     9,    11,    13,    15,
      17,    19,    21,    23,    25,    27,    29,    31,    33,    35,
      37,    40,    42,    44,    46,    50,    54,    56,    63,    68,
      72,    80,    83,    87,    95,    98,   101,   109,   114,   116,
     120,   121,   123,   125,   129,   131,   134,   141,   145,   153,
     157,   165,   168,   171,   174,   175,   178,   180,   182,   184,
     187,   190,   193,   196,   199,   202,   207,   210,   215,   222,
     224,   229,   234,   236,   238,   240,   242,   244,   246,   248,
     253,   255,   259,   263,   267,   269,   273,   277,   279,   283,
     287,   289,   293,   297,   301,   305,   307,   311,   315,   317,
     321,   323,   327,   329,   333,   335,   339,   341,   345,   347,
     353,   358,   360,   362,   366,   367,   369,   371,   373,   375,
     377,   379,   381,   383,   385,   387,   389,   391,   393,   400,
     408,   410,   414,   416,   420,   421,   423,   425,   427,   429,
     431,   433,   435,   437,   439,   446,   451,   454,   462,   464,
     468,   470,   473,   475,   478,   481,   483,   486,   489,   495,
     503,   509,   519,   525,   535,   537,   541,   543,   545,   549,
     553,   556,   558,   561,   564,   565,   567,   570,   574,   575,
     577,   580,   584,   588,   593,   594,   596,   598,   601,   607,
     615,   622,   629,   634,   638,   643,   646,   650,   653,   657,
     661,   665,   669,   675,   679,   683,   688,   690,   696,   703,
     709,   716,   726,   737,   747,   758,   761,   763,   766,   769,
     772,   774,   781,   790,   801,   814,   829,   830,   832,   833,
     835,   837,   841,   846,   854,   855,   857,   861,   863,   867,
     869,   871,   873,   877,   879,   881,   883,   887,   888,   890,
     894,   899,   901,   905,   907,   909,   913,   917,   921,   925,
     929,   932,   936,   943,   947,   951,   956,   958,   961,   964,
     968,   974,   982,   990,   996,  1006,  1009,  1012,  1018,  1022,
    1028,  1033,  1037,  1042,  1047,  1055,  1060,  1064,  1068,  1072,
    1076,  1083,  1085,  1087,  1089,  1091,  1093,  1095,  1097,  1099,
    1101,  1103,  1105,  1107,  1109,  1111,  1113,  1115,  1116,  1118,
    1120,  1123,  1125,  1127,  1129,  1131,  1133,  1135,  1137,  1138,
    1144,  1146,  1149,  1153,  1155,  1158,  1160,  1162,  1164,  1166,
    1168,  1170,  1172,  1174,  1176,  1178,  1180,  1182,  1184,  1186,
    1188,  1190,  1192,  1194,  1196,  1198,  1200,  1202,  1204,  1206,
    1209,  1212,  1216,  1220,  1222,  1226,  1228,  1231,  1234,  1237,
    1242,  1247,  1252,  1257,  1259,  1262,  1265,  1269,  1271,  1274,
    1277,  1279,  1282,  1285,  1289,  1291,  1294,  1297,  1299,  1302,
    1305,  1309,  1311,  1314,  1317,  1319,  1321,  1323,  1325,  1331,
    1332,  1340,  1349,  1351,  1355,  1359,  1361,  1363,  1364,  1367,
    1370,  1374,  1378,  1383,  1385,  1388,  1392,  1395,  1397,  1402,
    1403,  1405,  1408,  1411,  1413,  1414,  1416,  1419,  1426,  1427,
    1436,  1438,  1442,  1445,  1450,  1451,  1454,  1455,  1457,  1459,
    1461,  1467,  1473,  1479,  1481,  1487,  1493,  1503,  1505,  1511,
    1512,  1514,  1516,  1522,  1524,  1526,  1532,  1538,  1540,  1544,
    1548,  1553,  1555,  1557,  1559,  1561,  1564,  1566,  1570,  1574,
    1577,  1581,  1583,  1587,  1589,  1591,  1593,  1595,  1597,  1599,
    1601,  1603,  1605,  1607,  1609,  1612,  1614,  1616,  1617,  1620,
    1623,  1625,  1630,  1631,  1633,  1636,  1640,  1645,  1648,  1651,
    1653,  1656,  1659,  1665,  1671,  1679,  1686,  1688,  1691,  1694,
    1698,  1700,  1703,  1706,  1711,  1714,  1719,  1720,  1725,  1728,
    1730,  1732,  1734,  1736,  1737,  1740,  1746,  1752,  1766,  1768,
    1770,  1774,  1778,  1781,  1785,  1789,  1792,  1797,  1799,  1806,
    1816,  1817,  1829,  1831,  1835,  1839,  1843,  1845,  1847,  1853,
    1856,  1862,  1863,  1865,  1867,  1871,  1872,  1874,  1876,  1878,
    1884,  1885,  1892,  1895,  1897,  1900,  1905,  1908,  1912,  1916,
    1920,  1925,  1931,  1937,  1943,  1950,  1952,  1954,  1956,  1960,
    1961,  1967,  1968,  1970,  1972,  1975,  1982,  1984,  1988,  1989,
    1991,  1996,  1998,  2000,  2002,  2004,  2007,  2009,  2012,  2015,
    2017,  2021,  2024,  2028,  2033,  2036,  2041,  2046,  2050,  2059,
    2063,  2066,  2068,  2071,  2078,  2087,  2091,  2094,  2098,  2102,
    2107,  2112,  2116,  2118,  2120,  2122,  2127,  2136,  2140,  2143,
    2147,  2151,  2156,  2161,  2165,  2168,  2170,  2173,  2176,  2178,
    2182,  2185,  2189,  2194,  2197,  2202,  2207,  2211,  2218,  2227,
    2231,  2234,  2236,  2239,  2242,  2245,  2249,  2254,  2257,  2262,
    2267,  2271,  2278,  2287,  2291,  2294,  2296,  2299,  2302,  2304,
    2306,  2309,  2313,  2318,  2321,  2326,  2333,  2342,  2344,  2347,
    2350,  2352,  2355,  2358,  2362,  2367,  2369,  2374,  2379,  2383,
    2389,  2398,  2402,  2405,  2409,  2411,  2417,  2423,  2430,  2437,
    2439,  2442,  2445,  2447,  2450,  2453,  2457,  2462,  2464,  2469,
    2474,  2478,  2484,  2493,  2497,  2499,  2502,  2504,  2507,  2514,
    2520,  2527,  2535,  2543,  2545,  2548,  2551,  2553,  2556,  2559,
    2563,  2568,  2570,  2575,  2580,  2584,  2593,  2597,  2599,  2601,
    2604,  2606,  2608,  2611,  2615,  2618,  2622,  2625,  2629,  2633,
    2636,  2641,  2645,  2648,  2652,  2655,  2660,  2664,  2667,  2674,
    2681,  2688,  2696,  2698,  2701,  2703,  2705,  2707,  2710,  2714,
    2717,  2721,  2724,  2728,  2732,  2737,  2740,  2744,  2749,  2752,
    2758,  2765,  2772,  2773,  2775,  2776
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     315,     0,    -1,    -1,    -1,    82,    -1,    85,    -1,    86,
      -1,    87,    -1,    83,    -1,    75,    -1,    79,    -1,   145,
      -1,    75,    -1,    79,    -1,    75,    -1,   145,    -1,    88,
      -1,    89,    -1,   147,    -1,    84,    -1,   147,    84,    -1,
      75,    -1,   145,    -1,   175,    -1,   114,   177,   115,    -1,
     114,   181,   115,    -1,   148,    -1,   149,   116,   139,   172,
     140,   117,    -1,   149,   114,   150,   115,    -1,   149,   118,
     144,    -1,   149,   118,   116,   139,   152,   140,   117,    -1,
     149,    86,    -1,   149,    90,   144,    -1,   149,    90,   116,
     139,   152,   140,   117,    -1,   149,    91,    -1,   149,    92,
      -1,   114,   288,   115,   119,   292,   385,   120,    -1,   149,
     119,   150,   120,    -1,   151,    -1,   150,   121,   151,    -1,
      -1,   172,    -1,   153,    -1,   152,   121,   153,    -1,   154,
      -1,    85,   153,    -1,    85,   116,   139,   152,   140,   117,
      -1,   154,   118,   153,    -1,   154,   118,   116,   139,   152,
     140,   117,    -1,   154,    90,   153,    -1,   154,    90,   116,
     139,   152,   140,   117,    -1,    82,   155,    -1,    87,   155,
      -1,   144,   155,    -1,    -1,   155,    86,    -1,   149,    -1,
     141,    -1,   146,    -1,    43,   159,    -1,   157,   159,    -1,
     158,   159,    -1,    91,   156,    -1,    92,   156,    -1,    40,
     156,    -1,    40,   114,   288,   115,    -1,    69,   156,    -1,
      69,   114,   288,   115,    -1,    41,   114,   288,   121,   144,
     115,    -1,    79,    -1,    79,   114,   151,   115,    -1,    79,
     114,   289,   115,    -1,   122,    -1,   123,    -1,   124,    -1,
     125,    -1,   126,    -1,   127,    -1,   156,    -1,   114,   288,
     115,   159,    -1,   159,    -1,   160,   122,   159,    -1,   160,
     128,   159,    -1,   160,   129,   159,    -1,   160,    -1,   161,
     124,   160,    -1,   161,   125,   160,    -1,   161,    -1,   162,
      93,   161,    -1,   162,    94,   161,    -1,   162,    -1,   163,
     130,   162,    -1,   163,   131,   162,    -1,   163,    95,   162,
      -1,   163,    96,   162,    -1,   163,    -1,   164,    97,   163,
      -1,   164,    98,   163,    -1,   164,    -1,   165,   123,   164,
      -1,   165,    -1,   166,   132,   165,    -1,   166,    -1,   167,
     133,   166,    -1,   167,    -1,   168,    99,   167,    -1,   168,
      -1,   169,   100,   168,    -1,   169,    -1,   169,   134,   177,
     135,   170,    -1,   169,   134,   135,   170,    -1,   170,    -1,
     170,    -1,   156,   174,   172,    -1,    -1,   172,    -1,   136,
      -1,   112,    -1,   102,    -1,   103,    -1,   104,    -1,   105,
      -1,   106,    -1,   107,    -1,   108,    -1,   109,    -1,   110,
      -1,   111,    -1,   116,   139,   121,   176,   140,   117,    -1,
     116,   139,   172,   121,   176,   140,   117,    -1,   173,    -1,
     176,   121,   173,    -1,   172,    -1,   177,   121,   172,    -1,
      -1,   177,    -1,   180,    -1,   181,    -1,   185,    -1,   186,
      -1,   198,    -1,   200,    -1,   201,    -1,   206,    -1,   132,
     149,   119,   150,   120,   137,    -1,   285,   135,   325,   179,
      -1,   119,   120,    -1,   119,   139,   139,   217,   182,   140,
     120,    -1,   183,    -1,   182,   139,   183,    -1,   220,    -1,
      43,   220,    -1,   321,    -1,    43,   321,    -1,   179,   140,
      -1,   179,    -1,   184,   179,    -1,   178,   137,    -1,    44,
     114,   177,   115,   179,    -1,    44,   114,   177,   115,   179,
      45,   179,    -1,    46,   114,   177,   115,   191,    -1,    46,
     114,   177,   115,   119,   139,   213,   192,   120,    -1,    56,
     114,   177,   115,   191,    -1,    56,   114,   177,   115,   119,
     139,   213,   194,   120,    -1,   171,    -1,   171,   101,   171,
      -1,   323,    -1,   187,    -1,   188,   121,   187,    -1,    47,
     188,   135,    -1,    48,   135,    -1,   189,    -1,   190,   189,
      -1,   190,   179,    -1,    -1,   193,    -1,   190,   184,    -1,
     193,   190,   184,    -1,    -1,   195,    -1,   190,   197,    -1,
     190,   184,   196,    -1,   195,   190,   197,    -1,   195,   190,
     184,   196,    -1,    -1,   197,    -1,    59,    -1,    59,   137,
      -1,    50,   114,   177,   115,   179,    -1,    49,   179,    50,
     114,   177,   115,   137,    -1,    51,   114,   139,   199,   115,
     179,    -1,   178,   140,   137,   178,   137,   178,    -1,   220,
     178,   137,   178,    -1,    54,   285,   137,    -1,    54,   122,
     177,   137,    -1,    53,   137,    -1,    53,   285,   137,    -1,
      52,   137,    -1,    52,   285,   137,    -1,    55,   178,   137,
      -1,    64,   173,   137,    -1,    65,   173,   137,    -1,    65,
     173,    66,   172,   137,    -1,    60,   181,   202,    -1,    60,
     181,   204,    -1,    60,   181,   202,   204,    -1,   203,    -1,
      61,   114,   101,   115,   181,    -1,   203,    61,   114,   101,
     115,   181,    -1,    62,   114,   101,   115,   181,    -1,   203,
      62,   114,   101,   115,   181,    -1,    61,   114,   139,   139,
     205,   140,   115,   181,   140,    -1,   203,    61,   114,   139,
     139,   205,   140,   115,   181,   140,    -1,    62,   114,   139,
     139,   205,   140,   115,   181,   140,    -1,   203,    62,   114,
     139,   139,   205,   140,   115,   181,   140,    -1,    63,   181,
      -1,   235,    -1,   235,   322,    -1,   235,   370,    -1,   379,
     144,    -1,   379,    -1,    67,   207,   114,   146,   115,   137,
      -1,    67,   207,   114,   146,   135,   208,   115,   137,    -1,
      67,   207,   114,   146,   135,   208,   135,   208,   115,   137,
      -1,    67,   207,   114,   146,   135,   208,   135,   208,   135,
     211,   115,   137,    -1,    67,   207,    54,   114,   146,   135,
     135,   208,   135,   211,   135,   212,   115,   137,    -1,    -1,
      11,    -1,    -1,   209,    -1,   210,    -1,   209,   121,   210,
      -1,   146,   114,   171,   115,    -1,   116,   171,   117,   146,
     114,   171,   115,    -1,    -1,   146,    -1,   211,   121,   146,
      -1,   144,    -1,   212,   121,   144,    -1,   140,    -1,   214,
      -1,   220,    -1,   214,   139,   220,    -1,   140,    -1,   216,
      -1,   230,    -1,   216,   139,   230,    -1,    -1,   218,    -1,
      31,   219,   137,    -1,   218,    31,   219,   137,    -1,   287,
      -1,   219,   121,   287,    -1,   221,    -1,   230,    -1,   222,
     140,   137,    -1,   227,   140,   137,    -1,   224,   140,   137,
      -1,   306,   140,   137,    -1,   309,   140,   137,    -1,   223,
     290,    -1,   241,   223,   290,    -1,   222,   140,   121,   139,
     285,   290,    -1,   380,   285,   324,    -1,   383,   285,   324,
      -1,   237,   383,   285,   324,    -1,   225,    -1,   237,   225,
      -1,   241,   225,    -1,   241,   237,   225,    -1,   224,   140,
     121,   139,   285,    -1,   383,   285,   114,   139,   273,   140,
     115,    -1,   226,   285,   114,   139,   273,   140,   115,    -1,
     116,   139,   275,   140,   117,    -1,   116,   139,   275,   140,
     121,   139,   276,   140,   117,    -1,     3,   223,    -1,     3,
     225,    -1,   227,   140,   121,   139,   144,    -1,     3,   234,
     322,    -1,   228,   140,   121,   139,   322,    -1,   237,     3,
     234,   322,    -1,   234,     3,   322,    -1,   234,     3,   237,
     322,    -1,     3,   144,   136,   172,    -1,   229,   140,   121,
     139,   144,   136,   172,    -1,   232,   231,   140,   137,    -1,
     228,   140,   137,    -1,   229,   140,   137,    -1,   249,   140,
     137,    -1,   322,   324,   290,    -1,   231,   121,   325,   322,
     324,   290,    -1,   245,    -1,   249,    -1,   253,    -1,   296,
      -1,   245,    -1,   251,    -1,   253,    -1,   296,    -1,   246,
      -1,   250,    -1,   254,    -1,   297,    -1,   246,    -1,   252,
      -1,   254,    -1,   297,    -1,    -1,   237,    -1,   238,    -1,
     237,   238,    -1,   239,    -1,   327,    -1,    10,    -1,    12,
      -1,    11,    -1,    14,    -1,    70,    -1,    -1,    13,   114,
     240,   299,   115,    -1,   242,    -1,   237,   242,    -1,   241,
     237,   242,    -1,   243,    -1,   242,   243,    -1,     5,    -1,
       7,    -1,     4,    -1,     6,    -1,    74,    -1,     8,    -1,
       9,    -1,    72,    -1,    16,    -1,    21,    -1,    20,    -1,
      18,    -1,    19,    -1,    17,    -1,    22,    -1,    23,    -1,
      15,    -1,    27,    -1,    28,    -1,    29,    -1,    26,    -1,
      24,    -1,    25,    -1,   246,    -1,   241,   246,    -1,   245,
     243,    -1,   245,   243,   237,    -1,   245,   243,   246,    -1,
     247,    -1,   236,   248,   236,    -1,   244,    -1,   237,   244,
      -1,   247,   238,    -1,   247,   244,    -1,    30,   114,   289,
     115,    -1,    30,   114,   177,   115,    -1,    81,   114,   289,
     115,    -1,    81,   114,   177,   115,    -1,   250,    -1,   241,
     250,    -1,   249,   243,    -1,   249,   243,   237,    -1,   255,
      -1,   237,   255,    -1,   250,   238,    -1,   252,    -1,   241,
     252,    -1,   251,   243,    -1,   251,   243,   237,    -1,   256,
      -1,   237,   256,    -1,   252,   238,    -1,   254,    -1,   241,
     254,    -1,   253,   243,    -1,   253,   243,   237,    -1,    77,
      -1,   237,    77,    -1,   254,   238,    -1,   257,    -1,   268,
      -1,   259,    -1,   270,    -1,   260,   325,   119,   261,   120,
      -1,    -1,   260,   325,   287,   258,   119,   261,   120,    -1,
     260,   325,   114,   305,   115,   119,   261,   120,    -1,   259,
      -1,   260,   325,   287,    -1,   260,   325,   298,    -1,    33,
      -1,    34,    -1,    -1,   261,   262,    -1,   263,   137,    -1,
      43,   263,   137,    -1,   234,   264,   137,    -1,    43,   234,
     264,   137,    -1,   379,    -1,   379,   287,    -1,   263,   121,
     287,    -1,   263,   121,    -1,   265,    -1,   264,   121,   325,
     265,    -1,    -1,   267,    -1,   331,   266,    -1,   344,   266,
      -1,   370,    -1,    -1,   267,    -1,   135,   171,    -1,    32,
     325,   119,   271,   385,   120,    -1,    -1,    32,   325,   287,
     269,   119,   271,   385,   120,    -1,   270,    -1,    32,   325,
     287,    -1,   287,   272,    -1,   271,   121,   287,   272,    -1,
      -1,   136,   171,    -1,    -1,   274,    -1,   276,    -1,   275,
      -1,   275,   140,   121,   139,   276,    -1,   276,   140,   121,
     139,   101,    -1,   275,   140,   121,   139,   101,    -1,   280,
      -1,   276,   140,   121,   139,   280,    -1,   275,   140,   121,
     139,   280,    -1,   275,   140,   121,   139,   276,   140,   121,
     139,   280,    -1,   281,    -1,   276,   140,   121,   139,   281,
      -1,    -1,   278,    -1,   279,    -1,   279,   140,   121,   139,
     101,    -1,   283,    -1,   282,    -1,   279,   140,   121,   139,
     283,    -1,   279,   140,   121,   139,   282,    -1,   282,    -1,
     375,   285,   386,    -1,   383,   285,   386,    -1,   237,   383,
     285,   386,    -1,   225,    -1,   283,    -1,   375,    -1,   383,
      -1,   237,   383,    -1,   384,    -1,   233,   349,   386,    -1,
     233,   353,   386,    -1,   233,   386,    -1,   233,   364,   386,
      -1,   144,    -1,   284,   121,   144,    -1,   142,    -1,    77,
      -1,    78,    -1,   143,    -1,    77,    -1,    78,    -1,   144,
      -1,    77,    -1,    78,    -1,   379,    -1,   234,    -1,   234,
     358,    -1,   288,    -1,   384,    -1,    -1,   136,   291,    -1,
     112,   291,    -1,   172,    -1,   119,   292,   385,   120,    -1,
      -1,   291,    -1,   293,   291,    -1,   292,   121,   291,    -1,
     292,   121,   293,   291,    -1,   294,   135,    -1,   287,   135,
      -1,   295,    -1,   294,   295,    -1,   118,   287,    -1,   116,
     139,   172,   140,   117,    -1,   116,   139,   323,   140,   117,
      -1,   116,   139,   171,   101,   171,   140,   117,    -1,   118,
     116,   139,   152,   140,   117,    -1,   297,    -1,   241,   297,
      -1,   296,   243,    -1,   296,   243,   237,    -1,   298,    -1,
     237,   298,    -1,   297,   238,    -1,    78,   114,   305,   115,
      -1,   300,   386,    -1,   299,   121,   300,   386,    -1,    -1,
     302,   287,   301,   303,    -1,   234,   349,    -1,    35,    -1,
      37,    -1,    36,    -1,    38,    -1,    -1,   303,   304,    -1,
     133,   287,   114,   305,   115,    -1,   133,   119,   139,   311,
     120,    -1,   133,   114,   139,   299,   140,   115,   119,   139,
     311,   120,   114,   305,   115,    -1,   289,    -1,   172,    -1,
     305,   121,   289,    -1,   305,   121,   172,    -1,    35,   307,
      -1,   242,    35,   307,    -1,   306,   121,   307,    -1,   308,
     303,    -1,   308,   303,   136,   289,    -1,   287,    -1,   286,
     114,   139,   299,   140,   115,    -1,    39,   287,   114,   139,
     299,   140,   115,   119,   120,    -1,    -1,    39,   287,   114,
     139,   299,   140,   115,   119,   310,   311,   120,    -1,   312,
      -1,   311,   139,   312,    -1,   313,   140,   137,    -1,   314,
     140,   137,    -1,   223,    -1,   225,    -1,   313,   140,   121,
     139,   285,    -1,   234,   322,    -1,   314,   140,   121,   139,
     322,    -1,    -1,   316,    -1,   318,    -1,   316,   139,   318,
      -1,    -1,   316,    -1,   220,    -1,   320,    -1,    67,   114,
     146,   115,   137,    -1,    -1,     5,    84,   319,   119,   317,
     120,    -1,    43,   318,    -1,   321,    -1,   336,   181,    -1,
     340,   139,   215,   181,    -1,   224,   181,    -1,   232,   336,
     181,    -1,   237,   336,   181,    -1,   241,   336,   181,    -1,
     241,   237,   336,   181,    -1,   232,   340,   139,   215,   181,
      -1,   237,   340,   139,   215,   181,    -1,   241,   340,   139,
     215,   181,    -1,   241,   237,   340,   139,   215,   181,    -1,
     331,    -1,   344,    -1,   336,    -1,   171,   127,   171,    -1,
      -1,    67,   114,   146,   115,   325,    -1,    -1,   326,    -1,
     327,    -1,   326,   327,    -1,    42,   114,   114,   328,   115,
     115,    -1,   329,    -1,   328,   121,   329,    -1,    -1,   330,
      -1,   330,   114,   150,   115,    -1,    75,    -1,    77,    -1,
      78,    -1,    10,    -1,   332,   325,    -1,   333,    -1,   334,
     325,    -1,   335,   325,    -1,   142,    -1,   114,   332,   115,
      -1,   157,   331,    -1,   157,   237,   331,    -1,   114,   333,
     115,   325,    -1,   332,   362,    -1,   114,   333,   115,   362,
      -1,   114,   334,   115,   363,    -1,   114,   334,   115,    -1,
     114,   333,   115,   114,   139,   277,   140,   115,    -1,   114,
     335,   115,    -1,   337,   325,    -1,   338,    -1,   339,   325,
      -1,   332,   114,   139,   277,   140,   115,    -1,   114,   338,
     115,   114,   139,   277,   140,   115,    -1,   114,   337,   115,
      -1,   157,   336,    -1,   157,   237,   336,    -1,   114,   338,
     115,    -1,   114,   338,   115,   362,    -1,   114,   339,   115,
     363,    -1,   114,   339,   115,    -1,   341,    -1,   342,    -1,
     343,    -1,   332,   114,   284,   115,    -1,   114,   342,   115,
     114,   139,   277,   140,   115,    -1,   114,   341,   115,    -1,
     157,   340,    -1,   157,   237,   340,    -1,   114,   342,   115,
      -1,   114,   342,   115,   362,    -1,   114,   343,   115,   363,
      -1,   114,   343,   115,    -1,   345,   325,    -1,   346,    -1,
     347,   325,    -1,   348,   325,    -1,   354,    -1,   114,   345,
     115,    -1,   157,   344,    -1,   157,   237,   344,    -1,   114,
     346,   115,   325,    -1,   345,   362,    -1,   114,   346,   115,
     362,    -1,   114,   347,   115,   363,    -1,   114,   347,   115,
      -1,   345,   114,   139,   277,   140,   115,    -1,   114,   346,
     115,   114,   139,   277,   140,   115,    -1,   114,   348,   115,
      -1,   332,   325,    -1,   350,    -1,   351,   325,    -1,   352,
     325,    -1,   157,   349,    -1,   157,   237,   349,    -1,   114,
     350,   115,   325,    -1,   332,   368,    -1,   114,   350,   115,
     362,    -1,   114,   351,   115,   363,    -1,   114,   351,   115,
      -1,   332,   114,   139,   277,   140,   115,    -1,   114,   350,
     115,   114,   139,   277,   140,   115,    -1,   114,   352,   115,
      -1,   354,   325,    -1,   355,    -1,   356,   325,    -1,   357,
     325,    -1,    77,    -1,    78,    -1,   157,   353,    -1,   157,
     237,   353,    -1,   114,   355,   115,   325,    -1,   354,   368,
      -1,   114,   355,   115,   368,    -1,   354,   114,   139,   277,
     140,   115,    -1,   114,   355,   115,   114,   139,   277,   140,
     115,    -1,   359,    -1,   360,   325,    -1,   361,   325,    -1,
     157,    -1,   157,   237,    -1,   157,   358,    -1,   157,   237,
     358,    -1,   114,   359,   115,   325,    -1,   362,    -1,   114,
     359,   115,   362,    -1,   114,   360,   115,   363,    -1,   114,
     360,   115,    -1,   114,   139,   277,   140,   115,    -1,   114,
     359,   115,   114,   139,   277,   140,   115,    -1,   114,   361,
     115,    -1,   116,   117,    -1,   116,   117,   363,    -1,   363,
      -1,   116,   139,   172,   140,   117,    -1,   116,   139,   122,
     140,   117,    -1,   363,   116,   139,   172,   140,   117,    -1,
     363,   116,   139,   122,   140,   117,    -1,   365,    -1,   366,
     325,    -1,   367,   325,    -1,   157,    -1,   157,   237,    -1,
     157,   364,    -1,   157,   237,   364,    -1,   114,   365,   115,
     325,    -1,   368,    -1,   114,   365,   115,   368,    -1,   114,
     366,   115,   363,    -1,   114,   366,   115,    -1,   114,   139,
     277,   140,   115,    -1,   114,   365,   115,   114,   139,   277,
     140,   115,    -1,   114,   367,   115,    -1,   369,    -1,   369,
     363,    -1,   363,    -1,   116,   117,    -1,   116,   139,   237,
     122,   140,   117,    -1,   116,   139,   237,   140,   117,    -1,
     116,   139,   237,   172,   140,   117,    -1,   116,   139,     7,
     236,   172,   140,   117,    -1,   116,   139,   237,     7,   172,
     140,   117,    -1,   371,    -1,   372,   325,    -1,   373,   325,
      -1,   157,    -1,   157,   237,    -1,   157,   370,    -1,   157,
     237,   370,    -1,   114,   371,   115,   325,    -1,   362,    -1,
     114,   371,   115,   362,    -1,   114,   372,   115,   363,    -1,
     114,   372,   115,    -1,   114,   371,   115,   114,   139,   277,
     140,   115,    -1,   114,   373,   115,    -1,   375,    -1,   383,
      -1,   237,   383,    -1,   376,    -1,   377,    -1,   157,   235,
      -1,   237,   157,   235,    -1,   157,   384,    -1,   237,   157,
     384,    -1,   157,   374,    -1,   237,   157,   374,    -1,   116,
     117,   235,    -1,   378,   235,    -1,   116,   117,   363,   235,
      -1,   378,   363,   235,    -1,   363,   235,    -1,   116,   117,
     376,    -1,   378,   376,    -1,   116,   117,   363,   376,    -1,
     378,   363,   376,    -1,   363,   376,    -1,   116,   139,   237,
     122,   140,   117,    -1,   116,   139,   237,   172,   140,   117,
      -1,   116,   139,   241,   172,   140,   117,    -1,   116,   139,
     241,   237,   172,   140,   117,    -1,   383,    -1,   237,   383,
      -1,   380,    -1,   381,    -1,   382,    -1,   157,   234,    -1,
     237,   157,   234,    -1,   157,   384,    -1,   237,   157,   384,
      -1,   157,   379,    -1,   237,   157,   379,    -1,   116,   117,
     234,    -1,   116,   117,   363,   234,    -1,   363,   234,    -1,
     116,   117,   381,    -1,   116,   117,   363,   381,    -1,   363,
     381,    -1,   116,   139,   276,   140,   117,    -1,   383,   114,
     139,   273,   140,   115,    -1,   226,   114,   139,   273,   140,
     115,    -1,    -1,   121,    -1,    -1,   136,   172,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   326,   326,   330,   337,   338,   339,   340,   341,   345,
     346,   347,   351,   352,   356,   357,   361,   362,   366,   370,
     371,   382,   384,   386,   387,   389,   394,   395,   401,   403,
     405,   407,   409,   411,   413,   415,   417,   419,   428,   429,
     435,   436,   440,   441,   445,   446,   448,   450,   452,   454,
     456,   461,   463,   465,   477,   478,   486,   489,   491,   493,
     498,   511,   513,   515,   517,   519,   521,   523,   525,   527,
     529,   531,   538,   539,   545,   546,   547,   548,   552,   553,
     560,   561,   563,   565,   570,   571,   573,   578,   579,   581,
     586,   587,   589,   591,   593,   598,   599,   601,   606,   607,
     612,   613,   618,   619,   624,   625,   630,   631,   636,   637,
     640,   647,   652,   653,   661,   662,   666,   667,   668,   669,
     670,   671,   672,   673,   674,   675,   676,   677,   687,   689,
     694,   695,   700,   701,   707,   708,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   732,   739,   741,   752,   753,
     758,   760,   765,   767,   772,   776,   777,   782,   787,   790,
     792,   794,   804,   806,   817,   818,   820,   824,   826,   830,
     831,   836,   837,   841,   846,   847,   851,   853,   859,   860,
     864,   866,   868,   870,   876,   877,   881,   883,   888,   890,
     892,   897,   899,   904,   906,   910,   913,   917,   920,   924,
     926,   928,   930,   935,   937,   939,   944,   946,   948,   950,
     952,   957,   959,   961,   963,   968,   976,   977,   982,   984,
     989,   993,   995,   997,   999,  1001,  1007,  1008,  1014,  1015,
    1019,  1020,  1025,  1027,  1033,  1034,  1036,  1042,  1047,  1057,
    1059,  1063,  1064,  1069,  1071,  1075,  1076,  1080,  1082,  1086,
    1087,  1091,  1092,  1096,  1097,  1112,  1113,  1114,  1115,  1116,
    1120,  1125,  1132,  1142,  1147,  1152,  1160,  1165,  1170,  1175,
    1180,  1210,  1215,  1222,  1224,  1231,  1236,  1241,  1252,  1257,
    1262,  1267,  1272,  1281,  1286,  1316,  1320,  1321,  1322,  1328,
    1333,  1341,  1342,  1343,  1344,  1353,  1354,  1355,  1356,  1360,
    1361,  1362,  1363,  1372,  1373,  1374,  1375,  1380,  1381,  1390,
    1391,  1396,  1397,  1401,  1403,  1405,  1407,  1409,  1412,  1411,
    1423,  1424,  1426,  1436,  1437,  1442,  1444,  1446,  1448,  1450,
    1453,  1455,  1457,  1462,  1464,  1466,  1468,  1470,  1472,  1474,
    1476,  1478,  1480,  1482,  1484,  1486,  1488,  1490,  1496,  1497,
    1499,  1501,  1503,  1508,  1509,  1515,  1516,  1518,  1520,  1525,
    1527,  1529,  1531,  1536,  1537,  1539,  1541,  1546,  1547,  1549,
    1554,  1555,  1557,  1559,  1564,  1565,  1567,  1572,  1573,  1575,
    1577,  1582,  1584,  1586,  1591,  1592,  1596,  1597,  1601,  1604,
    1603,  1607,  1609,  1613,  1618,  1623,  1625,  1631,  1632,  1637,
    1638,  1643,  1646,  1654,  1655,  1657,  1659,  1664,  1665,  1671,
    1672,  1674,  1677,  1680,  1685,  1686,  1691,  1696,  1699,  1698,
    1702,  1706,  1714,  1716,  1722,  1723,  1731,  1732,  1736,  1737,
    1738,  1740,  1742,  1749,  1750,  1752,  1754,  1759,  1760,  1766,
    1767,  1771,  1772,  1777,  1778,  1779,  1781,  1789,  1790,  1792,
    1795,  1797,  1801,  1802,  1803,  1805,  1807,  1812,  1817,  1825,
    1827,  1836,  1838,  1843,  1844,  1845,  1849,  1850,  1851,  1855,
    1856,  1857,  1861,  1862,  1863,  1868,  1869,  1874,  1875,  1877,
    1882,  1883,  1888,  1889,  1890,  1891,  1892,  1907,  1908,  1913,
    1914,  1920,  1922,  1925,  1927,  1929,  1952,  1953,  1955,  1957,
    1962,  1963,  1965,  1970,  1975,  1976,  1982,  1981,  1985,  1989,
    1991,  1993,  1995,  2001,  2002,  2007,  2012,  2014,  2019,  2021,
    2022,  2024,  2029,  2031,  2033,  2038,  2040,  2045,  2050,  2058,
    2064,  2063,  2077,  2078,  2083,  2084,  2088,  2093,  2098,  2106,
    2111,  2122,  2123,  2128,  2129,  2135,  2136,  2140,  2141,  2142,
    2147,  2146,  2157,  2165,  2171,  2177,  2186,  2192,  2198,  2204,
    2210,  2218,  2224,  2232,  2238,  2247,  2248,  2249,  2253,  2259,
    2260,  2270,  2271,  2275,  2276,  2281,  2286,  2287,  2293,  2294,
    2296,  2301,  2302,  2303,  2304,  2339,  2341,  2342,  2344,  2349,
    2354,  2359,  2361,  2363,  2368,  2370,  2372,  2374,  2379,  2381,
    2390,  2392,  2393,  2398,  2400,  2402,  2407,  2409,  2411,  2416,
    2418,  2420,  2432,  2433,  2434,  2438,  2440,  2442,  2447,  2449,
    2451,  2456,  2458,  2460,  2475,  2477,  2478,  2480,  2485,  2486,
    2491,  2493,  2495,  2500,  2502,  2504,  2506,  2511,  2513,  2515,
    2525,  2527,  2528,  2530,  2535,  2537,  2539,  2544,  2546,  2548,
    2550,  2555,  2557,  2559,  2572,  2574,  2575,  2577,  2582,  2587,
    2595,  2597,  2599,  2604,  2606,  2611,  2613,  2630,  2631,  2633,
    2638,  2640,  2642,  2644,  2646,  2651,  2652,  2654,  2656,  2661,
    2663,  2665,  2671,  2673,  2675,  2679,  2681,  2683,  2685,  2719,
    2720,  2722,  2727,  2729,  2731,  2733,  2735,  2740,  2741,  2743,
    2745,  2750,  2752,  2754,  2760,  2761,  2763,  2772,  2775,  2777,
    2780,  2782,  2784,  2798,  2799,  2801,  2806,  2808,  2810,  2812,
    2814,  2819,  2820,  2822,  2824,  2829,  2831,  2839,  2840,  2841,
    2846,  2847,  2852,  2854,  2856,  2858,  2860,  2862,  2869,  2871,
    2873,  2875,  2877,  2880,  2882,  2884,  2886,  2888,  2893,  2895,
    2897,  2902,  2928,  2929,  2931,  2935,  2936,  2940,  2942,  2944,
    2946,  2948,  2950,  2957,  2959,  2961,  2963,  2965,  2967,  2972,
    2979,  2981,  2999,  3001,  3006,  3007
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TYPEDEF", "AUTO", "EXTERN", "REGISTER",
  "STATIC", "INLINE", "FORTRAN", "CONST", "VOLATILE", "RESTRICT", "FORALL",
  "LVALUE", "VOID", "CHAR", "SHORT", "INT", "LONG", "FLOAT", "DOUBLE",
  "SIGNED", "UNSIGNED", "ZERO_T", "ONE_T", "VALIST", "BOOL", "COMPLEX",
  "IMAGINARY", "TYPEOF", "LABEL", "ENUM", "STRUCT", "UNION", "OTYPE",
  "FTYPE", "DTYPE", "TTYPE", "TRAIT", "SIZEOF", "OFFSETOF", "ATTRIBUTE",
  "EXTENSION", "IF", "ELSE", "SWITCH", "CASE", "DEFAULT", "DO", "WHILE",
  "FOR", "BREAK", "CONTINUE", "GOTO", "RETURN", "CHOOSE", "DISABLE",
  "ENABLE", "FALLTHRU", "TRY", "CATCH", "CATCHRESUME", "FINALLY", "THROW",
  "THROWRESUME", "AT", "ASM", "ALIGNAS", "ALIGNOF", "ATOMIC", "GENERIC",
  "NORETURN", "STATICASSERT", "THREADLOCAL", "IDENTIFIER",
  "QUOTED_IDENTIFIER", "TYPEDEFname", "TYPEGENname", "ATTR_IDENTIFIER",
  "ATTR_TYPEDEFname", "ATTR_TYPEGENname", "INTEGERconstant",
  "CHARACTERconstant", "STRINGliteral", "REALDECIMALconstant",
  "REALFRACTIONconstant", "FLOATINGconstant", "ZERO", "ONE", "ARROW",
  "ICR", "DECR", "LS", "RS", "LE", "GE", "EQ", "NE", "ANDAND", "OROR",
  "ELLIPSIS", "MULTassign", "DIVassign", "MODassign", "PLUSassign",
  "MINUSassign", "LSassign", "RSassign", "ANDassign", "ERassign",
  "ORassign", "ATassign", "THEN", "'('", "')'", "'['", "']'", "'.'", "'{'",
  "'}'", "','", "'*'", "'&'", "'+'", "'-'", "'!'", "'~'", "'/'", "'%'",
  "'<'", "'>'", "'^'", "'|'", "'?'", "':'", "'='", "';'", "$accept",
  "push", "pop", "constant", "identifier", "no_01_identifier",
  "no_attr_identifier", "zero_one", "string_literal",
  "string_literal_list", "primary_expression", "postfix_expression",
  "argument_expression_list", "argument_expression", "field_list", "field",
  "field_name", "fraction_constants", "unary_expression",
  "ptrref_operator", "unary_operator", "cast_expression",
  "multiplicative_expression", "additive_expression", "shift_expression",
  "relational_expression", "equality_expression", "AND_expression",
  "exclusive_OR_expression", "inclusive_OR_expression",
  "logical_AND_expression", "logical_OR_expression",
  "conditional_expression", "constant_expression", "assignment_expression",
  "assignment_expression_opt", "assignment_operator", "tuple",
  "tuple_expression_list", "comma_expression", "comma_expression_opt",
  "statement", "labeled_statement", "compound_statement",
  "block_item_list", "block_item", "statement_list",
  "expression_statement", "selection_statement", "case_value",
  "case_value_list", "case_label", "case_label_list", "case_clause",
  "switch_clause_list_opt", "switch_clause_list", "choose_clause_list_opt",
  "choose_clause_list", "fall_through_opt", "fall_through",
  "iteration_statement", "for_control_expression", "jump_statement",
  "exception_statement", "handler_list", "handler_clause",
  "finally_clause", "exception_declaration", "asm_statement",
  "asm_volatile_opt", "asm_operands_opt", "asm_operands_list",
  "asm_operand", "asm_clobbers_list_opt", "label_list",
  "declaration_list_opt", "declaration_list", "KR_declaration_list_opt",
  "KR_declaration_list", "local_label_declaration_opt",
  "local_label_declaration_list", "local_label_list", "declaration",
  "cfa_declaration", "cfa_variable_declaration", "cfa_variable_specifier",
  "cfa_function_declaration", "cfa_function_specifier",
  "cfa_function_return", "cfa_typedef_declaration", "typedef_declaration",
  "typedef_expression", "c_declaration", "declaring_list",
  "declaration_specifier", "declaration_specifier_nobody",
  "type_specifier", "type_specifier_nobody", "type_qualifier_list_opt",
  "type_qualifier_list", "type_qualifier", "type_qualifier_name", "$@1",
  "declaration_qualifier_list", "storage_class_list", "storage_class",
  "basic_type_name", "basic_declaration_specifier", "basic_type_specifier",
  "direct_type_name", "indirect_type_name", "sue_declaration_specifier",
  "sue_type_specifier", "sue_declaration_specifier_nobody",
  "sue_type_specifier_nobody", "typedef_declaration_specifier",
  "typedef_type_specifier", "elaborated_type", "elaborated_type_nobody",
  "aggregate_type", "$@2", "aggregate_type_nobody", "aggregate_key",
  "field_declaration_list", "field_declaration",
  "cfa_field_declaring_list", "field_declaring_list", "field_declarator",
  "bit_subrange_size_opt", "bit_subrange_size", "enum_type", "$@3",
  "enum_type_nobody", "enumerator_list", "enumerator_value_opt",
  "cfa_parameter_type_list_opt", "cfa_parameter_type_list",
  "cfa_parameter_list", "cfa_abstract_parameter_list",
  "parameter_type_list_opt", "parameter_type_list", "parameter_list",
  "cfa_parameter_declaration", "cfa_abstract_parameter_declaration",
  "parameter_declaration", "abstract_parameter_declaration",
  "identifier_list", "identifier_or_type_name",
  "no_01_identifier_or_type_name", "no_attr_identifier_or_type_name",
  "type_name_no_function", "type_name", "initializer_opt", "initializer",
  "initializer_list", "designation", "designator_list", "designator",
  "typegen_declaration_specifier", "typegen_type_specifier",
  "typegen_name", "type_parameter_list", "type_parameter", "$@4",
  "type_class", "assertion_list_opt", "assertion", "type_name_list",
  "type_declaring_list", "type_declarator", "type_declarator_name",
  "trait_specifier", "$@5", "trait_declaration_list", "trait_declaration",
  "cfa_trait_declaring_list", "trait_declaring_list", "translation_unit",
  "external_definition_list", "external_definition_list_opt",
  "external_definition", "$@6", "external_function_definition",
  "function_definition", "declarator", "subrange", "asm_name_opt",
  "attribute_list_opt", "attribute_list", "attribute",
  "attribute_name_list", "attribute_name", "attr_name",
  "variable_declarator", "paren_identifier", "variable_ptr",
  "variable_array", "variable_function", "function_declarator",
  "function_no_ptr", "function_ptr", "function_array",
  "KR_function_declarator", "KR_function_no_ptr", "KR_function_ptr",
  "KR_function_array", "variable_type_redeclarator", "paren_type",
  "type_ptr", "type_array", "type_function",
  "identifier_parameter_declarator", "identifier_parameter_ptr",
  "identifier_parameter_array", "identifier_parameter_function",
  "type_parameter_redeclarator", "typedef", "type_parameter_ptr",
  "type_parameter_array", "type_parameter_function", "abstract_declarator",
  "abstract_ptr", "abstract_array", "abstract_function", "array_dimension",
  "multi_array_dimension", "abstract_parameter_declarator",
  "abstract_parameter_ptr", "abstract_parameter_array",
  "abstract_parameter_function", "array_parameter_dimension",
  "array_parameter_1st_dimension", "variable_abstract_declarator",
  "variable_abstract_ptr", "variable_abstract_array",
  "variable_abstract_function",
  "cfa_identifier_parameter_declarator_tuple",
  "cfa_identifier_parameter_declarator_no_tuple",
  "cfa_identifier_parameter_ptr", "cfa_identifier_parameter_array",
  "cfa_array_parameter_1st_dimension", "cfa_abstract_declarator_tuple",
  "cfa_abstract_declarator_no_tuple", "cfa_abstract_ptr",
  "cfa_abstract_array", "cfa_abstract_tuple", "cfa_abstract_function",
  "comma_opt", "assignment_opt", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    40,    41,    91,    93,    46,   123,
     125,    44,    42,    38,    43,    45,    33,   126,    47,    37,
      60,    62,    94,   124,    63,    58,    61,    59
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   138,   139,   140,   141,   141,   141,   141,   141,   142,
     142,   142,   143,   143,   144,   144,   145,   145,   146,   147,
     147,   148,   148,   148,   148,   148,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   150,   150,
     151,   151,   152,   152,   153,   153,   153,   153,   153,   153,
     153,   154,   154,   154,   155,   155,   156,   156,   156,   156,
     156,   156,   156,   156,   156,   156,   156,   156,   156,   156,
     156,   156,   157,   157,   158,   158,   158,   158,   159,   159,
     160,   160,   160,   160,   161,   161,   161,   162,   162,   162,
     163,   163,   163,   163,   163,   164,   164,   164,   165,   165,
     166,   166,   167,   167,   168,   168,   169,   169,   170,   170,
     170,   171,   172,   172,   173,   173,   174,   174,   174,   174,
     174,   174,   174,   174,   174,   174,   174,   174,   175,   175,
     176,   176,   177,   177,   178,   178,   179,   179,   179,   179,
     179,   179,   179,   179,   179,   180,   181,   181,   182,   182,
     183,   183,   183,   183,   183,   184,   184,   185,   186,   186,
     186,   186,   186,   186,   187,   187,   187,   188,   188,   189,
     189,   190,   190,   191,   192,   192,   193,   193,   194,   194,
     195,   195,   195,   195,   196,   196,   197,   197,   198,   198,
     198,   199,   199,   200,   200,   200,   200,   200,   200,   200,
     200,   200,   200,   201,   201,   201,   202,   202,   202,   202,
     202,   203,   203,   203,   203,   204,   205,   205,   205,   205,
     205,   206,   206,   206,   206,   206,   207,   207,   208,   208,
     209,   209,   210,   210,   211,   211,   211,   212,   212,   213,
     213,   214,   214,   215,   215,   216,   216,   217,   217,   218,
     218,   219,   219,   220,   220,   221,   221,   221,   221,   221,
     222,   222,   222,   223,   223,   223,   224,   224,   224,   224,
     224,   225,   225,   226,   226,   227,   227,   227,   228,   228,
     228,   228,   228,   229,   229,   230,   230,   230,   230,   231,
     231,   232,   232,   232,   232,   233,   233,   233,   233,   234,
     234,   234,   234,   235,   235,   235,   235,   236,   236,   237,
     237,   238,   238,   239,   239,   239,   239,   239,   240,   239,
     241,   241,   241,   242,   242,   243,   243,   243,   243,   243,
     243,   243,   243,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   245,   245,
     245,   245,   245,   246,   246,   247,   247,   247,   247,   248,
     248,   248,   248,   249,   249,   249,   249,   250,   250,   250,
     251,   251,   251,   251,   252,   252,   252,   253,   253,   253,
     253,   254,   254,   254,   255,   255,   256,   256,   257,   258,
     257,   257,   257,   259,   259,   260,   260,   261,   261,   262,
     262,   262,   262,   263,   263,   263,   263,   264,   264,   265,
     265,   265,   265,   265,   266,   266,   267,   268,   269,   268,
     268,   270,   271,   271,   272,   272,   273,   273,   274,   274,
     274,   274,   274,   275,   275,   275,   275,   276,   276,   277,
     277,   278,   278,   279,   279,   279,   279,   280,   280,   280,
     280,   280,   281,   281,   281,   281,   281,   282,   282,   283,
     283,   284,   284,   285,   285,   285,   286,   286,   286,   287,
     287,   287,   288,   288,   288,   289,   289,   290,   290,   290,
     291,   291,   292,   292,   292,   292,   292,   293,   293,   294,
     294,   295,   295,   295,   295,   295,   296,   296,   296,   296,
     297,   297,   297,   298,   299,   299,   301,   300,   300,   302,
     302,   302,   302,   303,   303,   304,   304,   304,   305,   305,
     305,   305,   306,   306,   306,   307,   307,   308,   308,   309,
     310,   309,   311,   311,   312,   312,   313,   313,   313,   314,
     314,   315,   315,   316,   316,   317,   317,   318,   318,   318,
     319,   318,   318,   320,   320,   320,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   322,   322,   322,   323,   324,
     324,   325,   325,   326,   326,   327,   328,   328,   329,   329,
     329,   330,   330,   330,   330,   331,   331,   331,   331,   332,
     332,   333,   333,   333,   334,   334,   334,   334,   335,   335,
     336,   336,   336,   337,   337,   337,   338,   338,   338,   339,
     339,   339,   340,   340,   340,   341,   341,   341,   342,   342,
     342,   343,   343,   343,   344,   344,   344,   344,   345,   345,
     346,   346,   346,   347,   347,   347,   347,   348,   348,   348,
     349,   349,   349,   349,   350,   350,   350,   351,   351,   351,
     351,   352,   352,   352,   353,   353,   353,   353,   354,   354,
     355,   355,   355,   356,   356,   357,   357,   358,   358,   358,
     359,   359,   359,   359,   359,   360,   360,   360,   360,   361,
     361,   361,   362,   362,   362,   363,   363,   363,   363,   364,
     364,   364,   365,   365,   365,   365,   365,   366,   366,   366,
     366,   367,   367,   367,   368,   368,   368,   369,   369,   369,
     369,   369,   369,   370,   370,   370,   371,   371,   371,   371,
     371,   372,   372,   372,   372,   373,   373,   374,   374,   374,
     375,   375,   376,   376,   376,   376,   376,   376,   377,   377,
     377,   377,   377,   377,   377,   377,   377,   377,   378,   378,
     378,   378,   379,   379,   379,   380,   380,   381,   381,   381,
     381,   381,   381,   382,   382,   382,   382,   382,   382,   383,
     384,   384,   385,   385,   386,   386
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     3,     3,     1,     6,     4,     3,
       7,     2,     3,     7,     2,     2,     7,     4,     1,     3,
       0,     1,     1,     3,     1,     2,     6,     3,     7,     3,
       7,     2,     2,     2,     0,     2,     1,     1,     1,     2,
       2,     2,     2,     2,     2,     4,     2,     4,     6,     1,
       4,     4,     1,     1,     1,     1,     1,     1,     1,     4,
       1,     3,     3,     3,     1,     3,     3,     1,     3,     3,
       1,     3,     3,     3,     3,     1,     3,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     5,
       4,     1,     1,     3,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     6,     7,
       1,     3,     1,     3,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     6,     4,     2,     7,     1,     3,
       1,     2,     1,     2,     2,     1,     2,     2,     5,     7,
       5,     9,     5,     9,     1,     3,     1,     1,     3,     3,
       2,     1,     2,     2,     0,     1,     2,     3,     0,     1,
       2,     3,     3,     4,     0,     1,     1,     2,     5,     7,
       6,     6,     4,     3,     4,     2,     3,     2,     3,     3,
       3,     3,     5,     3,     3,     4,     1,     5,     6,     5,
       6,     9,    10,     9,    10,     2,     1,     2,     2,     2,
       1,     6,     8,    10,    12,    14,     0,     1,     0,     1,
       1,     3,     4,     7,     0,     1,     3,     1,     3,     1,
       1,     1,     3,     1,     1,     1,     3,     0,     1,     3,
       4,     1,     3,     1,     1,     3,     3,     3,     3,     3,
       2,     3,     6,     3,     3,     4,     1,     2,     2,     3,
       5,     7,     7,     5,     9,     2,     2,     5,     3,     5,
       4,     3,     4,     4,     7,     4,     3,     3,     3,     3,
       6,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     0,     5,
       1,     2,     3,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     3,     3,     1,     3,     1,     2,     2,     2,     4,
       4,     4,     4,     1,     2,     2,     3,     1,     2,     2,
       1,     2,     2,     3,     1,     2,     2,     1,     2,     2,
       3,     1,     2,     2,     1,     1,     1,     1,     5,     0,
       7,     8,     1,     3,     3,     1,     1,     0,     2,     2,
       3,     3,     4,     1,     2,     3,     2,     1,     4,     0,
       1,     2,     2,     1,     0,     1,     2,     6,     0,     8,
       1,     3,     2,     4,     0,     2,     0,     1,     1,     1,
       5,     5,     5,     1,     5,     5,     9,     1,     5,     0,
       1,     1,     5,     1,     1,     5,     5,     1,     3,     3,
       4,     1,     1,     1,     1,     2,     1,     3,     3,     2,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     0,     2,     2,
       1,     4,     0,     1,     2,     3,     4,     2,     2,     1,
       2,     2,     5,     5,     7,     6,     1,     2,     2,     3,
       1,     2,     2,     4,     2,     4,     0,     4,     2,     1,
       1,     1,     1,     0,     2,     5,     5,    13,     1,     1,
       3,     3,     2,     3,     3,     2,     4,     1,     6,     9,
       0,    11,     1,     3,     3,     3,     1,     1,     5,     2,
       5,     0,     1,     1,     3,     0,     1,     1,     1,     5,
       0,     6,     2,     1,     2,     4,     2,     3,     3,     3,
       4,     5,     5,     5,     6,     1,     1,     1,     3,     0,
       5,     0,     1,     1,     2,     6,     1,     3,     0,     1,
       4,     1,     1,     1,     1,     2,     1,     2,     2,     1,
       3,     2,     3,     4,     2,     4,     4,     3,     8,     3,
       2,     1,     2,     6,     8,     3,     2,     3,     3,     4,
       4,     3,     1,     1,     1,     4,     8,     3,     2,     3,
       3,     4,     4,     3,     2,     1,     2,     2,     1,     3,
       2,     3,     4,     2,     4,     4,     3,     6,     8,     3,
       2,     1,     2,     2,     2,     3,     4,     2,     4,     4,
       3,     6,     8,     3,     2,     1,     2,     2,     1,     1,
       2,     3,     4,     2,     4,     6,     8,     1,     2,     2,
       1,     2,     2,     3,     4,     1,     4,     4,     3,     5,
       8,     3,     2,     3,     1,     5,     5,     6,     6,     1,
       2,     2,     1,     2,     2,     3,     4,     1,     4,     4,
       3,     5,     8,     3,     1,     2,     1,     2,     6,     5,
       6,     7,     7,     1,     2,     2,     1,     2,     2,     3,
       4,     1,     4,     4,     3,     8,     3,     1,     1,     2,
       1,     1,     2,     3,     2,     3,     2,     3,     3,     2,
       4,     3,     2,     3,     2,     4,     3,     2,     6,     6,
       6,     7,     1,     2,     1,     1,     1,     2,     3,     2,
       3,     2,     3,     3,     4,     2,     3,     4,     2,     5,
       6,     6,     0,     1,     0,     2
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     307,   307,   327,   325,   328,   326,   330,   331,   313,   315,
     314,     0,   316,   341,   333,   338,   336,   337,   335,   334,
     339,   340,   346,   347,   345,   342,   343,   344,   571,   395,
     396,     0,     0,     0,   307,     0,   317,   332,   329,     9,
     381,     0,    10,    16,    17,     0,     2,    72,    73,   589,
      11,   307,   547,   253,     3,   477,     3,   266,     0,     3,
       3,     3,   254,     0,     0,     0,   308,   309,   311,   307,
     320,   323,   355,   291,   348,   353,   292,   363,   293,   377,
     367,   384,   392,   571,   385,   420,   294,   496,   500,     3,
       3,     0,     2,   543,   548,   553,   312,     0,     0,   571,
     601,   571,     2,   612,   613,   614,   307,     0,   755,   756,
       0,    14,     0,    15,   307,   275,   276,     0,   308,   299,
     300,   301,   302,   550,   318,     0,   572,   573,    14,   470,
     471,    13,   466,   469,     0,   527,   522,   513,   470,   471,
       0,     0,   552,     0,   307,     0,     0,     0,     0,     0,
       0,     0,     0,   307,   307,     0,   757,   308,   606,   618,
     761,   754,   752,   759,     0,     0,     0,   260,     2,     0,
     556,   464,   465,   463,     0,     0,     0,     0,   658,   659,
       0,     0,     3,   569,   565,   571,   586,   571,   571,   567,
       2,   566,   571,   625,   571,   571,   628,     0,     0,     0,
     307,   307,   325,   382,     2,   307,   267,   310,   321,   356,
     368,   501,     0,     2,     0,   477,   268,   308,   349,   364,
     378,   497,     0,     2,     0,   324,   350,   357,   358,     0,
     365,   369,   379,   383,     0,   498,   502,     0,     0,     0,
       1,   307,     2,   554,   600,   602,   307,     2,   765,   308,
     768,   569,   569,     0,   308,     0,     0,   278,   571,   567,
       2,   307,     0,     0,   307,     0,   421,   574,     2,   525,
       2,   578,    19,     0,    18,     0,     0,     0,     0,    21,
      69,     4,     8,     5,     6,     7,     0,     0,   307,     2,
      74,    75,    76,    77,    57,    22,    58,    26,    56,    78,
     307,     0,    80,    84,    87,    90,    95,    98,   100,   102,
     104,   106,   108,   112,   519,    23,   473,   475,   518,     0,
     472,   476,     0,   590,   605,   608,   611,   617,   620,   623,
       2,   763,   307,   766,   571,     2,    72,   307,     3,   451,
       0,   774,   308,   307,   320,   295,   348,   296,   370,   297,
     377,   374,   386,   571,   387,     3,     3,   433,   437,   447,
     452,   298,   496,   307,   453,   730,   731,   307,   454,   456,
       2,   607,   619,   753,     2,     2,   255,     2,   482,     0,
     480,   479,   478,   146,     2,     2,   257,     2,     2,   256,
       2,   286,     2,   287,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   591,   630,   571,     0,     0,   477,     2,
     585,   594,   684,   587,   588,   557,   307,     2,   624,   633,
     626,   627,     0,   281,   307,   307,   354,   308,     0,   308,
     307,   758,   762,   760,   558,   307,   569,   261,   269,   322,
       0,     2,   559,   307,   523,   351,   352,   288,   366,   380,
     471,   307,   397,   393,   394,   499,   524,   258,   259,   544,
     307,   461,     0,   307,   243,     0,     2,   245,     0,   308,
     307,     0,   263,     2,   264,   283,     0,     0,     2,   307,
     569,   307,   509,   511,   510,   512,     0,     0,   774,     0,
     772,   424,     0,   307,     0,   307,   514,   307,   584,   581,
     582,   583,     0,   576,   579,     0,    20,   307,    64,   307,
      78,    59,   307,    66,   307,   307,    62,    63,     2,   132,
       0,     0,     0,   752,   307,    31,     0,    34,    35,    40,
       2,     0,    40,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   117,   116,     0,    60,    61,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     2,   670,   474,
     667,   571,   571,   675,   503,   307,     2,   609,   610,     2,
     621,   622,     0,   764,   767,     0,   307,   307,     0,   732,
     308,   303,   304,   305,   306,   736,   727,   728,   734,     0,
       2,     2,     0,   692,   571,   774,   641,   571,   571,   774,
     571,   655,   571,   571,   706,   774,   689,   571,   571,   697,
     704,   459,   307,   375,   455,   308,   371,   372,   376,     0,
       0,     0,   307,   742,   308,   747,   774,   739,   307,   744,
     774,   307,   307,     0,     0,    21,     2,     0,    22,     0,
     483,   772,     0,     0,   489,   247,     0,   307,     0,     0,
       0,   571,   597,   599,   629,   571,   636,   639,   592,   631,
       0,   285,     0,   289,   682,     0,   307,   282,     0,     0,
       0,     0,   280,     2,     0,   265,   560,   307,     0,     0,
     307,     0,   308,     3,   440,     3,   444,   443,   615,     0,
     555,   307,   308,    72,     3,   307,   774,   308,     3,   453,
     454,     2,     0,     0,     0,   508,   319,   307,   504,   506,
     773,     0,     0,   422,     0,     3,     2,     2,     0,   526,
       3,     0,   578,    40,   549,     0,     2,     0,     0,     0,
      41,     0,     0,   307,    24,     0,    25,     0,   114,     3,
       2,    32,     0,    38,     0,     2,    29,     0,   113,    81,
      82,    83,    85,    86,    88,    89,    93,    94,    91,    92,
      96,    97,    99,   101,   103,   105,   107,     0,     0,   307,
       0,     0,     0,   671,   672,   668,   669,   521,   520,   307,
     307,   421,   738,   307,   743,   308,   307,   686,   729,   685,
       2,   307,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,   775,   693,   644,   660,   694,     2,   640,   647,
     457,   642,   643,   458,     2,   654,   663,   656,   657,   460,
     690,   691,   705,   733,   737,   735,   774,   373,   393,   273,
       2,   769,     2,   448,   741,   746,   449,     3,   427,     3,
       3,     3,   477,     0,     0,     2,   491,   488,   773,     0,
     484,     2,   487,   490,     0,   307,   248,   270,     3,   277,
     279,     0,     2,   593,   595,   596,     2,   632,   634,   635,
     569,     0,   683,   561,     3,   360,   359,   362,   361,   307,
     562,     0,   563,     0,   307,   388,   409,   398,     0,   403,
     397,     0,     0,   462,   246,     0,     0,     3,     2,   692,
     455,     0,   551,     0,   774,   513,   424,   417,   111,   425,
     772,     0,   307,   307,   307,     0,   575,   577,     0,    65,
     307,     0,    67,    70,    71,     0,   133,   482,    79,   115,
     130,     3,   114,     0,    28,    40,     3,     0,    37,   110,
       0,     3,   571,   678,   681,   673,     3,     3,   740,   745,
       2,    72,   307,     3,     3,   308,     0,     3,   571,   650,
     653,   571,   571,   700,   703,   307,     3,   645,   661,   695,
     307,   307,   450,   307,   307,     0,     0,     0,     0,   262,
     111,     0,     3,     3,     0,   485,     0,   481,     0,     0,
     251,   307,     0,     0,   134,     0,     0,     0,     0,     0,
     134,     0,     0,   114,   114,   226,    21,   381,   465,    69,
       0,    22,   135,     0,     3,   136,   137,     2,   148,   138,
     139,   140,   141,   142,   143,   150,     0,   152,     0,     0,
       0,   307,   307,   477,   571,     0,   564,   397,   409,     0,
       0,     0,   716,     0,   407,   410,   414,   571,   414,   721,
     413,   713,   571,   571,   406,   399,   404,   307,   603,     2,
     688,   687,     0,   693,     2,   505,   507,   423,     0,   528,
       3,   536,   537,     0,     2,   532,     3,     3,     0,     0,
     580,     0,   772,   114,     0,     3,    54,     0,    54,    54,
       3,    42,    44,    39,     0,     3,   109,     0,     2,   674,
     676,   677,     0,     0,   307,     0,     0,     0,     3,   571,
       0,     2,   646,   648,   649,     2,   662,   664,     2,   696,
     698,   699,     0,     0,    72,     0,     3,     3,     3,     3,
     435,   434,   438,   771,     2,     2,   770,     0,     0,     0,
       0,     3,   486,     3,     0,   249,   151,   153,     0,     0,
       0,     0,     2,   197,     0,   195,     0,     0,     0,     0,
       0,     0,     0,     0,   227,     0,     0,   157,   154,   307,
       0,   571,     0,   272,   284,     3,     3,   290,   570,   637,
     307,     0,   400,     0,     0,     0,     0,   416,   717,   718,
     571,   401,   411,   415,   412,   714,   715,   405,   390,   307,
     271,   307,   419,     0,   539,   516,   307,     0,     0,   515,
     530,    68,     0,   131,   128,     0,    51,     2,    45,    52,
      53,     0,     0,     0,     0,    27,     0,   679,   307,   604,
     616,   748,   749,   750,     0,   701,   307,   307,   307,     3,
       3,     0,   709,     0,     0,     0,     0,   307,   307,     3,
     568,   492,   493,     0,   252,     0,     0,     0,     0,   307,
     198,   196,     0,   193,   199,     0,     0,     0,     0,   203,
     206,   204,   200,     0,   201,     0,     0,    40,   149,   147,
     134,   250,     0,     0,   391,   402,   571,   724,   726,   719,
     409,   442,   446,   445,     0,   533,     2,   534,     2,   535,
     529,   307,    36,   129,    55,     0,    43,    33,     2,    49,
       2,    47,    30,     3,   751,     3,     3,     3,     0,     0,
     708,   710,   651,   665,   274,     2,   432,     3,   431,     0,
     495,   134,     0,     0,   134,     3,     0,   134,     3,   308,
     307,   194,     0,     2,     2,   215,   205,     0,     0,     0,
       0,     0,     0,   145,   598,   638,     2,   720,   722,   723,
     408,     2,     0,     0,     2,     3,     0,     0,     0,     0,
       0,     0,   711,   712,   307,     0,   494,   158,     0,     0,
       2,   171,   134,   160,     0,   188,     0,   134,     0,   308,
       2,   162,     0,     2,     0,     2,     2,     2,   202,     0,
       0,   228,    37,   307,   307,   538,   540,   531,     0,     3,
       3,   680,   652,   666,   702,   436,   134,   164,   167,     0,
     166,   170,     3,   173,   172,     0,   134,   190,   134,     3,
       0,   307,     0,   307,     0,     2,     0,     2,     0,   221,
       0,     0,     0,   229,   230,   144,     3,     2,    46,     0,
       0,   159,     0,     0,   169,   239,   174,     2,   241,   189,
       0,   192,   178,   207,     3,   216,   308,   220,   209,     3,
       0,   307,     0,   307,   228,     0,     0,     0,   228,     0,
       0,     0,    50,    48,   165,   168,   134,     0,   175,   307,
     134,   134,     0,   179,     0,     0,   716,   217,   218,   219,
       0,   208,     3,   210,     3,     0,     0,     0,   222,     0,
     231,   725,   307,   155,   176,   161,   134,   242,   191,   186,
     184,   180,   163,   134,     0,   717,     0,     0,     0,   234,
       0,   232,     0,   234,     0,   156,   177,   187,   181,   185,
     184,   182,     3,     3,     0,     0,   235,     0,     0,   223,
       0,   517,   183,   211,   213,     3,     3,     0,     0,     0,
       0,   212,   214,   236,   237,     0,   233,   224,     0,     0,
     225,   238
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   801,   464,   294,    49,   132,   133,   295,   296,   274,
     297,   298,   752,   753,  1100,  1101,  1102,  1226,   299,   379,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   991,   519,   940,   545,   315,   941,  1022,
    1023,  1523,  1025,  1026,  1027,  1028,  1524,  1029,  1030,  1428,
    1429,  1391,  1392,  1393,  1497,  1498,  1502,  1503,  1548,  1549,
    1031,  1346,  1032,  1033,  1279,  1280,  1281,  1474,  1034,  1175,
    1452,  1453,  1454,  1557,  1575,  1466,  1467,   465,   466,   865,
     866,   999,    52,    53,    54,    55,    56,   339,   155,    59,
      60,    61,    62,   182,   468,   341,    64,  1475,    65,   254,
      67,    68,   264,   343,   344,    71,    72,   345,   119,    75,
     200,    76,   120,   347,   348,   349,   121,    80,   351,    81,
     691,    82,    83,   690,   897,   898,  1053,  1054,  1202,  1055,
      84,   492,    85,   490,   723,   847,   848,   355,   356,   693,
     694,   695,   357,   358,   696,   360,   462,  1036,   134,   135,
     317,   318,   167,   650,   651,   652,   653,   654,   361,   122,
      88,   487,   488,   915,   489,   269,   496,   319,    89,   136,
     137,    90,  1311,  1084,  1085,  1086,  1087,    91,    92,   712,
      93,   263,    94,    95,   183,   993,   685,   410,   126,    96,
     502,   503,   504,   184,   258,   186,   187,   188,   259,    99,
     100,   101,   102,   103,   104,   105,   191,   192,   193,   194,
     195,   814,   606,   607,   608,   609,   196,   611,   612,   613,
     569,   570,   571,   572,  1059,   106,   615,   616,   617,   618,
     619,   620,  1060,  1061,  1062,  1063,   595,   364,   365,   366,
     367,   320,   161,   108,   109,   110,   369,   721,   621
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1346
static const yytype_int16 yypact[] =
{
    7080, 10336, -1346,    65, -1346, -1346, -1346, -1346, -1346, -1346,
   -1346,    62, -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346,
   -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346,   140, -1346,
   -1346,  1135,  1743,    79,  8505,   107, -1346, -1346, -1346, -1346,
   -1346,   187, -1346, -1346, -1346,  1055,   192, -1346, -1346, -1346,
   -1346, 10182, -1346, -1346, -1346,   118,   227, -1346,  1650, -1346,
   -1346, -1346, -1346,  2245,   362,    74,  8626, -1346, -1346, 10182,
    1874, -1346, -1346,  1963,   424,  3845,  1754,   831,  1963,  1126,
   -1346, -1346, -1346,   140, -1346, -1346,  1963,  1440, -1346,   315,
   -1346,   449,   497, -1346, -1346, -1346, -1346,   340,   227,   140,
   -1346,   140, -1346, -1346, -1346, -1346,  6995,  1650, -1346, -1346,
    1650, -1346,   379, -1346,  9247, -1346, -1346,  2348, 10491, -1346,
     797,   797,   797, -1346, -1346,  1229,   140, -1346,   431,   468,
     505, -1346, -1346, -1346,   517, -1346, -1346, -1346, -1346, -1346,
     536,   569, -1346,   522,  9788,  2012,   153,   486,   556,   589,
     592,   600,   612, 10524,  8132,   576, -1346, 10222, -1346, -1346,
   -1346, -1346,   587, -1346,   216,  3873,  3873, -1346,   616,   454,
   -1346, -1346, -1346, -1346,   636,   467,   478,   540, -1346, -1346,
    2245,  2715,   640,   713, -1346,    42, -1346,   140,   140,   227,
   -1346, -1346,    80, -1346,   140,   140, -1346,  2887,   679,   692,
     797,  7794, -1346, -1346, -1346, 10182, -1346, -1346,  1963, -1346,
   -1346, -1346,   227, -1346,  1650,   118, -1346,  8898, -1346,   797,
     797,   797,   227, -1346,  1135, -1346,  7163, -1346, -1346,   691,
     797, -1346,   797, -1346,   993,   797, -1346,  1135,   700,   717,
   -1346,  8505,   606, -1346, -1346, -1346, 10149, -1346, -1346,  4159,
   -1346,   713,    16,  5182, 10491,  2348,  2887, -1346,    92, -1346,
   -1346,  9247,  1650,   697, 11820,  1743,   800, -1346, -1346,    59,
   -1346,   509, -1346,   765,   838,  5241,   819,  5182,  5622, -1346,
     821, -1346, -1346, -1346, -1346, -1346,  6113,  6113,  9552,   192,
   -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346,  1842,  2541,
    9788,  5182, -1346,   385,   290,   801,   638,   472,   837,   833,
     835,   879,    26, -1346, -1346, -1346,   733, -1346, -1346,   223,
   -1346, -1346,  2012, -1346, -1346,   432,   865, -1346,   659,   865,
   -1346, -1346,  6995, -1346,   140,   874,   876,  9906, -1346, -1346,
     878,  1713,  9333,  7918,  1963,  1963, -1346,  1963,   797,  1963,
     797, -1346, -1346,   140, -1346, -1346, -1346, -1346, -1346, -1346,
   -1346,  1963,   797, 10609,  1650, -1346, -1346, 10642,  1324, -1346,
   -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346,  3398,  5182,
   -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346,
   -1346, -1346, -1346, -1346,   921,   880,   906,   909,   944,   914,
     916,   918,  2715, -1346, -1346,   140,   902,   935,   118,   934,
   -1346, -1346,   949, -1346, -1346, -1346, 10149, -1346, -1346, -1346,
   -1346, -1346,  2887, -1346,  9788,  9788, -1346,   797,  2348,  8042,
    9408, -1346, -1346, -1346, -1346, 10149,    16, -1346, -1346,  1963,
     227, -1346, -1346, 10149, -1346,  7659, -1346, -1346,   797,   797,
     187,  9788, -1346,   954, -1346,   797, -1346, -1346, -1346, -1346,
   10950, -1346,   397, 11485, -1346,   227,   960, -1346,  2348, 11525,
    7794,  6374, -1346, -1346, -1346, -1346,   980,  2887, -1346,  9408,
     713,  7345, -1346, -1346, -1346, -1346,  1499,   420,   951,  1743,
     969,   967,   990, 11820,  1343,  9247, -1346, 11820, -1346, -1346,
   -1346, -1346,   422, -1346,   996,   976, -1346,  9552, -1346, 10682,
   -1346, -1346,  9552, -1346,  9670,  9552, -1346, -1346,   192, -1346,
     452,  1006,  1007, -1346,  7884, -1346,   532, -1346, -1346,  5182,
   -1346,   763,  5182, -1346, -1346, -1346, -1346, -1346, -1346, -1346,
   -1346, -1346, -1346, -1346, -1346,  5182, -1346, -1346,  5182,  5182,
    5182,  5182,  5182,  5182,  5182,  5182,  5182,  5182,  5182,  5182,
    5182,  5182,  5182,  5182,  5182,  5182,  3194,   733,   674, -1346,
   -1346,   140,   140, -1346, -1346,  9788, -1346, -1346,   949, -1346,
   -1346,   949,  6559, -1346, -1346,  1743, 10642,  7884,  1002, -1346,
   10757, -1346,   797,   797,   797, -1346, -1346,   587, -1346,  1011,
     953,  1016,  5182,  2260,   168,   951, -1346,   140,   140,   951,
     211, -1346,   140,   140,   949,   951, -1346,   140,   140, -1346,
     865, -1346, 10797, -1346,  1650, 11676,   797,   797, -1346,  1953,
     266,   729, 10797, -1346,  7263, -1346,   951, -1346, 10609, -1346,
     193,  9018,  9018,  1650,  4710,   989, -1346,   550,  1010,  1012,
   -1346,  1021,  3873,   390, -1346,  1117,  1650,  9018,   606,  2348,
     606,   235,   865, -1346, -1346,   274,   865, -1346, -1346, -1346,
    2348, -1346,   522, -1346,   865,   227, 10950, -1346,   487,  1045,
     620,  1049, -1346,   874,   227, -1346, -1346, 10149,   227,   633,
    6712,  1046, 11676, -1346, -1346,  1051, -1346, -1346, -1346,   606,
   -1346, 11601, 11751,   876, -1346,  9018,   518,  9333, -1346, -1346,
     587,  1047,  1050,  1499,  2494, -1346, -1346, 11820, -1346, -1346,
    1743,  1052,  5182, -1346,  1743,  1053, -1346, -1346,  1057, -1346,
    1053,  1060,   509,  5182, -1346,  1061,   192,  1063,  1072,  1073,
   -1346,  1076,  1077,  7884, -1346,  5182, -1346,  5073,  5182,  1068,
   -1346, -1346,   657, -1346,  5182, -1346, -1346,   828, -1346, -1346,
   -1346, -1346,   385,   385,   290,   290,   801,   801,   801,   801,
     638,   638,   472,   837,   833,   835,   879,  5182,   327, 10950,
    1084,  1085,  1086,   674, -1346, -1346, -1346, -1346, -1346, 10950,
   10950, -1346, -1346, 10609, -1346,  8256, 10024, -1346, -1346, -1346,
     953, 10950,   985,  1089,  1093,  1107,  1110,  1115,  1120,  1124,
   -1346,  4610, -1346,  2260, -1346, -1346, -1346, -1346, -1346, -1346,
   -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346,
   -1346, -1346,   949, -1346, -1346, -1346,   951,   797, -1346, -1346,
   -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346,  1127,
    1130, -1346,   118,  1068,  4710, -1346, -1346, -1346,  3398,  1123,
   -1346, -1346, -1346, -1346,  1743,  7483,  1215, -1346, -1346, -1346,
   -1346,  1116, -1346, -1346, -1346,   949, -1346, -1346, -1346,   949,
     713,  1136,   949, -1346, -1346, -1346, -1346, -1346, -1346,  8132,
   -1346,   227, -1346,  1142, 10682, -1346,  2205, -1346,   542,  1743,
   -1346,  1152,  1157, -1346, -1346,  1156,  1162, -1346,   775,  1004,
   -1346,   751, -1346,  2494,   951, -1346,   967, -1346, -1346, -1346,
     969,  1165, 11820,  9247,  9788,  1168, -1346, -1346,   677,  1169,
    8132,   606,  1169, -1346, -1346,  1169, -1346,  3398, -1346, -1346,
   -1346,  1163,  5182,  1278, -1346,  5182, -1346,  1278, -1346, -1346,
    5182, -1346,   317,   865, -1346, -1346, -1346, -1346, -1346, -1346,
   -1346,   876,  9906, -1346, -1346,  8380,  1174, -1346,   318,   865,
   -1346,   324,   376,   865, -1346,   797,  4908, -1346, -1346, -1346,
   10950, 10950, -1346,  9408,  9408,  1177,  1176,  1184,  1186, -1346,
     793,    61,  1068, -1346,  1278, -1346,  3873, -1346,  5182,   543,
   -1346,  7760,  1195,  1198, 11362,  1199,  1200,  1074,  1128,  1197,
    5182,  1209,   227,  5182,  5182,  1300,  1189,  1193,   187,   182,
     688,  1196,  1212,  1214, -1346, -1346, -1346,  1217, -1346, -1346,
   -1346, -1346, -1346, -1346, -1346, -1346,  1219, -1346,  1743,  1234,
    5182, 10950, 10950,   118,   140,  1237, -1346, -1346,  2205,   575,
    1180,  5182,  2333,   588, -1346, -1346,  1222,    54,  1222, -1346,
   -1346, -1346,   140,   140,  1743, -1346, -1346, 10376, -1346, -1346,
   -1346, -1346,  1255,  1004, -1346, -1346,  1238, -1346,  1254, -1346,
    1053, -1346, -1346,  2348,  1259, -1346, -1346, -1346,   708,  1256,
   -1346,  1266,  1021,  5182,  1265,  1163, -1346,   818, -1346, -1346,
    1264, -1346,    23, -1346,  1270,  1264, -1346,  1275, -1346, -1346,
   -1346,   949,  1276,  1280,  8008,  1287,  1288,  1291, -1346,   140,
    1294, -1346, -1346, -1346,   949, -1346, -1346, -1346, -1346, -1346,
   -1346,   949,  5182,  5182,   876,  1298, -1346, -1346, -1346, -1346,
   -1346, -1346, -1346, -1346, -1346, -1346, -1346,  5182,  5182,  1306,
    1307,  1264, -1346, -1346,  1743, -1346, -1346, -1346,  5182,  5182,
    1361,  5182, -1346, -1346,  1296, -1346,  1297,  5182,  1302,  1303,
    5182,  1094,  1304,    -2, -1346,    55,  1896, -1346, -1346,  7483,
    1273,   140,   608, -1346, -1346, -1346, -1346, -1346, -1346, -1346,
   10451,   618, -1346,   858,  1310,  1313,  1329, -1346,  2333, -1346,
     140, -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346, 11178,
   -1346,  9408, -1346,  1330, -1346, -1346,  9247,   621,   664, -1346,
    1328, -1346,  1336, -1346, -1346,  1347,  1331, -1346, -1346,  1331,
    1331,  1278,  1349,   897,  1631, -1346,  1350, -1346, 10950, -1346,
   -1346, -1346, -1346, -1346,  1355, -1346, 10950, 10950, 10950, -1346,
   -1346,  1357, -1346,  1359,  1345,  1365,   815,  9093,  9213, -1346,
   -1346, -1346, -1346,  1362, -1346,   710,   712,  1344,   754,  7625,
   -1346, -1346,   698, -1346, -1346,   761,  1371,  1376,   227,  1429,
     937, -1346, -1346,  5182, -1346,  1379,   522,  5182, -1346, -1346,
   11362, -1346,  1384,  1385, -1346, -1346,   416,   865, -1346, -1346,
    2205, -1346, -1346, -1346,  1375, -1346, -1346, -1346, -1346, -1346,
   -1346,  9247, -1346, -1346, -1346,  1278, -1346, -1346, -1346, -1346,
   -1346, -1346, -1346, -1346, -1346, -1346, -1346, -1346,  1387,  1390,
   -1346, -1346, -1346, -1346, -1346, -1346, -1346,  1396, -1346,  1397,
   -1346, 11362,    52,  5182, 11362, -1346,  1400,  5182, -1346,  8823,
    9247, -1346,   242,  1401,  1418, -1346, -1346,  1406,  1407,  1388,
     522,   291,   885, -1346, -1346, -1346, -1346, -1346, -1346,   949,
   -1346, -1346,  1650,  2348,  1409,  1264,  1278,  1278,  1416,  1417,
    1421,  1425, -1346, -1346,  9408,  1420, -1346,  1497,  5182,  1412,
   -1346, -1346, 11272, -1346,   794, -1346,  1415, 11362,  1424,  9483,
   -1346, -1346,  1439, -1346,  1442, -1346,  1454,  1461, -1346,  1431,
    1427,   210,  1430, 10950,  9247, -1346, -1346, -1346,  1455,  1264,
    1264, -1346, -1346, -1346, -1346, -1346, 11362,    76, -1346,   476,
   -1346, -1346,  5498, -1346, -1346,  1443,  5182, -1346,  5182,  5498,
     227, 10830,   227, 10830,  1462, -1346,  1467, -1346,  1457, -1346,
    5182,  1480,   308,  1475, -1346, -1346, -1346,  1479, -1346,  1483,
    1485, -1346,  5182,  5182, -1346, -1346,   963,    96, -1346, -1346,
    1471, -1346,   963, -1346, -1346,  1784, 10757,   606, -1346, -1346,
     227, 10830,   227, 10830,   210,  1487,  5182,  1477,   210,   210,
    1500,  1502, -1346, -1346, -1346, -1346, 11272,  1498,   963,  8747,
    5182, 11182,  1503,   963,  1510,  1784,  2509, -1346, -1346, -1346,
    1512, -1346, -1346, -1346, -1346,  1493,   522,  1516, -1346,   358,
   -1346, -1346,  9788, -1346, 11044, -1346, 11272, -1346, -1346,  1501,
   10954, -1346, -1346, 11182,   227,  2509,   227,  1519,  1520,   522,
    1522, -1346,  1509,   522,   809, -1346, 11044, -1346, -1346, -1346,
   10954, -1346, -1346, -1346,   227,   227, -1346,   568,  5182, -1346,
     824, -1346, -1346, -1346, -1346, -1346, -1346,   522,   606,  1533,
    1514, -1346, -1346, -1346, -1346,   843, -1346, -1346,  1518,   606,
   -1346, -1346
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1346,  4712,  1583, -1346,  1844, -1346,     7,     0,   257, -1346,
   -1346,   637,  -508,  -460,  -702, -1047, -1346,   -72,  1640,  1181,
   -1346,   368,   492,   531,   498,   557,  1092,  1099,  1100,  1106,
    1091, -1346,  -277,  -697,  5286,  -774, -1346, -1346,   722,   565,
    -972,   603, -1346,   111, -1346,   496, -1130, -1346, -1346,   208,
   -1346, -1322,  -943,   325, -1346, -1346, -1346, -1346,   128, -1151,
   -1346, -1346, -1346, -1346, -1346, -1346,   400, -1046, -1346, -1346,
    -544, -1346,   196,   138, -1346,   243, -1346,  -329, -1346, -1346,
   -1346,   648,  -823, -1346, -1346,     5, -1137,   564,   270, -1346,
   -1346, -1346,  -130, -1346,    18,  -452,    47,  -213,  -191,  2570,
    4418, -1346, -1346,   131,   355,   744,  1341,    39,  2331, -1346,
   -1346, -1346,   276, -1346,   365,   201,  2987,    15,  -227, -1346,
   -1346,  5549,  5788,  -872, -1346,   795,   639,   391,   634,  -919,
   -1346, -1346,  6180,   970,   781,  -314, -1346,   -52,  -391,   770,
   -1346, -1346,  -927,  -863,   -63,   -19, -1346,  1233, -1346,  1364,
     -99,  -296,  -180,  -136,   762,   840, -1346,  1048,   405,  3462,
    1523,  -417,   986, -1346, -1346,   792, -1346,  -436, -1346,   -73,
   -1346, -1346, -1346, -1262,   494, -1346, -1346, -1346,  1230, -1346,
       6, -1346, -1346,  -803,  -107, -1345,  -150,  6282, -1346,  3941,
   -1346,   982, -1346,   -18,   212,  -176,  -173,  -169,     2,   -42,
     -40,   -32,   586,    10,    22,    49,    50,  -166,  -163,  -160,
    -158,  -318,  -540,  -528,  -480,  -587,  -304,  -556, -1346, -1346,
    -509,  1145,  1154,  1155,  1813,  5019,  -577,  -507,  -497,  -488,
    -468, -1346,  -925, -1029, -1004, -1003,  -581,  -252,  -244, -1346,
   -1346,   169,    77,   -45, -1346,  3860,   -39,  -632,   147
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -547
static const yytype_int16 yytable[] =
{
      50,   113,    98,   147,   395,   148,   115,   396,   112,   426,
     257,   397,   163,   149,   398,   689,   815,   399,    63,   859,
     400,  1194,   401,   605,   757,   919,   816,   706,  1067,   381,
     382,   113,   113,   408,    50,   437,    98,   610,  1169,    73,
     142,   834,  1035,  1430,   806,    50,  1195,  1196,   117,  1374,
    1228,    50,    63,   158,   739,   150,  1140,  1141,    50,   784,
     803,   250,  1037,    50,  1283,   189,    50,   151,   212,    50,
    1434,   222,   804,    73,   215,   163,   725,   107,   107,   395,
     730,   210,   396,   407,    33,   596,   397,   675,   708,   398,
     423,   359,   399,   807,   152,   400,    33,   401,   156,  1388,
    1389,   472,   474,   808,   198,   321,   684,    50,   333,  1285,
      50,   107,   809,  1233,   688,   623,   467,    50,  1430,   635,
     805,  1142,    33,   639,   589,   113,   565,  1199,   679,   681,
     473,    69,  1348,   210,    33,  1284,   819,  1203,   147,  1203,
     148,  1234,   826,  -240,  -240,    50,   107,   158,   149,   123,
     633,   444,  1457,   248,   637,   199,   242,    50,   409,   371,
     566,   156,  1147,   403,   456,    69,   433,   170,   715,  1286,
     409,  1390,   210,   803,  1434,  1190,   124,  1462,  1156,  1434,
      50,    50,    33,   158,  1316,   804,  1319,  1321,  1148,   522,
     150,   316,   494,   141,   417,   495,   409,    50,  1157,   729,
     331,    78,   151,  1148,  1434,    50,   478,   158,   409,   243,
      33,  1434,    97,   147,    50,   148,  -240,    50,   741,   440,
     160,   143,   433,   149,   113,   928,   978,   709,   673,   152,
     165,   404,   210,   805,   113,    78,   979,   113,   403,  1172,
    1173,    50,   113,    98,   966,  1105,    97,   459,   428,   461,
     850,   850,   431,    33,   166,    50,    50,   146,   158,    63,
     803,   163,    50,    97,   210,   113,   850,   242,   323,   210,
      58,    58,   804,  1299,   955,   185,    77,    33,    97,   788,
      73,    97,   817,   160,   601,    73,   467,   584,  1078,  1388,
    1389,   706,  1151,   807,   272,  1348,   514,  1345,   598,   610,
     415,   144,  1348,   808,    58,   467,   404,   473,   431,   153,
      77,   486,   809,   467,   850,   677,    33,   -10,   107,  1223,
     805,   682,    50,   434,   371,   824,  1450,   601,   851,   602,
    1140,  1141,   816,   442,   819,   316,    58,   375,   574,    58,
      50,    50,   794,   868,   575,   219,   168,   156,  1142,   872,
    1531,   409,   708,   376,  1197,    70,  1035,    97,   891,    33,
      33,  1400,  1348,   623,    50,   197,    33,   359,    50,    97,
     596,  1530,    69,   792,   432,  1398,  1037,   470,   648,   583,
     596,   834,  1551,   839,   668,   321,   321,   840,   876,    70,
     409,   907,   394,   185,   845,  1142,  1546,  1479,   623,   521,
     273,   807,    50,  1550,   371,    86,  1410,   623,   735,   833,
     737,   808,   321,   738,   551,   552,   742,    97,    33,   589,
     809,   208,    50,  1487,   340,   844,  1411,  -299,    50,    97,
     432,  1108,  1121,   409,   409,  1512,   237,  1514,  1125,    86,
     601,   697,    78,  1488,   210,   918,  1347,    78,   745,   240,
    1259,  1260,   669,    97,   242,    73,   321,  1425,    33,   668,
    1222,   359,   950,   113,  1470,   623,  1471,   476,    50,   160,
     112,   316,   316,  1542,    73,   321,  1194,    50,   706,   371,
     623,    50,    73,    98,   210,  1103,    50,    58,  1088,   113,
    1128,   709,   601,  1543,   113,   977,   979,  -542,   316,    63,
     949,  1195,  1196,  1127,  1130,  1080,   861,   548,   647,   610,
     117,    58,   698,   549,   550,   253,   860,    77,   699,   498,
      73,  1142,    77,  1496,   359,   862,   113,   669,  1528,  1501,
    1366,   113,   409,   751,    97,   716,   321,   731,   756,   708,
     486,   717,   316,   732,   486,   -12,   576,   470,   409,   959,
    1508,   686,   870,   604,   316,  1526,   316,   467,   107,   316,
    1533,   316,   316,   880,    57,   116,   470,   744,   623,   559,
     560,   904,   439,   745,   470,   385,   700,   990,   359,   359,
     958,  1199,  -467,   835,   499,   113,   500,   501,   388,   849,
     849,   386,  1139,   598,   359,   977,    70,  1463,    57,   390,
      50,   324,   885,    50,   389,   849,   272,   111,   745,  1468,
    1299,  1464,    69,  1375,   185,   391,  1468,    78,   521,  -468,
      43,    44,   316,   521,    50,   111,   521,   138,   139,   113,
     206,   268,   908,   216,   601,   718,    78,   159,    43,    44,
      47,    48,   359,    50,    78,   511,    86,   113,   750,   190,
     270,    86,   213,   849,   602,   223,    50,   697,   113,    50,
     113,   392,   706,  1064,  1154,   869,   855,   871,   546,   547,
      50,   325,   989,  1106,  1419,  1420,  1527,   393,   709,  1065,
    1155,   111,    78,   271,     8,     9,    10,    11,    12,  1567,
     370,  1427,    77,    97,    43,    44,  1064,   208,   604,   113,
     340,   374,   592,  1568,   326,   546,   903,   327,   626,  1200,
     596,    77,  1192,    50,    50,   328,    33,   210,   796,    77,
     113,   990,   995,   708,   113,  1201,    73,   329,   592,  1154,
    1043,   159,   592,   555,   556,   887,   383,   896,   623,  1200,
      73,   745,  1306,   372,    36,  1291,   219,   546,   893,   833,
     387,    58,   820,  1485,   575,  1295,   823,    77,  1307,   706,
     697,   405,   829,   279,   486,  1494,  1427,   159,   557,   558,
     697,   697,   944,   579,   918,   409,    43,    44,   945,  1362,
     407,   438,   697,   843,  1132,  1308,   883,   846,   567,  1517,
     409,   159,  1090,   424,   340,   890,    47,    48,   945,   892,
      50,  1309,   515,   441,   377,    57,   425,     8,     9,    10,
      11,    12,   802,    50,   225,   604,   481,   226,   470,   745,
     230,    86,   232,  1219,   208,  1341,   359,  1342,   447,   575,
     235,   745,   470,   745,  -300,  1351,    70,   457,   111,    33,
      86,     8,     9,    10,    11,    12,   841,   567,    86,   409,
     842,    43,    44,   520,   458,    47,    48,   340,   648,   899,
    1152,  1569,   709,  1187,   113,  1021,  1337,    36,   841,  1344,
     918,   918,  1074,    33,   395,   745,  1352,   396,  1056,   755,
     505,   397,   745,    63,   398,   321,    86,   399,    78,   908,
     400,   601,   401,   111,   553,   554,    50,    47,    48,   113,
    1096,    36,    78,  1097,    73,  1098,    43,    44,   372,  1435,
    -112,   340,   340,    50,  -112,   745,   759,   760,   761,  -418,
     359,   359,   506,   835,  1561,   802,   604,   340,  1081,   881,
     575,   113,  1334,   509,  1227,   514,  1335,   648,  1091,  1570,
    1515,  1048,   107,   113,  1519,  1567,  1058,   113,   948,   945,
    1099,   592,   225,    39,  1099,   171,   172,    42,  1578,   709,
     561,   697,   697,    77,  1579,   562,    43,    44,   563,   486,
    1083,   316,   111,   323,   409,   340,  1214,    77,   564,  1096,
     439,   330,  1097,   982,  1098,    43,    44,   592,   372,   678,
     680,   586,   370,    -3,   113,   661,    69,   592,  1357,  1358,
     107,  1099,  1046,   592,  1021,  1412,   945,    50,    50,    50,
    1388,  1389,   802,  1318,     8,     9,    10,    11,    12,    63,
     796,   662,   697,   697,   663,   604,  1229,  1230,    39,   665,
    1056,   666,    42,   667,   403,   242,   323,   409,   113,   671,
      73,    43,    44,   762,   763,    57,    33,   208,    50,   672,
      50,   674,    50,   766,   767,   768,   769,   439,   417,   664,
     409,  1075,   208,   899,   113,   247,    78,   800,   111,   601,
     138,   450,   520,  -389,    36,    47,    48,   520,   107,  -244,
     520,    43,    44,    50,   764,   765,  1544,   602,   225,   226,
     720,   627,    86,   232,   478,   323,   409,   113,  1058,   817,
     323,   601,   404,   722,  1099,   235,    86,   451,  1057,   724,
     733,   918,   452,   734,   896,   938,   770,   771,   908,   797,
     601,   746,   747,  1171,   -14,   604,    47,    48,   799,  -301,
      39,   778,    69,   810,    42,    58,     8,     9,    10,    11,
      12,    77,   858,    43,    44,   -15,  1302,   857,   864,    39,
     208,   171,   172,    42,   113,  1276,  1277,  1278,   592,   340,
     886,   626,    43,    44,   888,   900,  -441,  -546,    33,    45,
     912,   924,   917,   918,   717,   926,   929,    47,    48,  1021,
     668,    51,   114,   225,   931,   918,   918,   932,   933,   942,
    1303,   934,   935,    58,   359,   359,    36,    63,    50,   952,
     953,   954,    78,    39,   968,   171,   172,    42,   969,   918,
     128,  1163,   129,   130,   131,    51,    43,    44,    73,   697,
      70,  1081,   970,    43,    44,   971,   145,   697,   697,   697,
     972,   113,    51,   113,   113,   973,   899,   896,  1099,   974,
    1099,  1099,  -429,   997,   181,  -428,  1038,   205,   669,   623,
      51,  1044,  1040,   340,   340,    39,   107,   178,   179,    42,
    1057,  1047,  1193,  1083,  1057,  1165,  1416,  1068,    43,    44,
      86,    58,    39,  1070,   171,   172,    42,    77,  1069,  1071,
    1079,   918,  1056,  1089,  1093,    43,    44,   114,   937,  1119,
    1021,   174,  1143,   107,  1050,   114,   409,  1144,   256,   261,
      50,  1146,    47,    48,   111,  1145,   138,   139,    73,  1158,
      69,  1174,  1159,  1161,  1162,   113,  1081,    43,    44,  1167,
     439,   359,  1099,  1170,    -9,   300,   145,   592,  -464,   395,
     546,   -11,   396,   745,   114,   337,   397,    -3,   205,   398,
     251,  1021,   399,   252,  1021,   400,   107,   401,   265,  1183,
    1058,  1177,  1189,   111,  1181,   215,    70,  1051,  1083,   899,
    1096,   181,   181,  1097,   210,  1098,    43,    44,  1507,   511,
    1210,   494,    50,    50,  1212,  1220,   113,   113,   256,  1215,
      78,  1221,  1224,  1099,  1099,  1231,    51,  1235,   107,  1355,
    1237,  1239,  1021,  1289,   697,  1240,   140,  1021,   205,    39,
    1350,   171,   172,    42,  1241,  1242,    86,   209,  1243,  1245,
    1057,  1267,    43,    44,   210,  1252,   228,  1314,   111,  1081,
     138,   139,    51,  1261,  1262,  1296,  1021,   107,  1297,    57,
     261,    43,    44,  1270,  1271,   261,   256,   256,   374,  1273,
    1274,  1282,   114,  -302,  1298,  1304,   884,   436,  1310,    58,
       8,     9,    10,    11,    12,    77,  1312,   726,  1343,   209,
    1332,  1083,   727,   147,  1313,   148,  1317,  1322,  1024,   300,
      78,    73,  1324,   149,  1330,    50,  1331,   113,    73,  1340,
    1333,   300,    33,   321,  1509,  1353,    58,  1082,   403,   266,
    1354,   107,  1278,  1360,  1371,   480,  1021,   568,   209,  1364,
    1365,  1021,  1402,   145,  1382,    50,    50,  1383,   158,   107,
      36,  -430,  1057,   114,  1386,  1397,   107,   668,   337,  1404,
    1406,  1407,   603,   622,  1021,  1408,  1021,   340,   340,  1417,
    1021,  1421,  1422,  1021,    70,    50,  1423,   371,    73,    58,
    1424,  1335,  1426,  1361,   632,    77,  1021,  1431,   632,   951,
    1021,  1473,  1436,  1478,  1440,  1444,   404,  1442,   209,   956,
     957,  1438,  1446,  1350,  1449,    57,  1448,  1455,   113,   316,
    1350,   967,  1458,   174,    39,  1574,   107,  1480,    42,   113,
    1469,    58,  1482,   181,    86,   669,  1581,    43,    44,   211,
     209,  1511,  1484,  1513,  1486,   209,  1489,   636,   453,  1491,
    1492,   640,  1493,   256,  1516,   300,   300,  1160,  1500,   256,
    1477,   632,  1477,   713,  1518,  1521,  1522,  1409,  1525,    58,
      58,    47,    48,  1532,    70,  1534,   219,  1536,  1539,   491,
    1350,  1541,   300,    78,  1554,  1555,  1558,   164,  1547,   169,
      78,   211,   175,   176,   177,  1552,  1559,  1553,  1576,   256,
    1477,  1577,  1477,   772,   340,  1580,   776,  1176,   256,   229,
     632,   773,    51,   774,  1095,  1565,  1566,   714,  1451,    58,
     775,  1495,   238,   239,    86,  1288,   114,  1401,  1562,  1356,
     211,  1560,  1472,   209,    58,  1520,  1182,  1191,   300,  1049,
     114,  1370,  1204,   300,   920,   300,   300,  1077,   996,  1092,
      78,   863,    58,   914,   208,   337,   111,  1076,    77,    58,
    1305,   711,   780,  1096,   927,    77,  1097,   476,  1098,    43,
      44,   781,   782,  1265,  1266,    39,  1268,   171,   172,    42,
       0,     0,  1272,     0,     0,  1275,     0,     0,    43,    44,
     211,  1451,   649,    57,     0,  1451,  1451,  1320,   568,   568,
    1137,  1138,     0,     0,   439,     0,   300,   454,     2,   202,
       4,     5,     6,     7,     0,   406,     0,   632,   337,    58,
     209,   622,   211,  1540,     0,    77,     0,   211,     0,     0,
    1082,   603,  1024,     0,   603,     0,   209,    70,    39,     0,
     178,   179,    42,     0,    70,     0,  1556,     0,     0,     0,
    1556,    43,    44,   632,     0,     0,   592,     0,   592,     0,
     209,  1185,  1186,   632,     0,   622,     0,     0,   111,   632,
     138,   139,   632,   632,  1573,     0,    37,   600,    38,   601,
       0,    43,    44,    57,     0,    47,    48,    86,   632,     0,
     256,     0,     0,     0,    86,     0,   592,     0,   592,   602,
       0,   256,     0,   719,    70,     0,     0,   836,   728,    39,
       0,   178,   179,    42,     0,   211,     0,     0,     0,     0,
       0,   114,    43,    44,     0,  1082,   852,     0,     2,   202,
       4,     5,     6,     7,     0,     0,   632,   909,   622,   867,
       0,    -3,     0,  1363,   714,   714,     0,     0,  1505,     0,
     409,     0,   173,     0,    86,     0,    47,    48,  1394,   224,
       0,     0,     0,   206,   216,   508,     0,   510,   513,   588,
       0,   599,     0,     0,   337,     0,   516,   517,   525,     0,
       0,   209,   526,   527,   528,     0,     0,     0,   630,   631,
     510,   510,     0,     0,  1387,     0,    37,  1395,    38,   791,
       0,   173,   211,     0,   173,     0,   529,     0,   530,     0,
     531,   532,     0,   438,   568,     0,   209,     2,   202,     4,
       5,     6,     7,     0,   632,   209,   962,   510,  1082,     0,
       0,   603,   525,     0,     0,     0,   526,   527,   528,     0,
       0,     0,   211,   838,   603,  1433,    57,     0,   411,     0,
    1437,     0,     0,    57,     0,   419,     0,     0,  1323,     0,
     529,   856,   530,     0,   531,  1287,  1325,  1326,  1327,   510,
       0,     0,     8,     9,    10,    11,    12,     0,   111,  1461,
     138,   450,     0,   209,     0,    37,     0,    38,     0,     0,
       0,    43,    44,   209,     0,     0,   300,     0,   209,     0,
       0,     0,     0,     0,    33,     0,     0,     0,   173,     0,
       0,     0,     0,    57,     0,     0,     0,     0,     0,     0,
     337,   411,     0,     0,     0,   114,     0,  1052,     0,     0,
       0,     0,    36,     0,   916,     0,     0,    39,   491,   909,
     909,    42,     0,     0,   714,     0,     0,     0,     0,     0,
      43,    44,     0,     0,   114,   300,   173,     0,     0,     0,
       0,   337,     0,   211,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,  1545,     0,   573,
       0,     0,     0,  1545,    47,    48,   209,     0,   577,     0,
       0,   580,     0,   337,     0,     0,     0,     0,   211,  1545,
       0,     0,   454,  1545,     0,     0,     0,   211,     0,     0,
       0,     0,     0,     0,   632,   632,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   300,  1456,   173,     0,     0,     0,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,     0,   411,   173,     0,
       0,   419,   173,     0,     0,   211,     0,     0,     0,     0,
       0,     0,   649,     0,     0,   211,     0,     0,  1000,  1052,
     211,  1052,     0,  1052,     0,     0,     0,     0,     0,     0,
    1164,  1166,  1168,     0,     0,     0,     0,     0,   114,     0,
       0,     0,     0,     0,   909,     0,     0,     0,     0,     0,
       0,     0,     0,  1066,   256,     0,     0,     0,     0,     0,
       8,     9,    10,    11,    12,     0,   901,     0,   902,     0,
      39,     0,   178,   179,    42,     0,   905,   906,     0,   411,
       0,   911,     0,    43,    44,   337,     0,     0,     0,     0,
       0,   649,    33,     0,     0,     0,   209,     0,   921,     0,
       0,     0,     0,   925,     0,     0,     0,     0,   211,  1050,
      39,   409,   178,   179,    42,     0,     0,    47,    48,     0,
      36,    74,   599,    43,    44,    39,     0,   178,   179,    42,
    1051,     0,     0,     8,     9,    10,    11,    12,    43,    44,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   180,
     300,     0,   510,     0,     0,    74,     0,    47,    48,     0,
       0,   114,     0,     0,   600,    33,   601,     0,     0,  1052,
     573,   573,    47,    48,     0,     0,     0,   510,     0,     0,
       0,     0,   632,     0,     0,     0,     0,   114,     0,     0,
     218,     0,  1000,    36,     0,     0,     0,     0,    39,     0,
     178,   179,    42,     0,     0,     0,     0,   510,     0,     0,
       0,    43,    44,    39,     0,   178,   179,    42,  1207,     0,
     985,     0,   986,   987,   988,     0,    43,    44,   632,   632,
       0,     0,     0,     0,     0,     0,     0,  1050,     0,   409,
     300,  1039,     0,     0,     0,    47,    48,     0,     0,     0,
       0,     0,   255,     0,     0,     0,     0,  1045,   173,     0,
      47,    48,     0,     0,   874,     0,     0,     0,   878,     0,
       0,  1052,     0,     0,     0,   346,     0,   173,   211,     0,
    1072,     0,   114,     0,     0,     0,     0,     0,     0,     0,
     173,     0,     0,     0,     8,     9,    10,    11,    12,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1264,     8,
       9,    10,    11,    12,  1094,     0,     0,     0,     0,  1104,
     261,   114,     0,     0,  1107,     0,    33,     0,     0,  1112,
    1113,     0,     0,     0,  1115,     0,  1116,  1117,     0,     0,
    1120,    33,     0,     0,   256,     0,     0,   446,     0,  1135,
       0,     0,     0,     0,    36,   632,     0,     0,     0,    39,
      66,   118,    74,    42,     0,  1149,  1150,    74,     0,    36,
     261,     0,    43,    44,    39,     0,   178,   179,    42,     0,
     510,     0,     0,     0,     0,   114,   573,    43,    44,     0,
       0,     0,   510,     0,    66,  1415,     0,  1178,   713,     0,
    1180,     0,     0,   114,     0,     0,    47,    48,     0,     0,
     114,   157,   114,  1505,   114,   409,     0,     0,     0,     0,
       0,    47,    48,     0,     0,     0,     0,     0,     0,   217,
       0,   510,     0,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,     0,     0,  1506,   261,     0,     0,
       0,     0,   114,  1213,   114,     0,     0,     0,   591,  1217,
    1218,     0,     0,     0,   218,     0,   249,   544,  1225,     0,
     114,     0,     0,  1232,     0,     0,  1506,  1506,  1236,     0,
     209,   510,     0,     0,   591,     0,     0,     0,   591,     0,
       0,  1244,     0,   300,     0,     0,     0,     0,     0,   173,
       0,     0,     0,     0,     0,   322,  1506,  1251,     0,  1253,
    1254,  1255,  1256,   249,   342,     8,     9,    10,    11,    12,
       0,     0,     0,     0,  1263,     0,  1149,     0,     0,     0,
     209,     0,     0,     0,     0,     0,     0,    74,     0,     0,
       0,   402,     0,     0,     0,     0,     0,    33,     0,     0,
       0,   346,     0,     0,     0,  1110,    74,   422,  1292,  1293,
     427,   429,     0,     0,    74,   157,     0,     0,     0,     0,
       0,  1123,     0,     0,     0,    36,     0,   510,   510,     0,
      39,   346,   178,   179,    42,     0,   445,     0,     0,     0,
     448,   218,   449,    43,    44,   455,     0,     0,     0,     0,
     346,    66,    74,     0,     0,     0,   469,   209,     0,     0,
       0,     0,     0,     0,     0,     0,   477,     0,     0,   180,
       0,     0,  1328,  1329,   429,     0,     0,    47,    48,     0,
       0,     0,  1339,     0,     0,     0,     0,     0,   173,     0,
       0,   173,   173,   173,     0,   346,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     411,     0,   211,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     8,     9,    10,
      11,    12,   249,     0,     0,     0,  1378,   590,  1379,  1380,
    1381,     0,     0,   625,     0,     0,     0,   591,   346,     0,
    1385,     0,   211,     0,     0,     0,     0,     0,  1396,    33,
       0,   169,     0,   634,     0,     0,     0,   634,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   591,     0,     0,     0,    36,  1418,     0,
       0,     0,    39,   591,   178,   179,    42,     0,     0,   591,
       0,     0,   346,   346,     0,    43,    44,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   469,    79,   346,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     342,   255,  1459,  1460,     0,   469,   411,   346,     0,    47,
      48,     0,     0,   469,     0,  1465,     0,     0,    74,     0,
       0,    79,  1465,   173,     0,     0,     0,     0,   510,     0,
     692,     0,    74,   429,     0,     0,   346,     0,     0,  1490,
     702,     0,     0,     0,     0,     0,     0,     0,     0,   707,
       0,    66,     0,     0,     0,     0,   220,  1504,     0,     0,
       0,     0,  1510,   429,     0,     0,     0,   429,     0,     0,
       0,     0,     0,     0,   346,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     510,     0,     0,     0,   342,  1537,     0,  1538,     0,     0,
       0,     0,   510,   510,     0,     0,     0,     0,     0,  1368,
     346,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     346,   346,     0,     0,   591,     0,   510,   218,     0,     0,
       0,     0,   346,     0,   173,  1563,  1564,     0,   783,     0,
       0,   350,     0,     0,     0,     0,     0,     0,  1571,  1572,
       0,     0,     0,     0,     0,     0,   634,   795,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   813,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   173,     0,     0,   173,     0,
       0,     0,   590,     0,     0,     0,    74,   837,   510,     0,
       0,     0,   590,     0,     0,     0,     0,     0,   634,     0,
       0,   342,   342,     0,     0,     0,   173,     0,     0,     0,
     346,     0,     0,     0,     0,     0,     0,   342,    79,     0,
       0,     0,     0,    79,   275,   276,   173,   277,     0,     0,
       0,   173,     0,     0,     0,     0,   692,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   469,     0,     0,
       0,   346,     0,   278,     0,     0,     0,     0,     0,   279,
     173,   469,     0,   280,     0,   342,   281,   282,   272,   283,
     284,   285,    43,    44,   913,   286,   287,   429,     0,     0,
       0,     0,     0,   591,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   288,     0,
     377,   346,   346,   707,   346,   346,    47,    48,   290,   291,
     292,   293,     0,     0,   593,     0,     0,     0,     0,   777,
     220,     0,    74,     0,     0,     0,     0,     0,     0,     0,
     173,     0,     0,     0,     0,   173,     0,     0,     0,   692,
     593,     0,     0,     0,   593,     0,     0,     0,     0,   692,
     692,     0,     0,   634,     0,     0,   965,     0,   173,     0,
     173,   692,   346,   346,   173,     0,     0,   173,     0,     0,
       0,   976,     0,     0,     0,     0,     0,     0,     0,     0,
     173,     0,     0,     0,   173,     0,     0,     0,     0,     0,
       0,     0,     0,    79,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   350,     0,     0,
       0,     0,    79,     0,     0,     0,     0,     0,     0,     0,
      79,     0,     0,     0,     0,    66,     0,     0,   275,   276,
       0,   277,     0,     0,     0,   346,     0,   350,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   220,     0,   795,
       0,     0,    87,     0,     0,     0,   350,   278,    79,     0,
       0,     0,     0,   645,     0,   138,   139,   280,     0,  1073,
     281,   282,   272,   283,   284,   285,    43,    44,     0,   286,
     287,     0,   429,   118,     0,     0,    87,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      74,   350,   288,     0,   646,     0,   647,   378,     0,     0,
      47,    48,   290,   291,   292,   293,     0,     0,     0,     0,
       0,   221,   590,     0,     0,     0,     0,     0,     0,     0,
     346,     0,   346,     0,     0,   427,     0,     0,     0,     0,
     692,   692,     0,   342,   342,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   346,
       0,    66,     0,   593,   350,     0,     0,   346,   346,   346,
       0,     0,     0,     0,     0,     0,     0,     0,   346,   346,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      74,     0,     0,     0,     0,     0,     0,     0,     0,   593,
       0,   692,   692,     0,     0,     0,   362,     0,     0,   593,
       0,     0,  1198,     0,     0,   593,     0,     0,   350,   350,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   350,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   350,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    79,     0,     0,     0,     0,     0,
       0,   218,     0,     0,   707,     0,     0,     0,    79,     0,
       0,     0,   350,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,     0,     0,     0,     0,    87,     0,
       0,     0,     0,     0,     0,   346,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     350,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   346,     0,     0,     0,     0,    66,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    74,     0,     0,   350,     0,     0,     0,
      74,     0,   591,     0,   591,     0,   350,   350,     0,   692,
     593,   707,     0,   220,     0,     0,   118,     0,   350,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   594,
       0,     0,     0,     0,     0,   221,     0,     0,   692,     0,
       0,     0,   591,     0,   591,     0,   692,   692,   692,     0,
       0,     0,     0,     0,     0,   594,     0,   342,   342,   594,
      74,     0,     0,     0,     0,     0,     0,     0,     0,  1349,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    79,     0,     0,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,     0,   350,     0,    87,     0,
       0,   118,     0,     0,     0,     0,     0,    33,     0,     0,
       0,     0,   362,     0,     0,     0,     0,    87,     0,     0,
       0,     0,     0,     0,     0,    87,     0,     0,     0,     0,
       0,   162,     0,   275,   276,    36,   277,   350,     0,     0,
    1399,     0,   362,     0,     0,     0,   214,     0,     0,     0,
       0,     0,   221,     0,     0,     0,     0,     0,     0,     0,
       0,   362,   278,    87,     0,     0,     0,     0,   279,   593,
       0,     0,   280,     0,   342,   281,   282,   272,   283,   284,
     285,    43,    44,     0,   286,   287,     0,   350,   350,   127,
     350,   350,     0,     0,   162,     0,     0,     0,   262,     0,
       0,     0,     0,   692,   118,     0,   362,   288,    79,   377,
       0,     0,   378,     0,     0,    47,    48,   290,   291,   292,
     293,     0,  1349,     0,   162,     0,     0,     0,     0,  1349,
       0,  1476,     0,  1476,   368,     0,     0,   373,     0,     0,
       0,     0,     0,     0,   127,     0,     0,     0,   350,   350,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     127,     0,   127,     0,     0,     0,     0,     0,   594,   362,
       0,  1476,     0,  1476,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   162,     0,   267,     0,  1349,
       0,     0,     0,     0,     0,     0,  1535,   214,     0,     0,
       0,     0,     0,     0,   594,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   594,     0,     0,     0,     0,     0,
     594,   350,     0,   362,   362,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   373,     0,     0,     0,     0,   362,
       0,   162,     0,     0,     0,     0,   127,     0,   127,   127,
       0,     0,     0,   127,     0,   127,   127,     0,   362,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   523,    87,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     162,     0,     0,    87,     0,     0,    79,   362,     0,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     0,
       0,    28,    29,    30,     0,     0,   350,   597,   350,   127,
       0,    33,   624,     0,     0,   362,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   350,     0,     0,     0,    36,
       0,     0,     0,   350,   350,   350,   203,    41,     0,     0,
       0,   362,     0,     0,   350,   350,     0,     0,     0,     0,
       0,   362,   362,     0,     0,   594,    79,     0,   221,     0,
       0,     0,     0,   362,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   127,     0,     0,     0,     0,
       0,    47,    48,     0,   162,   162,     0,     0,     0,     0,
     368,     0,     0,     0,   127,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   162,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    87,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   220,     0,   710,
       0,     0,     0,     0,     0,     0,   127,     0,     0,     0,
       0,   362,     0,     0,     0,   162,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   523,     0,   523,
       0,   350,   523,     0,   162,   523,     0,     0,     0,     0,
       0,     0,     0,     0,   368,     0,     0,     0,     0,     0,
       0,     0,   362,     0,     0,     0,     0,     0,     0,     0,
     350,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
       0,     0,     0,     0,   594,     0,    79,     0,   593,     0,
     593,     0,     0,     0,     0,   162,     0,     0,     0,     0,
       0,     0,   362,   362,     0,   362,   362,   368,     0,     0,
     798,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,     0,     0,     0,     0,   593,     0,
     593,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   597,     0,   207,     0,    79,     0,     0,     0,
       0,     0,   597,   227,     0,   231,     0,   233,     0,     0,
       0,   368,   368,   362,   362,   236,     0,     0,     0,     0,
       0,     0,   127,   127,     0,     0,     0,   368,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   207,     0,   231,   233,
     236,     0,     0,     0,     0,   127,     0,     0,   127,   127,
     523,   127,     0,   127,   127,     0,     0,     0,   127,   127,
       0,     0,     0,     0,     0,   368,     0,   910,     0,     0,
       0,     0,     0,     0,     0,   207,   362,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   127,   710,     0,     0,   127,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   975,     0,     0,
       8,     9,    10,    11,    12,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   207,     0,   231,   233,   236,
       0,    87,     0,     0,     0,     0,     0,     0,     0,     0,
     275,   276,    33,   277,     0,   624,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   207,     0,     0,
       0,   362,   207,   362,     0,     0,     0,     0,     0,   278,
      36,     0,     0,     0,     0,   279,     0,     0,     0,   280,
       0,     0,   281,   282,   272,   283,   284,   285,    43,    44,
     362,   286,   287,     0,     0,     0,     0,     0,   362,   362,
     362,     0,     0,     0,     0,     0,     0,     0,     0,   362,
     362,     0,     0,     0,   288,     0,   377,     0,     0,     0,
       0,    87,   336,    48,   290,   291,   292,   293,     0,     0,
     207,     0,     0,     0,     0,     0,     0,     0,     0,   368,
     275,   276,     0,   277,   523,     0,     0,     0,   154,     0,
     207,     0,     0,     0,     0,     0,   628,     0,   233,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   278,
     236,     0,     0,     0,   162,   279,     0,     0,     0,   280,
     710,     0,   281,   282,   272,   283,   284,   285,    43,    44,
       0,   286,   287,     0,   241,     0,     0,     0,     0,     0,
       0,     0,   221,     0,   246,     0,     0,     0,     0,     0,
     207,     0,   597,     0,   288,     0,   377,     0,     0,     0,
       0,   748,    47,    48,   290,   291,   292,   293,     0,     0,
     207,     0,     0,   368,   368,   207,   362,   207,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   207,     0,     0,   207,   207,     0,     0,
       0,     0,     0,   207,     0,   362,     0,     0,     0,     0,
     384,     0,     0,     0,     0,     0,     0,   207,     0,     0,
       0,     0,     0,   127,    87,   207,     0,     0,     0,     0,
       0,    87,   416,   594,     0,   594,     0,     0,     0,   127,
       0,     0,   127,   127,     0,  1133,   430,     0,     8,     9,
      10,    11,    12,     0,     0,   435,     0,   523,     0,     0,
       0,     0,     0,     0,     0,   443,     0,     0,     0,     0,
       0,     0,     0,   594,     0,   594,     0,     0,   275,   276,
      33,   277,     0,     0,   460,     0,     0,     0,     0,   471,
       0,    87,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   479,     0,   710,     0,     0,   278,    36,     0,
     493,     0,   497,   279,     0,   127,     0,   280,     0,     0,
     281,   282,   272,   283,   284,   285,    43,    44,   127,   286,
     287,   524,     0,   127,   127,     0,     0,     0,   207,     0,
     628,   233,   236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   288,     0,   377,     0,     0,     0,     0,     0,
    1134,    48,   290,   291,   292,   293,     0,     0,     0,     0,
       0,     0,   582,   207,   628,     0,     0,   587,     0,     0,
     523,     0,   207,     0,     0,     0,     0,     0,     0,     0,
     127,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   710,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   641,     0,     0,     0,   642,   643,     0,   644,
       0,     0,     0,     0,     0,     0,   655,   656,     0,   657,
     658,     0,   659,     0,   660,     0,     0,     0,     0,     0,
     207,     0,     0,   275,   276,     0,   277,   368,   368,     0,
     207,   582,   127,     0,     0,   207,     0,     0,     0,   676,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   127,   278,     0,     0,     0,     0,     0,   279,     0,
       0,     0,   280,   687,     0,   281,   282,   272,   283,   284,
     285,    43,    44,     0,   286,   287,     0,     0,     0,     0,
       0,     0,   332,   363,     0,     0,     0,     0,   701,     0,
       0,     0,     0,     0,     0,   705,     0,   288,     0,   377,
     460,     0,   937,     0,     0,    47,    48,   290,   291,   292,
     293,   207,     0,     0,   412,     0,     0,     0,     0,   214,
       0,   412,     0,   207,     0,     0,     0,     0,     0,     0,
       0,     0,   275,   276,     0,   277,     0,     0,     0,     0,
     743,   207,     0,     0,     0,     0,     0,   127,     0,     0,
       0,     0,   754,     0,   368,     0,     0,     0,     0,     0,
       0,   278,     0,     0,     0,   207,     0,   279,     0,   214,
       0,   280,     0,     0,   281,   282,   272,   283,   284,   285,
      43,    44,     0,   286,   287,     0,     0,   412,     0,   779,
       0,   275,   276,     0,   277,     0,     0,     0,   789,     0,
       0,   790,     0,     0,     0,     0,   288,     0,   377,     0,
       0,   523,     0,   523,    47,    48,   290,   291,   292,   293,
     278,     0,     0,   811,     0,     0,   279,     0,     0,     0,
     280,     0,     0,   281,   282,   272,   283,   284,   285,    43,
      44,   207,   286,   287,     0,   412,   373,     0,     0,     0,
       0,   523,     0,   523,   412,   578,     0,   412,   581,     0,
       0,     0,     0,     0,     0,   507,   363,   377,   854,     0,
     614,     0,     0,    47,    48,   290,   291,   292,   293,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   162,   207,     0,     0,   638,     0,     0,     0,
       0,     0,     0,     0,   207,   889,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,     0,     0,   412,     0,     0,
       0,     0,     0,   241,     0,     0,     0,     0,     0,     0,
     314,     0,     0,     0,     0,     0,     0,     0,   922,   923,
     338,     0,     0,     0,     0,     0,     0,     0,   930,   363,
       0,   380,   380,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,     0,     0,     0,     0,   947,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   207,     0,     0,     0,   412,     0,     0,   363,     0,
       0,     1,     2,   202,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,  -307,   980,
      28,    29,    30,    31,     0,     0,   981,    32,     0,   475,
      33,     0,     0,   363,     0,     0,     0,     0,     0,     0,
       0,     0,   983,     0,   984,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   994,    36,     0,
      37,     0,    38,   998,     0,    40,    41,     0,     0,  -307,
       0,     0,     0,     0,  1041,     0,   412,   412,  1042,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   793,   363,     0,     0,     0,
       0,     0,     0,     0,    46,     0,   207,     0,     0,   614,
      47,    48,   614,   614,     0,     0,     0,     0,     0,   614,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   832,
       0,   363,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   363,     0,     0,     0,     0,     0,     0,     0,     0,
     363,   363,   275,   276,   380,   277,     0,     0,     0,     0,
       0,     0,  1114,     0,     0,     0,   363,     0,     0,     0,
     412,   875,     0,     0,   412,   879,     0,     0,     0,     0,
       0,   278,     0,   882,     0,     0,     0,   279,     0,     0,
       0,   280,     0,   352,   281,   282,   272,   283,   284,   285,
      43,    44,     0,   286,   287,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   363,   614,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   512,   314,   377,  1179,
       0,     0,     0,     0,    47,    48,   290,   291,   292,   293,
       0,     0,     0,     0,     0,     0,     0,   704,     0,     0,
       0,     0,   363,     0,     0,     0,     0,   207,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1209,     0,     0,     0,     0,  1211,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1216,     0,     0,     0,
     740,     0,   412,     0,     0,     0,     0,     0,     0,     0,
     749,     0,     0,     0,     0,   740,     0,   207,   740,   614,
    1238,   614,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   758,   614,  1246,     0,     0,     0,  1247,     0,     0,
    1248,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1257,  1258,     0,     0,
       0,   787,     0,     0,     0,     0,     0,     0,   338,     0,
       0,     0,     0,   749,  1269,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   352,     0,   812,     0,
       0,   352,   352,     0,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   363,     0,
       0,     0,   352,     0,     0,   412,   352,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   614,   614,     0,
     853,     0,     0,     0,     0,     0,     0,     0,   380,  1315,
       0,     0,   353,     0,     0,     0,     0,     0,     0,   363,
       0,     0,     0,   207,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   412,  1111,     0,     0,     0,     0,     0,     0,   352,
       0,   363,     0,     0,     0,     0,     0,   412,  1124,     0,
     614,   614,  1131,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   363,   363,     0,     0,     0,     0,     0,   352,
       0,     0,     0,     0,     0,     0,     0,     0,  1372,   740,
    1373,     0,     0,     0,     0,     0,     0,     0,   352,   749,
    1376,   936,  1377,     0,   939,     0,     0,     0,     0,     0,
     946,     0,     0,     0,     0,     0,     0,  1384,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1403,  1405,   412,     0,   412,
       0,   412,     0,   352,     0,     0,   412,     0,  1413,     0,
       0,   963,   964,  1414,     0,     0,  1216,     0,     0,     0,
       0,     0,   614,     0,     0,     0,     0,   338,     0,     0,
       0,     0,  1432,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1439,     0,     0,  1441,     0,  1443,  1445,  1447,
       0,     0,     0,     0,     0,   353,     0,     0,     0,     0,
     353,   353,     0,   363,     0,   352,   352,     0,     0,   352,
     992,     0,     0,     0,   380,     0,     0,     0,     0,     0,
       0,   353,     0,   275,   276,   353,   277,  1481,     0,  1483,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1216,
       0,   352,     0,     0,   352,   338,     0,     0,     0,  1499,
       0,   352,   278,   352,     0,     0,     0,   352,   279,     0,
     352,   352,   280,     0,     0,   281,   282,   272,   283,   284,
     285,    43,    44,     0,   286,   287,   352,     0,     0,     0,
     314,     0,   412,     0,     0,     0,   338,   412,   353,     0,
       0,     0,     0,   380,     0,   352,     0,   515,   939,   377,
     363,   740,     0,     0,     0,    47,    48,   290,   291,   292,
     293,   352,     0,     0,     0,     0,     0,     0,   353,     0,
       0,  1118,     0,     0,   352,     0,   352,     0,     0,     0,
       0,     0,  1136,     0,     0,     0,     0,   353,     0,     0,
       0,     0,     0,     0,     0,     0,   363,   363,     0,     0,
       0,     0,   380,     0,  1153,     0,     0,     0,     0,     0,
       0,     0,   352,     0,     0,     0,     0,     0,     0,   939,
     939,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     125,     0,   353,     0,     0,   412,  1369,     0,     0,   412,
       0,     0,     0,     0,     0,     0,  1184,     0,   352,     0,
       0,     0,     0,     0,   354,     0,     0,     0,   352,   352,
       0,     0,   352,     0,   352,   352,     0,     0,     0,     0,
     352,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   234,     0,     0,     0,     0,
       0,     0,     0,     0,   353,   353,     0,     0,   353,   939,
       0,   244,     0,   245,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     853,     0,     0,   363,     0,     0,     0,     0,     0,     0,
     353,     0,     0,   353,   275,   276,     0,   277,  1249,  1250,
     353,     0,   353,     0,     0,     0,   353,     0,     0,   353,
     353,     0,     0,     0,     0,     0,     0,     0,   352,     0,
       0,     0,     0,   278,     0,   353,     0,     0,     0,   279,
       0,     0,     0,   280,     0,     0,   281,   282,   272,   283,
     284,   285,    43,    44,   353,   286,   287,     0,     0,   413,
     414,     0,     0,     0,   418,     0,   420,   421,     0,   352,
     353,     0,     0,     0,     0,     0,     0,     0,   288,     0,
     377,     0,     0,   353,   412,   353,   703,    48,   290,   291,
     292,   293,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   352,     0,     0,   352,     0,     0,   354,     0,     0,
       0,     0,   354,   354,   412,   412,     0,     0,     0,   352,
     352,   353,   352,   352,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   354,     0,     0,     0,   354,     0,     0,
       0,     0,     0,     0,   412,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   353,     0,  1359,
       0,     0,     0,   740,     0,     0,     0,   353,   353,     0,
       0,   353,     0,   353,   353,     0,     0,     0,     0,   353,
     352,   352,     0,     0,     0,     0,     0,     0,     0,   275,
     276,     0,   277,     0,     0,     0,     0,     0,     0,     0,
     354,     0,     0,     0,     0,     0,   585,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   278,     0,
       0,     0,     0,     0,   279,   629,     0,     0,   280,     0,
     354,   281,   282,   272,   283,   284,   285,    43,    44,     0,
     286,   287,     0,     0,     0,     0,     0,     0,     0,   354,
       0,     0,     0,   352,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   288,     0,   377,     0,   353,     0,     0,
       0,   336,    48,   290,   291,   292,   293,   670,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   354,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   353,     0,
       0,     0,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,     0,     0,    28,    29,    30,     0,     0,     0,
     353,     0,     0,   353,    33,   894,     0,     0,   352,     0,
     352,     0,     0,     0,     0,     0,   354,   354,   353,   353,
     354,   353,   353,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,     0,     0,     0,     0,   352,     0,    40,
      41,     0,     0,     0,     0,   352,   352,   352,     0,     0,
       0,     0,   354,     0,     0,   354,   352,   352,   314,     0,
       0,     0,   354,     0,   354,     0,     0,     0,   354,     0,
       0,   354,   354,     0,     0,     0,     0,     0,   736,   353,
     353,     0,   895,     0,    47,    48,     0,   354,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   785,   786,     0,   354,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   354,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   354,   818,   354,     0,   821,
     822,     0,   825,     0,   827,   828,     0,     0,     0,   830,
     831,     0,   353,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   354,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   352,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   873,     0,     0,     0,   877,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   354,
       0,     0,   352,     0,     0,     0,     0,     0,     0,   354,
     354,     0,     0,   354,     0,   354,   354,     0,     0,     0,
       0,   354,     0,     0,     0,     0,     0,     0,     0,     0,
     352,     0,   352,     0,     0,     0,     0,   353,     0,   353,
       0,     0,     0,     0,     0,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,   352,   353,    28,    29,    30,
     352,     0,   352,     0,   353,   353,   353,    33,     0,     0,
       0,     0,     0,     0,     0,   353,   353,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    36,     0,     0,     0,   354,
       0,     0,    40,    41,     0,     0,     0,     0,     0,     0,
    -541,     0,     0,     1,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
     354,   247,    28,    29,    30,    31,     0,    47,    48,    32,
       0,     0,    33,    34,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   354,     0,     0,   354,     0,    35,     0,     0,
      36,     0,    37,     0,    38,    39,     0,    40,    41,    42,
     354,   354,     0,   354,   354,     0,     0,     0,    43,    44,
       0,     0,   353,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,  -307,    45,     0,    46,     0,     0,     0,
       0,   353,    47,    48,     0,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   354,   354,     0,     0,     0,     0,     0,     0,   353,
       0,   353,     0,    36,  1109,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -307,     0,     0,     0,     0,     0,
    1122,     0,     0,  1126,  1129,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   353,     0,     0,     0,     0,   353,
       0,   353,     0,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,     0,   354,   334,    29,    30,     0,     0,
       0,     0,     0,     0,     0,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1188,     0,     0,     0,
       0,     0,     0,    36,     0,     0,     0,     0,     0,     0,
     203,    41,     0,     0,  1205,  1206,     0,     0,     1,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,     0,     0,    28,    29,    30,
      31,     0,     0,     0,    32,    47,    48,    33,    34,   354,
       0,   354,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1126,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,     0,     0,    36,     0,    37,   354,    38,
      39,     0,    40,    41,    42,     0,   354,   354,   354,     0,
       0,     0,     0,    43,    44,     0,     0,   354,   354,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
       0,    46,     0,  1290,     0,  -545,     0,    47,    48,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1300,     0,     0,     0,     1,     2,   202,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,     0,     0,    28,    29,    30,    31,     0,
       0,     0,    32,   275,   276,    33,  1001,  1002,     0,  1003,
       0,     0,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
       0,     0,     0,  1012,     0,     0,     0,  1013,  1014,     0,
    1015,     0,   278,    36,     0,    37,     0,    38,  1016,     0,
    1017,  1018,  1019,     0,   354,   281,   282,   272,   283,   284,
     285,    43,    44,     0,   286,   287,     0,     0,  1367,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   354,     0,     0,     0,   288,     0,   289,
       0,     0,   168,     0,     0,    47,    48,   290,   291,   292,
     293,     0,     0,     0,     0,  1020,     0,     0,     0,     0,
    -134,   354,     0,   354,     0,     0,     0,     0,     1,     2,
     202,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,     0,   354,    28,    29,    30,
      31,   354,     0,   354,    32,   275,   276,    33,   277,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,  -308,
       0,     0,     0,     0,   278,    36,     0,    37,     0,    38,
     279,    33,    40,    41,   280,     0,     0,   281,   282,   272,
     283,   284,   285,    43,    44,     0,   286,   287,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    36,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   288,
    -308,   289,     0,     0,     0,     0,     0,    47,    48,   290,
     291,   292,   293,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -134,     1,     2,   202,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
       0,     0,    28,    29,    30,    31,     0,     0,     0,    32,
     275,   276,    33,   277,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,     0,     0,    28,    29,    30,   278,
      36,     0,    37,     0,    38,   279,    33,    40,    41,   280,
       0,     0,   281,   282,   272,   283,   284,   285,    43,    44,
       0,   286,   287,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    36,     0,     0,     0,     0,     0,
       0,    40,    41,     0,   288,     0,   289,     0,     0,     0,
       0,     0,    47,    48,   290,   291,   292,   293,     2,   202,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,     0,     0,   334,    29,    30,     0,
       0,     0,     0,     0,   275,   276,    33,   277,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,     0,     0,
     334,    29,    30,   278,    36,     0,    37,     0,    38,   279,
      33,    40,    41,   280,     0,     0,   281,   282,   272,   283,
     284,   285,    43,    44,     0,   286,   287,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    36,     0,
       0,     0,     0,     0,     0,    40,    41,     0,   288,     0,
     335,     0,     0,     0,     0,   748,   336,    48,   290,   291,
     292,   293,     2,   202,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,     0,     0,
     334,    29,    30,     0,     0,     0,     0,     0,   275,   276,
      33,   277,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,     0,     0,    28,    29,    30,   278,    36,     0,
      37,     0,    38,   279,    33,    40,    41,   280,     0,     0,
     281,   282,   272,   283,   284,   285,    43,    44,     0,   286,
     287,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,     0,     0,     0,     0,     0,     0,   203,
      41,     0,   288,     0,   335,     0,     0,     0,     0,   748,
      47,    48,   290,   291,   292,   293,     2,   202,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,     0,     0,   334,    29,    30,     0,     0,     0,
       0,     0,   275,   276,    33,   277,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   278,    36,     0,    37,     0,    38,   279,     0,    40,
      41,   280,     0,     0,   281,   282,   272,   283,   284,   285,
      43,    44,     0,   286,   287,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   288,     0,   335,     0,
       0,     0,     0,     0,   336,    48,   290,   291,   292,   293,
       2,   202,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     0,     0,   334,    29,
      30,     0,     0,     0,     0,     0,   275,   276,    33,   277,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   278,    36,     0,    37,     0,
      38,   279,     0,   203,    41,   280,     0,     0,   281,   282,
     272,   283,   284,   285,    43,    44,     0,   286,   287,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     288,     0,   960,     0,     0,     0,     0,     0,   961,    48,
     290,   291,   292,   293,     2,   202,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
       0,     0,   334,    29,    30,     0,     0,     0,     0,     0,
     275,   276,    33,   277,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   278,
      36,     0,    37,     0,    38,   279,     0,   203,    41,   280,
       0,     0,   281,   282,   272,   283,   284,   285,    43,    44,
       0,   286,   287,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   288,     0,   377,     0,     0,     0,
       0,     0,    47,    48,   290,   291,   292,   293,     1,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,     0,     0,    28,    29,    30,
      31,     0,     0,     0,    32,     0,     0,    33,    34,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,     0,     0,    36,     0,    37,     0,    38,
      39,     0,    40,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,    43,    44,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
       0,    46,     0,     0,     0,     0,     0,    47,    48,   201,
       2,   202,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     0,     0,    28,    29,
      30,     0,     0,     0,     0,     0,     0,     0,    33,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,     0,    37,     0,
      38,    39,     0,   203,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,    43,    44,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,     0,   204,     0,     0,     0,     0,     0,    47,    48,
       1,     2,   202,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     0,     0,    28,
      29,    30,    31,     0,     0,     0,    32,     0,     0,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,     0,    37,
       0,    38,     0,     0,    40,    41,   201,     2,   202,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,     0,     0,    28,    29,    30,     0,     0,
       0,     0,     0,    46,     0,    33,     0,     0,     0,    47,
      48,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,    37,     0,    38,     0,     0,
     203,    41,     2,   202,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,     0,     0,
      28,    29,    30,     0,     0,     0,     0,     0,     0,   204,
      33,     0,     0,     0,     0,    47,    48,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    36,     0,
      37,     0,    38,    39,     0,   203,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,    43,    44,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,     0,   204,     0,     0,     0,     0,     0,
      47,    48,     2,   202,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,     0,     0,
     334,    29,    30,     0,     0,     0,     0,     0,     0,     0,
      33,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    36,     0,
      37,     0,    38,     0,     0,    40,    41,     2,   202,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,     0,     0,   334,    29,    30,     0,     0,
       0,     0,     0,  -426,   683,    33,     0,     0,     0,     0,
      47,    48,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,    37,     0,    38,     0,     0,
      40,    41,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1336,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   683,
       0,     0,     0,     0,     0,    47,    48,     2,   202,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,     0,     0,   334,    29,    30,     0,     0,
       0,     0,     0,     0,     0,    33,     0,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     0,     0,    28,
      29,    30,     0,    36,     0,    37,     0,    38,     0,    33,
      40,    41,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1338,     0,     0,    36,     0,     0,
       0,     0,     0,     0,    40,    41,     0,     0,     0,   683,
       0,     0,     0,     0,     0,    47,    48,     2,   202,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    46,     0,   334,    29,    30,     0,    47,
      48,     0,     0,     0,     0,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,    37,     0,    38,     0,     0,
     203,    41,     2,   202,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,     0,     0,
     334,    29,    30,     0,     0,     0,     0,     0,     0,   260,
      33,     0,     0,     0,     0,    47,    48,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    36,     0,
      37,     0,    38,     0,     0,    40,    41,     2,   202,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,     0,     0,    28,    29,    30,     0,     0,
       0,     0,     0,     0,   683,    33,     0,     0,     0,     0,
      47,    48,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,    37,     0,    38,     0,     0,
     203,    41,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,     0,     0,    28,    29,    30,     0,     0,     0,
       0,     0,   275,   276,    33,   277,     0,     0,     0,   204,
       0,     0,     0,     0,     0,    47,    48,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   278,    36,     0,     0,     0,     0,   279,     0,    40,
      41,   280,     0,     0,   281,   282,   272,   283,   284,   285,
      43,    44,     0,   286,   287,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   288,     0,   518,     0,
       0,   168,     0,     0,    47,    48,   290,   291,   292,   293,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
       0,     0,    28,    29,    30,     0,     0,     0,     0,     0,
     275,   276,    33,   277,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   278,
      36,     0,     0,     0,     0,   279,     0,    40,    41,   280,
       0,     0,   281,   282,   272,   283,   284,   285,    43,    44,
       0,   286,   287,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   288,   -40,   289,     0,     0,     0,
       0,     0,    47,    48,   290,   291,   292,   293,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,     0,     0,
      28,    29,    30,     0,     0,     0,     0,     0,   275,   276,
      33,   277,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   278,    36,     0,
       0,     0,     0,   279,     0,    40,    41,   280,     0,     0,
     281,   282,   272,   283,   284,   285,    43,    44,     0,   286,
     287,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   288,     0,   289,     0,     0,     0,     0,     0,
      47,    48,   290,   291,   292,   293,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     0,     0,   334,    29,
      30,     0,     0,     0,     0,     0,   275,   276,    33,   277,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   278,    36,     0,     0,     0,
       0,   279,     0,    40,    41,   280,     0,     0,   281,   282,
     272,   283,   284,   285,    43,    44,     0,   286,   287,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     288,     0,   335,     0,     0,     0,     0,     0,    47,    48,
     290,   291,   292,   293,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,     0,     0,   334,    29,    30,     0,
       0,     0,     0,     0,   275,   276,    33,   277,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   278,    36,     0,     0,     0,     0,   279,
       0,    40,    41,   280,     0,     0,   281,   282,   272,   283,
     284,   285,    43,    44,     0,   286,   287,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   288,     0,
     377,     0,     0,     0,     0,     0,    47,    48,   290,   291,
     292,   293,   463,     2,   202,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     0,
       0,    28,    29,    30,     0,     0,     0,     0,     0,     0,
       0,    33,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,     0,     0,    28,    29,    30,     0,     0,    36,
       0,    37,     0,    38,    33,     0,    40,    41,     0,     0,
       0,     0,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    36,     0,    28,    29,    30,    39,     0,    40,
      41,    42,     0,     0,    33,     0,     0,     0,    -3,     0,
      43,    44,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,     0,     0,     0,    45,    39,    46,   203,
      41,    42,     0,     0,    47,    48,     0,     0,     0,     0,
      43,    44,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,     0,   260,     0,
       0,     0,     0,     0,    47,    48,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     0,     0,    28,    29,
      30,     0,     0,     0,     0,     0,     0,     0,    33,     0,
       0,     0,     0,     0,     0,     0,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    36,     0,    28,    29,
      30,   111,     0,    40,    41,     0,     0,     0,    33,   894,
       0,     0,     0,     0,    43,    44,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,     0,     0,     0,
       0,     0,    46,    40,    41,     0,     0,     0,    47,    48,
       0,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     0,     0,    28,    29,    30,     0,     0,     0,     0,
       0,     0,   736,    33,   894,     0,  1208,     0,    47,    48,
       0,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    36,     0,    28,    29,    30,     0,     0,    40,    41,
       0,     0,     0,    33,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,     0,     0,    28,    29,    30,     0,
       0,    36,     0,     0,     0,     0,    33,   736,   203,    41,
       0,  1294,     0,    47,    48,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    36,     0,     0,     0,     0,     0,
       0,    40,    41,     0,     0,     0,     0,   260,     0,     0,
       0,     0,     0,    47,    48,     0,     0,     0,     0,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     0,
     330,   334,    29,    30,     0,     0,    47,    48,     0,     0,
       0,    33,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,     0,     0,   334,    29,    30,     0,     0,    36,
       0,     0,     0,     0,    33,     0,    40,    41,     0,     0,
       0,     0,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    36,     0,    28,    29,    30,     0,     0,    40,
      41,     0,     0,     0,    33,   247,     0,     0,     0,     0,
       0,    47,    48,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,     0,     0,     0,     0,     0,   330,    40,
      41,     0,     0,     0,    47,    48,     0,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     0,     0,   334,
      29,    30,     0,     0,     0,     0,     0,     0,   736,    33,
       0,     0,     0,     0,    47,    48,     0,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    36,     0,   334,
      29,    30,     0,     0,   203,    41,     0,     0,     0,    33,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
       0,     0,   334,    29,    30,     0,     0,    36,     0,     0,
       0,     0,    33,   260,    40,    41,     0,     0,     0,    47,
      48,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      36,     0,     0,     0,     0,     0,     0,    40,    41,     0,
       0,     0,     0,   683,     0,     0,     0,     0,     0,    47,
      48,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   736,     0,     0,     0,
       0,     0,    47,    48,     2,   202,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
       0,     0,   334,    29,    30,     0,     0,     0,     0,     0,
       0,     0,    33,     0,   275,   276,     0,   277,  1002,     0,
    1003,     0,     0,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,     0,     0,  1529,  1012,     0,     0,     0,  1013,  1014,
      36,  1015,    37,   278,    38,     0,     0,    40,    41,  1016,
       0,   171,   172,  1019,     0,     0,   281,   282,   272,   283,
     284,   285,    43,    44,     0,   286,   287,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -439,     0,     0,   288,     0,
     377,     0,     0,   168,     0,     0,    47,    48,   290,   291,
     292,   293,     0,     0,   275,   276,  1020,   277,  1002,     0,
    1003,  -134,     0,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,     0,     0,     0,  1012,     0,     0,     0,  1013,  1014,
       0,  1015,     0,   278,     0,     0,     0,     0,     0,  1016,
       0,   171,   172,  1019,     0,     0,   281,   282,   272,   283,
     284,   285,    43,    44,     0,   286,   287,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   288,     0,
     377,     0,     0,   168,     0,     0,    47,    48,   290,   291,
     292,   293,     0,     0,     0,     0,  1020,     0,     0,     0,
       0,  -134,     2,   202,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,     0,     0,
     334,    29,    30,     0,     0,     0,     0,     0,     0,     0,
      33,     0,   275,   276,     0,   277,  1002,     0,  1003,  1388,
    1389,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,     0,
       0,  1529,  1012,     0,     0,     0,  1013,  1014,    36,  1015,
      37,   278,    38,     0,     0,    40,    41,  1016,     0,   171,
     172,  1019,     0,     0,   281,   282,   272,   283,   284,   285,
      43,    44,     0,   286,   287,     0,     0,     0,     0,  1301,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   288,     0,   377,     0,
       0,   168,     0,     0,    47,    48,   290,   291,   292,   293,
       0,     0,   275,   276,  1020,   277,  1002,     0,  1003,  1388,
    1389,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,     0,
       0,     0,  1012,     0,     0,     0,  1013,  1014,     0,  1015,
       0,   278,     0,     0,     0,     0,     0,  1016,     0,   171,
     172,  1019,     0,     0,   281,   282,   272,   283,   284,   285,
      43,    44,     0,   286,   287,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   288,     0,   377,     0,
       0,   168,     0,     0,    47,    48,   290,   291,   292,   293,
       0,     0,   275,   276,  1020,   277,  1002,     0,  1003,     0,
       0,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,     0,
       0,     0,  1012,     0,     0,     0,  1013,  1014,     0,  1015,
       0,   278,     0,     0,     0,     0,     0,  1016,     0,   171,
     172,  1019,     0,     0,   281,   282,   272,   283,   284,   285,
      43,    44,     0,   286,   287,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   288,     0,   377,     0,
       0,   168,     0,     0,    47,    48,   290,   291,   292,   293,
       0,     0,     0,     0,  1020,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,     0,     0,    28,    29,    30,
       0,     0,     0,     0,     0,     0,     0,    33,   201,     2,
     202,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    36,     0,    28,    29,    30,
     111,     0,    40,    41,     0,     0,     0,    33,     0,     0,
       0,     0,     0,    43,    44,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    36,     0,    37,     0,    38,
       0,     0,   203,    41,   463,     2,   202,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     0,     0,    28,    29,    30,     0,     0,     0,     0,
       0,     0,     0,    33,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    36,     0,    37,     0,    38,     0,     0,    40,    41,
       2,   202,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     0,     0,   334,    29,
      30,     0,     0,     0,     0,     0,     0,     0,    33,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,     0,    37,     0,
      38,     0,     0,   203,    41,     2,   202,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     0,     0,    28,    29,    30,     0,     0,     0,     0,
       0,     0,     0,    33,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    36,     0,    37,     0,    38,     0,     0,   203,    41,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
       0,     0,    28,    29,    30,   482,   483,   484,   485,     0,
       0,     0,    33,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      36,     0,     0,     0,     0,     0,     0,    40,    41
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-1346))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       0,     1,     0,    45,   180,    45,     1,   180,     1,   200,
     117,   180,    51,    45,   180,   451,   603,   180,     0,   651,
     180,  1050,   180,   341,   532,   722,   603,   479,   900,   165,
     166,    31,    32,   183,    34,   215,    34,   341,  1010,     0,
      34,   622,   865,  1388,   600,    45,  1050,  1050,     1,  1311,
    1097,    51,    34,    51,   514,    45,   983,   984,    58,   568,
     600,   106,   865,    63,    66,    63,    66,    45,    66,    69,
    1392,    69,   600,    34,    69,   114,   493,     0,     1,   255,
     497,    66,   255,    67,    42,   337,   255,   416,   479,   255,
     197,   154,   255,   600,    45,   255,    42,   255,    51,    47,
      48,   251,   252,   600,    30,   144,   435,   107,   153,    54,
     110,    34,   600,    90,   443,   342,   246,   117,  1463,   363,
     600,   984,    42,   367,   337,   125,   100,  1052,   424,   425,
     114,     0,  1269,   118,    42,   137,   604,  1056,   180,  1058,
     180,   118,   610,    47,    48,   145,    69,   145,   180,    84,
     363,   224,  1414,   106,   367,    81,   114,   157,   116,   157,
     134,   114,   101,   181,   237,    34,   205,    56,   486,   114,
     116,   119,   157,   713,  1496,  1047,   114,   101,  1001,  1501,
     180,   181,    42,   181,  1231,   713,  1233,  1234,   127,   288,
     180,   144,   133,   114,   114,   136,   116,   197,  1001,   495,
     153,     0,   180,   127,  1526,   205,   114,   205,   116,    98,
      42,  1533,     0,   255,   214,   255,   120,   217,   514,   217,
      51,   114,   261,   255,   224,   733,   813,   479,   408,   180,
     112,   181,   217,   713,   234,    34,   813,   237,   256,  1013,
    1014,   241,   242,   241,   800,   947,    34,   241,   201,   242,
     641,   642,   205,    42,   136,   255,   256,    45,   256,   241,
     800,   300,   262,    51,   249,   265,   657,   114,   115,   254,
       0,     1,   800,  1198,   783,    63,     0,    42,    66,   575,
     241,    69,   114,   114,   116,   246,   416,   332,   920,    47,
      48,   743,   994,   800,    84,  1432,   114,  1269,   337,   603,
     189,   114,  1439,   800,    34,   435,   256,   114,   261,   117,
      34,   264,   800,   443,   705,   422,    42,   135,   241,  1093,
     800,   428,   322,   212,   322,   114,   116,   116,   642,   136,
    1257,  1258,   909,   222,   802,   288,    66,   121,   115,    69,
     340,   341,   586,   657,   121,    69,   119,   300,  1211,   114,
    1501,   116,   743,   137,  1051,     0,  1179,   145,   687,    42,
      42,   119,  1499,   590,   364,     3,    42,   430,   368,   157,
     622,  1501,   241,   586,   205,  1347,  1179,   246,   378,   332,
     632,   962,  1533,   117,   402,   424,   425,   121,   114,    34,
     116,   705,   180,   181,   638,  1258,  1526,  1443,   625,   288,
     143,   908,   402,  1533,   402,     0,   115,   634,   507,   622,
     509,   908,   451,   512,   124,   125,   515,   205,    42,   632,
     908,    66,   422,   115,   154,   638,   135,     3,   428,   217,
     261,   114,   114,   116,   116,  1481,   121,  1483,   114,    34,
     116,   460,   241,   135,   429,   722,  1269,   246,   121,     0,
    1147,  1148,   402,   241,   114,   416,   495,  1384,    42,   477,
    1092,   524,   135,   463,  1436,   692,  1438,   255,   468,   300,
     463,   424,   425,   115,   435,   514,  1505,   477,   930,   477,
     707,   481,   443,   481,   469,   945,   486,   217,   924,   489,
     114,   743,   116,   135,   494,   813,  1073,     0,   451,   481,
     777,  1505,  1505,   971,   972,   922,   116,   122,   118,   813,
     463,   241,   115,   128,   129,   136,   652,   241,   121,    10,
     481,  1384,   246,  1466,   587,   135,   526,   477,  1500,  1472,
     114,   531,   116,   526,   322,   115,   575,   115,   531,   930,
     493,   121,   495,   121,   497,   114,   114,   416,   116,   793,
    1475,   440,   659,   341,   507,  1498,   509,   687,   481,   512,
    1503,   514,   515,   670,     0,     1,   435,   115,   795,    97,
      98,   701,   217,   121,   443,   121,   465,   854,   641,   642,
     793,  1506,   114,   622,    75,   585,    77,    78,   121,   641,
     642,   137,   983,   632,   657,   913,   241,   121,    34,   121,
     600,   115,   115,   603,   137,   657,    84,    75,   121,  1432,
    1535,   135,   481,  1315,   402,   137,  1439,   416,   507,   114,
      88,    89,   575,   512,   624,    75,   515,    77,    78,   629,
      66,   114,   114,    69,   116,   488,   435,    51,    88,    89,
     122,   123,   705,   643,   443,   277,   241,   647,   116,    63,
     114,   246,    66,   705,   136,    69,   656,   676,   658,   659,
     660,   121,  1114,   121,   121,   658,   116,   660,   300,   301,
     670,   115,   852,   950,  1376,  1377,  1499,   137,   930,   137,
     137,    75,   481,   114,    10,    11,    12,    13,    14,   121,
     114,  1388,   416,   481,    88,    89,   121,   342,   486,   699,
     430,   114,   337,   135,   115,   337,   699,   115,   343,   121,
     962,   435,   137,   713,   714,   115,    42,   702,   587,   443,
     720,   998,   858,  1114,   724,   137,   687,   115,   363,   121,
     880,   145,   367,    95,    96,   115,   120,   690,   965,   121,
     701,   121,   121,   157,    70,   137,   470,   379,   115,   962,
     114,   481,   605,  1450,   121,   137,   609,   481,   137,  1211,
     779,   121,   615,    75,   717,  1462,  1463,   181,   130,   131,
     789,   790,   115,   114,  1051,   116,    88,    89,   121,  1287,
      67,   217,   801,   636,   975,   121,   675,   640,   114,  1486,
     116,   205,   115,   114,   524,   684,   122,   123,   121,   688,
     800,   137,   114,   217,   116,   241,   114,    10,    11,    12,
      13,    14,   600,   813,    70,   603,   119,    73,   687,   121,
      76,   416,    78,   115,   469,   115,   889,   115,   137,   121,
      86,   121,   701,   121,     3,   137,   481,   137,    75,    42,
     435,    10,    11,    12,    13,    14,   117,   114,   443,   116,
     121,    88,    89,   288,   137,   122,   123,   587,   858,   690,
     996,  1558,  1114,  1043,   864,   865,  1257,    70,   117,   115,
    1147,  1148,   121,    42,  1050,   121,   115,  1050,   896,   116,
     115,  1050,   121,   865,  1050,   924,   481,  1050,   687,   114,
    1050,   116,  1050,    75,    93,    94,   896,   122,   123,   899,
      82,    70,   701,    85,   865,    87,    88,    89,   322,   115,
     117,   641,   642,   913,   121,   121,   548,   549,   550,   119,
     983,   984,    84,   962,   115,   713,   714,   657,   923,   672,
     121,   931,   117,   114,   116,   114,   121,   937,   931,   115,
    1484,   894,   865,   943,  1488,   121,   896,   947,   120,   121,
     943,   586,   208,    75,   947,    77,    78,    79,   115,  1211,
     123,   980,   981,   687,   121,   132,    88,    89,   133,   922,
     923,   924,    75,   115,   116,   705,  1083,   701,    99,    82,
     625,   116,    85,   836,    87,    88,    89,   622,   402,   424,
     425,   117,   114,   117,   994,   115,   865,   632,    61,    62,
     923,   994,   891,   638,  1004,   120,   121,  1007,  1008,  1009,
      47,    48,   800,   116,    10,    11,    12,    13,    14,  1001,
     889,   115,  1041,  1042,   115,   813,  1098,  1099,    75,   115,
    1048,   115,    79,   115,  1052,   114,   115,   116,  1038,   137,
    1001,    88,    89,   551,   552,   481,    42,   692,  1048,   114,
    1050,   117,  1052,   555,   556,   557,   558,   702,   114,   115,
     116,   914,   707,   894,  1064,   116,   865,   114,    75,   116,
      77,    78,   507,   119,    70,   122,   123,   512,  1001,   119,
     515,    88,    89,  1083,   553,   554,  1522,   136,   344,   345,
     121,   347,   687,   349,   114,   115,   116,  1097,  1048,   114,
     115,   116,  1052,   136,  1097,   361,   701,   114,   896,   119,
     114,  1388,   119,   137,  1067,   747,   559,   560,   114,   117,
     116,   115,   115,  1012,   135,   913,   122,   123,   117,     3,
      75,   566,  1001,   117,    79,   865,    10,    11,    12,    13,
      14,   865,   121,    88,    89,   135,  1209,   135,    31,    75,
     795,    77,    78,    79,  1154,    61,    62,    63,   793,   889,
     115,   796,    88,    89,   115,   119,   115,   120,    42,   114,
     120,   114,   120,  1450,   121,   115,   115,   122,   123,  1179,
    1198,     0,     1,   439,   121,  1462,  1463,   115,   115,   121,
    1209,   115,   115,   923,  1257,  1258,    70,  1179,  1198,   115,
     115,   115,  1001,    75,   115,    77,    78,    79,   115,  1486,
      75,   137,    77,    78,    79,    34,    88,    89,  1179,  1238,
     865,  1216,   115,    88,    89,   115,    45,  1246,  1247,  1248,
     115,  1231,    51,  1233,  1234,   115,  1067,  1190,  1231,   115,
    1233,  1234,   115,   120,    63,   115,    31,    66,  1198,  1476,
      69,   115,   136,   983,   984,    75,  1179,    77,    78,    79,
    1048,   119,  1050,  1216,  1052,   137,  1373,   115,    88,    89,
     865,  1001,    75,   117,    77,    78,    79,  1001,   121,   117,
     115,  1558,  1300,   115,   121,    88,    89,   106,   119,   115,
    1290,    58,   115,  1216,   114,   114,   116,   121,   117,   118,
    1300,   115,   122,   123,    75,   121,    77,    78,  1269,   114,
    1179,    11,   114,   114,   114,  1315,  1311,    88,    89,   122,
     965,  1384,  1315,   114,   135,   144,   145,   962,   135,  1505,
     962,   135,  1505,   121,   153,   154,  1505,   120,   157,  1505,
     107,  1341,  1505,   110,  1344,  1505,  1269,  1505,   119,   115,
    1300,   137,   115,    75,   135,  1350,  1001,   135,  1311,  1190,
      82,   180,   181,    85,  1349,    87,    88,    89,  1475,  1001,
     115,   133,  1372,  1373,   120,   119,  1376,  1377,   197,   120,
    1179,   115,   117,  1376,  1377,   121,   205,   117,  1311,  1278,
     115,   115,  1392,   120,  1413,   115,    32,  1397,   217,    75,
    1269,    77,    78,    79,   117,   117,  1001,    66,   117,   115,
    1198,    50,    88,    89,  1399,   117,    75,    86,    75,  1414,
      77,    78,   241,   117,   117,   115,  1426,  1350,   115,   865,
     249,    88,    89,   137,   137,   254,   255,   256,   114,   137,
     137,   137,   261,     3,   115,   115,   676,   214,   120,  1179,
      10,    11,    12,    13,    14,  1179,   120,   114,   114,   118,
     115,  1414,   119,  1505,   117,  1505,   117,   117,   865,   288,
    1269,  1432,   117,  1505,   117,  1475,   117,  1477,  1439,   117,
     115,   300,    42,  1522,  1477,   114,  1216,   923,  1506,   125,
     114,  1414,    63,   114,   119,   262,  1496,   316,   157,   115,
     115,  1501,   101,   322,   117,  1505,  1506,   117,  1506,  1432,
      70,   115,  1300,   332,   117,   115,  1439,  1535,   337,   101,
     114,   114,   341,   342,  1524,   137,  1526,  1257,  1258,   120,
    1530,   115,   115,  1533,  1179,  1535,   115,  1535,  1499,  1269,
     115,   121,    45,  1286,   363,  1269,  1546,   135,   367,   779,
    1550,  1440,   137,  1442,   115,   101,  1506,   115,   217,   789,
     790,   137,   101,  1432,   137,  1001,   135,   137,  1568,  1522,
    1439,   801,   117,   340,    75,  1568,  1499,   115,    79,  1579,
     137,  1311,   115,   402,  1179,  1535,  1579,    88,    89,    66,
     249,  1480,   135,  1482,   114,   254,   121,   364,   234,   120,
     117,   368,   117,   422,   117,   424,   425,  1004,   137,   428,
    1441,   430,  1443,   114,   137,   115,   114,  1360,   120,  1349,
    1350,   122,   123,   120,  1269,   115,  1350,   115,   135,   265,
    1499,   115,   451,  1432,   115,   115,   114,    54,   137,    56,
    1439,   118,    59,    60,    61,  1534,   137,  1536,   115,   468,
    1481,   137,  1483,   561,  1384,   137,   565,  1020,   477,    76,
     479,   562,   481,   563,   942,  1554,  1555,   486,  1411,  1399,
     564,  1463,    89,    90,  1269,  1179,   495,  1352,  1550,  1279,
     157,  1543,  1439,   342,  1414,  1489,  1038,  1048,   507,   894,
     509,  1300,  1058,   512,   724,   514,   515,   916,   858,   937,
    1499,   653,  1432,   717,  1349,   524,    75,   915,  1432,  1439,
    1216,   481,   567,    82,   732,  1439,    85,  1505,    87,    88,
      89,   567,   567,  1158,  1159,    75,  1161,    77,    78,    79,
      -1,    -1,  1167,    -1,    -1,  1170,    -1,    -1,    88,    89,
     217,  1484,   378,  1179,    -1,  1488,  1489,   116,   567,   568,
     980,   981,    -1,    -1,  1399,    -1,   575,   234,     4,     5,
       6,     7,     8,     9,    -1,   182,    -1,   586,   587,  1499,
     429,   590,   249,  1516,    -1,  1499,    -1,   254,    -1,    -1,
    1216,   600,  1179,    -1,   603,    -1,   445,  1432,    75,    -1,
      77,    78,    79,    -1,  1439,    -1,  1539,    -1,    -1,    -1,
    1543,    88,    89,   622,    -1,    -1,  1441,    -1,  1443,    -1,
     469,  1041,  1042,   632,    -1,   634,    -1,    -1,    75,   638,
      77,    78,   641,   642,  1567,    -1,    72,   114,    74,   116,
      -1,    88,    89,  1269,    -1,   122,   123,  1432,   657,    -1,
     659,    -1,    -1,    -1,  1439,    -1,  1481,    -1,  1483,   136,
      -1,   670,    -1,   489,  1499,    -1,    -1,   624,   494,    75,
      -1,    77,    78,    79,    -1,   342,    -1,    -1,    -1,    -1,
      -1,   690,    88,    89,    -1,  1311,   643,    -1,     4,     5,
       6,     7,     8,     9,    -1,    -1,   705,   706,   707,   656,
      -1,   137,    -1,  1290,   713,   714,    -1,    -1,   114,    -1,
     116,    -1,    58,    -1,  1499,    -1,   122,   123,  1343,    35,
      -1,    -1,    -1,  1349,  1350,   275,    -1,   277,   278,   336,
      -1,   338,    -1,    -1,   743,    -1,   286,   287,    86,    -1,
      -1,   590,    90,    91,    92,    -1,    -1,    -1,   355,   356,
     300,   301,    -1,    -1,  1341,    -1,    72,  1344,    74,   585,
      -1,   107,   429,    -1,   110,    -1,   114,    -1,   116,    -1,
     118,   119,    -1,  1399,   783,    -1,   625,     4,     5,     6,
       7,     8,     9,    -1,   793,   634,   795,   337,  1414,    -1,
      -1,   800,    86,    -1,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,   469,   629,   813,  1392,  1432,    -1,   185,    -1,
    1397,    -1,    -1,  1439,    -1,   192,    -1,    -1,  1238,    -1,
     114,   647,   116,    -1,   118,   119,  1246,  1247,  1248,   379,
      -1,    -1,    10,    11,    12,    13,    14,    -1,    75,  1426,
      77,    78,    -1,   692,    -1,    72,    -1,    74,    -1,    -1,
      -1,    88,    89,   702,    -1,    -1,   865,    -1,   707,    -1,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,   214,    -1,
      -1,    -1,    -1,  1499,    -1,    -1,    -1,    -1,    -1,    -1,
     889,   258,    -1,    -1,    -1,   894,    -1,   896,    -1,    -1,
      -1,    -1,    70,    -1,   720,    -1,    -1,    75,   724,   908,
     909,    79,    -1,    -1,   913,    -1,    -1,    -1,    -1,    -1,
      88,    89,    -1,    -1,   923,   924,   262,    -1,    -1,    -1,
      -1,   930,    -1,   590,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,  1524,    -1,   316,
      -1,    -1,    -1,  1530,   122,   123,   795,    -1,   325,    -1,
      -1,   328,    -1,   962,    -1,    -1,    -1,    -1,   625,  1546,
      -1,    -1,   629,  1550,    -1,    -1,    -1,   634,    -1,    -1,
      -1,    -1,    -1,    -1,   983,   984,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1001,  1413,   340,    -1,    -1,    -1,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,    -1,   394,   364,    -1,
      -1,   398,   368,    -1,    -1,   692,    -1,    -1,    -1,    -1,
      -1,    -1,   858,    -1,    -1,   702,    -1,    -1,   864,  1048,
     707,  1050,    -1,  1052,    -1,    -1,    -1,    -1,    -1,    -1,
    1007,  1008,  1009,    -1,    -1,    -1,    -1,    -1,  1067,    -1,
      -1,    -1,    -1,    -1,  1073,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   899,  1083,    -1,    -1,    -1,    -1,    -1,
      10,    11,    12,    13,    14,    -1,   693,    -1,   695,    -1,
      75,    -1,    77,    78,    79,    -1,   703,   704,    -1,   476,
      -1,   708,    -1,    88,    89,  1114,    -1,    -1,    -1,    -1,
      -1,   937,    42,    -1,    -1,    -1,   965,    -1,   725,    -1,
      -1,    -1,    -1,   730,    -1,    -1,    -1,    -1,   795,   114,
      75,   116,    77,    78,    79,    -1,    -1,   122,   123,    -1,
      70,     0,   749,    88,    89,    75,    -1,    77,    78,    79,
     135,    -1,    -1,    10,    11,    12,    13,    14,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
    1179,    -1,   722,    -1,    -1,    34,    -1,   122,   123,    -1,
      -1,  1190,    -1,    -1,   114,    42,   116,    -1,    -1,  1198,
     567,   568,   122,   123,    -1,    -1,    -1,   747,    -1,    -1,
      -1,    -1,  1211,    -1,    -1,    -1,    -1,  1216,    -1,    -1,
      69,    -1,  1038,    70,    -1,    -1,    -1,    -1,    75,    -1,
      77,    78,    79,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    88,    89,    75,    -1,    77,    78,    79,  1064,    -1,
     847,    -1,   849,   850,   851,    -1,    88,    89,  1257,  1258,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,
    1269,   868,    -1,    -1,    -1,   122,   123,    -1,    -1,    -1,
      -1,    -1,   114,    -1,    -1,    -1,    -1,   884,   624,    -1,
     122,   123,    -1,    -1,   661,    -1,    -1,    -1,   665,    -1,
      -1,  1300,    -1,    -1,    -1,   154,    -1,   643,   965,    -1,
     907,    -1,  1311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     656,    -1,    -1,    -1,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1154,    10,
      11,    12,    13,    14,   941,    -1,    -1,    -1,    -1,   946,
    1349,  1350,    -1,    -1,   951,    -1,    42,    -1,    -1,   956,
     957,    -1,    -1,    -1,   961,    -1,   963,   964,    -1,    -1,
     967,    42,    -1,    -1,  1373,    -1,    -1,   226,    -1,   976,
      -1,    -1,    -1,    -1,    70,  1384,    -1,    -1,    -1,    75,
       0,     1,   241,    79,    -1,   992,   993,   246,    -1,    70,
    1399,    -1,    88,    89,    75,    -1,    77,    78,    79,    -1,
     950,    -1,    -1,    -1,    -1,  1414,   783,    88,    89,    -1,
      -1,    -1,   962,    -1,    34,  1372,    -1,  1024,   114,    -1,
    1027,    -1,    -1,  1432,    -1,    -1,   122,   123,    -1,    -1,
    1439,    51,  1441,   114,  1443,   116,    -1,    -1,    -1,    -1,
      -1,   122,   123,    -1,    -1,    -1,    -1,    -1,    -1,    69,
      -1,  1001,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,    -1,    -1,  1475,  1476,    -1,    -1,
      -1,    -1,  1481,  1080,  1483,    -1,    -1,    -1,   337,  1086,
    1087,    -1,    -1,    -1,   343,    -1,   106,   136,  1095,    -1,
    1499,    -1,    -1,  1100,    -1,    -1,  1505,  1506,  1105,    -1,
    1349,  1051,    -1,    -1,   363,    -1,    -1,    -1,   367,    -1,
      -1,  1118,    -1,  1522,    -1,    -1,    -1,    -1,    -1,   865,
      -1,    -1,    -1,    -1,    -1,   145,  1535,  1134,    -1,  1136,
    1137,  1138,  1139,   153,   154,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,  1151,    -1,  1153,    -1,    -1,    -1,
    1399,    -1,    -1,    -1,    -1,    -1,    -1,   416,    -1,    -1,
      -1,   181,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,
      -1,   430,    -1,    -1,    -1,   952,   435,   197,  1185,  1186,
     200,   201,    -1,    -1,   443,   205,    -1,    -1,    -1,    -1,
      -1,   968,    -1,    -1,    -1,    70,    -1,  1147,  1148,    -1,
      75,   460,    77,    78,    79,    -1,   226,    -1,    -1,    -1,
     230,   470,   232,    88,    89,   235,    -1,    -1,    -1,    -1,
     479,   241,   481,    -1,    -1,    -1,   246,  1476,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   256,    -1,    -1,   114,
      -1,    -1,  1249,  1250,   264,    -1,    -1,   122,   123,    -1,
      -1,    -1,  1259,    -1,    -1,    -1,    -1,    -1,  1004,    -1,
      -1,  1007,  1008,  1009,    -1,   524,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1057,    -1,  1349,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    11,    12,
      13,    14,   332,    -1,    -1,    -1,  1323,   337,  1325,  1326,
    1327,    -1,    -1,   343,    -1,    -1,    -1,   586,   587,    -1,
    1337,    -1,  1399,    -1,    -1,    -1,    -1,    -1,  1345,    42,
      -1,  1348,    -1,   363,    -1,    -1,    -1,   367,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   622,    -1,    -1,    -1,    70,  1375,    -1,
      -1,    -1,    75,   632,    77,    78,    79,    -1,    -1,   638,
      -1,    -1,   641,   642,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   416,     0,   657,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1476,
     430,   114,  1419,  1420,    -1,   435,  1193,   676,    -1,   122,
     123,    -1,    -1,   443,    -1,  1432,    -1,    -1,   687,    -1,
      -1,    34,  1439,  1179,    -1,    -1,    -1,    -1,  1388,    -1,
     460,    -1,   701,   463,    -1,    -1,   705,    -1,    -1,  1456,
     470,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   479,
      -1,   481,    -1,    -1,    -1,    -1,    69,  1474,    -1,    -1,
      -1,    -1,  1479,   493,    -1,    -1,    -1,   497,    -1,    -1,
      -1,    -1,    -1,    -1,   743,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1450,    -1,    -1,    -1,   524,  1512,    -1,  1514,    -1,    -1,
      -1,    -1,  1462,  1463,    -1,    -1,    -1,    -1,    -1,  1296,
     779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     789,   790,    -1,    -1,   793,    -1,  1486,   796,    -1,    -1,
      -1,    -1,   801,    -1,  1290,  1552,  1553,    -1,   568,    -1,
      -1,   154,    -1,    -1,    -1,    -1,    -1,    -1,  1565,  1566,
      -1,    -1,    -1,    -1,    -1,    -1,   586,   587,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   603,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1341,    -1,    -1,  1344,    -1,
      -1,    -1,   622,    -1,    -1,    -1,   865,   627,  1558,    -1,
      -1,    -1,   632,    -1,    -1,    -1,    -1,    -1,   638,    -1,
      -1,   641,   642,    -1,    -1,    -1,  1372,    -1,    -1,    -1,
     889,    -1,    -1,    -1,    -1,    -1,    -1,   657,   241,    -1,
      -1,    -1,    -1,   246,    40,    41,  1392,    43,    -1,    -1,
      -1,  1397,    -1,    -1,    -1,    -1,   676,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   687,    -1,    -1,
      -1,   930,    -1,    69,    -1,    -1,    -1,    -1,    -1,    75,
    1426,   701,    -1,    79,    -1,   705,    82,    83,    84,    85,
      86,    87,    88,    89,   714,    91,    92,   717,    -1,    -1,
      -1,    -1,    -1,   962,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
     116,   980,   981,   743,   983,   984,   122,   123,   124,   125,
     126,   127,    -1,    -1,   337,    -1,    -1,    -1,    -1,   135,
     343,    -1,  1001,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1496,    -1,    -1,    -1,    -1,  1501,    -1,    -1,    -1,   779,
     363,    -1,    -1,    -1,   367,    -1,    -1,    -1,    -1,   789,
     790,    -1,    -1,   793,    -1,    -1,   796,    -1,  1524,    -1,
    1526,   801,  1041,  1042,  1530,    -1,    -1,  1533,    -1,    -1,
      -1,   811,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1546,    -1,    -1,    -1,  1550,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   416,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   430,    -1,    -1,
      -1,    -1,   435,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     443,    -1,    -1,    -1,    -1,   865,    -1,    -1,    40,    41,
      -1,    43,    -1,    -1,    -1,  1114,    -1,   460,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   470,    -1,   889,
      -1,    -1,     0,    -1,    -1,    -1,   479,    69,   481,    -1,
      -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,   909,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    -1,   922,   923,    -1,    -1,    34,    -1,    -1,    -1,
     930,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1179,   524,   114,    -1,   116,    -1,   118,   119,    -1,    -1,
     122,   123,   124,   125,   126,   127,    -1,    -1,    -1,    -1,
      -1,    69,   962,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1209,    -1,  1211,    -1,    -1,   975,    -1,    -1,    -1,    -1,
     980,   981,    -1,   983,   984,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1238,
      -1,  1001,    -1,   586,   587,    -1,    -1,  1246,  1247,  1248,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1257,  1258,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   622,
      -1,  1041,  1042,    -1,    -1,    -1,   154,    -1,    -1,   632,
      -1,    -1,  1052,    -1,    -1,   638,    -1,    -1,   641,   642,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   657,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   676,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   687,    -1,    -1,    -1,    -1,    -1,
      -1,  1350,    -1,    -1,  1114,    -1,    -1,    -1,   701,    -1,
      -1,    -1,   705,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,    -1,    -1,  1384,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     743,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1413,    -1,    -1,    -1,    -1,  1179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1432,    -1,    -1,   779,    -1,    -1,    -1,
    1439,    -1,  1441,    -1,  1443,    -1,   789,   790,    -1,  1209,
     793,  1211,    -1,   796,    -1,    -1,  1216,    -1,   801,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   337,
      -1,    -1,    -1,    -1,    -1,   343,    -1,    -1,  1238,    -1,
      -1,    -1,  1481,    -1,  1483,    -1,  1246,  1247,  1248,    -1,
      -1,    -1,    -1,    -1,    -1,   363,    -1,  1257,  1258,   367,
    1499,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   865,    -1,    -1,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,   889,    -1,   416,    -1,
      -1,  1311,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,
      -1,    -1,   430,    -1,    -1,    -1,    -1,   435,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   443,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    40,    41,    70,    43,   930,    -1,    -1,
    1350,    -1,   460,    -1,    -1,    -1,    66,    -1,    -1,    -1,
      -1,    -1,   470,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   479,    69,   481,    -1,    -1,    -1,    -1,    75,   962,
      -1,    -1,    79,    -1,  1384,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    -1,   980,   981,    28,
     983,   984,    -1,    -1,   114,    -1,    -1,    -1,   118,    -1,
      -1,    -1,    -1,  1413,  1414,    -1,   524,   114,  1001,   116,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,   125,   126,
     127,    -1,  1432,    -1,   144,    -1,    -1,    -1,    -1,  1439,
      -1,  1441,    -1,  1443,   154,    -1,    -1,   157,    -1,    -1,
      -1,    -1,    -1,    -1,    83,    -1,    -1,    -1,  1041,  1042,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      99,    -1,   101,    -1,    -1,    -1,    -1,    -1,   586,   587,
      -1,  1481,    -1,  1483,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   205,    -1,   126,    -1,  1499,
      -1,    -1,    -1,    -1,    -1,    -1,  1506,   217,    -1,    -1,
      -1,    -1,    -1,    -1,   622,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   632,    -1,    -1,    -1,    -1,    -1,
     638,  1114,    -1,   641,   642,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,    -1,   657,
      -1,   261,    -1,    -1,    -1,    -1,   185,    -1,   187,   188,
      -1,    -1,    -1,   192,    -1,   194,   195,    -1,   676,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,   687,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     300,    -1,    -1,   701,    -1,    -1,  1179,   705,    -1,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    33,    34,    -1,    -1,  1209,   337,  1211,   258,
      -1,    42,   342,    -1,    -1,   743,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1238,    -1,    -1,    -1,    70,
      -1,    -1,    -1,  1246,  1247,  1248,    77,    78,    -1,    -1,
      -1,   779,    -1,    -1,  1257,  1258,    -1,    -1,    -1,    -1,
      -1,   789,   790,    -1,    -1,   793,  1269,    -1,   796,    -1,
      -1,    -1,    -1,   801,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   334,    -1,    -1,    -1,    -1,
      -1,   122,   123,    -1,   424,   425,    -1,    -1,    -1,    -1,
     430,    -1,    -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   451,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   865,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1350,    -1,   479,
      -1,    -1,    -1,    -1,    -1,    -1,   405,    -1,    -1,    -1,
      -1,   889,    -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,    -1,   509,
      -1,  1384,   512,    -1,   514,   515,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   524,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   930,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1413,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1432,
      -1,    -1,    -1,    -1,   962,    -1,  1439,    -1,  1441,    -1,
    1443,    -1,    -1,    -1,    -1,   575,    -1,    -1,    -1,    -1,
      -1,    -1,   980,   981,    -1,   983,   984,   587,    -1,    -1,
     590,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1001,    -1,    -1,    -1,    -1,  1481,    -1,
    1483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   622,    -1,    66,    -1,  1499,    -1,    -1,    -1,
      -1,    -1,   632,    75,    -1,    77,    -1,    79,    -1,    -1,
      -1,   641,   642,  1041,  1042,    87,    -1,    -1,    -1,    -1,
      -1,    -1,   571,   572,    -1,    -1,    -1,   657,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   118,    -1,   120,   121,
     122,    -1,    -1,    -1,    -1,   604,    -1,    -1,   607,   608,
     690,   610,    -1,   612,   613,    -1,    -1,    -1,   617,   618,
      -1,    -1,    -1,    -1,    -1,   705,    -1,   707,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   157,  1114,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   661,   743,    -1,    -1,   665,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     7,    -1,    -1,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   217,    -1,   219,   220,   221,
      -1,  1179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    43,    -1,   795,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,
      -1,  1209,   254,  1211,    -1,    -1,    -1,    -1,    -1,    69,
      70,    -1,    -1,    -1,    -1,    75,    -1,    -1,    -1,    79,
      -1,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
    1238,    91,    92,    -1,    -1,    -1,    -1,    -1,  1246,  1247,
    1248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1257,
    1258,    -1,    -1,    -1,   114,    -1,   116,    -1,    -1,    -1,
      -1,  1269,   122,   123,   124,   125,   126,   127,    -1,    -1,
     322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   889,
      40,    41,    -1,    43,   894,    -1,    -1,    -1,    46,    -1,
     342,    -1,    -1,    -1,    -1,    -1,   348,    -1,   350,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,
     362,    -1,    -1,    -1,   924,    75,    -1,    -1,    -1,    79,
     930,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    -1,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1350,    -1,   102,    -1,    -1,    -1,    -1,    -1,
     402,    -1,   962,    -1,   114,    -1,   116,    -1,    -1,    -1,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,    -1,
     422,    -1,    -1,   983,   984,   427,  1384,   429,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   445,    -1,    -1,   448,   449,    -1,    -1,
      -1,    -1,    -1,   455,    -1,  1413,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,    -1,    -1,    -1,   469,    -1,    -1,
      -1,    -1,    -1,   952,  1432,   477,    -1,    -1,    -1,    -1,
      -1,  1439,   190,  1441,    -1,  1443,    -1,    -1,    -1,   968,
      -1,    -1,   971,   972,    -1,     7,   204,    -1,    10,    11,
      12,    13,    14,    -1,    -1,   213,    -1,  1067,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   223,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1481,    -1,  1483,    -1,    -1,    40,    41,
      42,    43,    -1,    -1,   242,    -1,    -1,    -1,    -1,   247,
      -1,  1499,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   260,    -1,  1114,    -1,    -1,    69,    70,    -1,
     268,    -1,   270,    75,    -1,  1044,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,  1057,    91,
      92,   289,    -1,  1062,  1063,    -1,    -1,    -1,   590,    -1,
     592,   593,   594,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,
     122,   123,   124,   125,   126,   127,    -1,    -1,    -1,    -1,
      -1,    -1,   330,   625,   626,    -1,    -1,   335,    -1,    -1,
    1190,    -1,   634,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   370,    -1,    -1,    -1,   374,   375,    -1,   377,
      -1,    -1,    -1,    -1,    -1,    -1,   384,   385,    -1,   387,
     388,    -1,   390,    -1,   392,    -1,    -1,    -1,    -1,    -1,
     692,    -1,    -1,    40,    41,    -1,    43,  1257,  1258,    -1,
     702,   409,  1181,    -1,    -1,   707,    -1,    -1,    -1,   417,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1200,    69,    -1,    -1,    -1,    -1,    -1,    75,    -1,
      -1,    -1,    79,   441,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,   153,   154,    -1,    -1,    -1,    -1,   466,    -1,
      -1,    -1,    -1,    -1,    -1,   473,    -1,   114,    -1,   116,
     478,    -1,   119,    -1,    -1,   122,   123,   124,   125,   126,
     127,   783,    -1,    -1,   185,    -1,    -1,    -1,    -1,  1349,
      -1,   192,    -1,   795,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    -1,    43,    -1,    -1,    -1,    -1,
     518,   813,    -1,    -1,    -1,    -1,    -1,  1296,    -1,    -1,
      -1,    -1,   530,    -1,  1384,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    -1,    -1,    -1,   837,    -1,    75,    -1,  1399,
      -1,    79,    -1,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    -1,    -1,   258,    -1,   567,
      -1,    40,    41,    -1,    43,    -1,    -1,    -1,   576,    -1,
      -1,   579,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,
      -1,  1441,    -1,  1443,   122,   123,   124,   125,   126,   127,
      69,    -1,    -1,   601,    -1,    -1,    75,    -1,    -1,    -1,
      79,    -1,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,   913,    91,    92,    -1,   316,  1476,    -1,    -1,    -1,
      -1,  1481,    -1,  1483,   325,   326,    -1,   328,   329,    -1,
      -1,    -1,    -1,    -1,    -1,   114,   337,   116,   646,    -1,
     341,    -1,    -1,   122,   123,   124,   125,   126,   127,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1522,   965,    -1,    -1,   367,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   976,   683,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   394,    -1,    -1,    -1,   398,    -1,    -1,
      -1,    -1,    -1,   711,    -1,    -1,    -1,    -1,    -1,    -1,
     144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   726,   727,
     154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   736,   430,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   750,    -1,    -1,    -1,    -1,   755,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1073,    -1,    -1,    -1,   476,    -1,    -1,   479,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,   817,
      32,    33,    34,    35,    -1,    -1,   824,    39,    -1,   253,
      42,    -1,    -1,   524,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   840,    -1,   842,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   855,    70,    -1,
      72,    -1,    74,   861,    -1,    77,    78,    -1,    -1,    81,
      -1,    -1,    -1,    -1,   872,    -1,   567,   568,   876,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   586,   587,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   116,    -1,  1198,    -1,    -1,   600,
     122,   123,   603,   604,    -1,    -1,    -1,    -1,    -1,   610,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   620,
      -1,   622,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   632,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     641,   642,    40,    41,   378,    43,    -1,    -1,    -1,    -1,
      -1,    -1,   960,    -1,    -1,    -1,   657,    -1,    -1,    -1,
     661,   662,    -1,    -1,   665,   666,    -1,    -1,    -1,    -1,
      -1,    69,    -1,   674,    -1,    -1,    -1,    75,    -1,    -1,
      -1,    79,    -1,   154,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   705,   706,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,   451,   116,  1027,
      -1,    -1,    -1,    -1,   122,   123,   124,   125,   126,   127,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   471,    -1,    -1,
      -1,    -1,   743,    -1,    -1,    -1,    -1,  1349,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1069,    -1,    -1,    -1,    -1,  1074,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1084,    -1,    -1,    -1,
     514,    -1,   783,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     524,    -1,    -1,    -1,    -1,   529,    -1,  1399,   532,   800,
    1108,   802,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   545,   813,  1121,    -1,    -1,    -1,  1125,    -1,    -1,
    1128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1144,  1145,    -1,    -1,
      -1,   575,    -1,    -1,    -1,    -1,    -1,    -1,   582,    -1,
      -1,    -1,    -1,   587,  1162,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   337,    -1,   602,    -1,
      -1,   342,   343,    -1,  1476,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   889,    -1,
      -1,    -1,   363,    -1,    -1,   896,   367,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   908,   909,    -1,
     644,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   652,  1227,
      -1,    -1,   154,    -1,    -1,    -1,    -1,    -1,    -1,   930,
      -1,    -1,    -1,  1535,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   952,   953,    -1,    -1,    -1,    -1,    -1,    -1,   430,
      -1,   962,    -1,    -1,    -1,    -1,    -1,   968,   969,    -1,
     971,   972,   973,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   983,   984,    -1,    -1,    -1,    -1,    -1,   460,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1306,   733,
    1308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   479,   743,
    1318,   745,  1320,    -1,   748,    -1,    -1,    -1,    -1,    -1,
     754,    -1,    -1,    -1,    -1,    -1,    -1,  1335,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1353,  1354,  1048,    -1,  1050,
      -1,  1052,    -1,   524,    -1,    -1,  1057,    -1,  1366,    -1,
      -1,   795,   796,  1371,    -1,    -1,  1374,    -1,    -1,    -1,
      -1,    -1,  1073,    -1,    -1,    -1,    -1,   811,    -1,    -1,
      -1,    -1,  1390,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1400,    -1,    -1,  1403,    -1,  1405,  1406,  1407,
      -1,    -1,    -1,    -1,    -1,   337,    -1,    -1,    -1,    -1,
     342,   343,    -1,  1114,    -1,   586,   587,    -1,    -1,   590,
     854,    -1,    -1,    -1,   858,    -1,    -1,    -1,    -1,    -1,
      -1,   363,    -1,    40,    41,   367,    43,  1445,    -1,  1447,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1457,
      -1,   622,    -1,    -1,   625,   889,    -1,    -1,    -1,  1467,
      -1,   632,    69,   634,    -1,    -1,    -1,   638,    75,    -1,
     641,   642,    79,    -1,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,   657,    -1,    -1,    -1,
     924,    -1,  1193,    -1,    -1,    -1,   930,  1198,   430,    -1,
      -1,    -1,    -1,   937,    -1,   676,    -1,   114,   942,   116,
    1211,   945,    -1,    -1,    -1,   122,   123,   124,   125,   126,
     127,   692,    -1,    -1,    -1,    -1,    -1,    -1,   460,    -1,
      -1,   965,    -1,    -1,   705,    -1,   707,    -1,    -1,    -1,
      -1,    -1,   976,    -1,    -1,    -1,    -1,   479,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1257,  1258,    -1,    -1,
      -1,    -1,   996,    -1,   998,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   743,    -1,    -1,    -1,    -1,    -1,    -1,  1013,
    1014,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    -1,   524,    -1,    -1,  1296,  1297,    -1,    -1,  1300,
      -1,    -1,    -1,    -1,    -1,    -1,  1040,    -1,   779,    -1,
      -1,    -1,    -1,    -1,   154,    -1,    -1,    -1,   789,   790,
      -1,    -1,   793,    -1,   795,   796,    -1,    -1,    -1,    -1,
     801,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   586,   587,    -1,    -1,   590,  1093,
      -1,    99,    -1,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1114,    -1,    -1,  1384,    -1,    -1,    -1,    -1,    -1,    -1,
     622,    -1,    -1,   625,    40,    41,    -1,    43,  1132,  1133,
     632,    -1,   634,    -1,    -1,    -1,   638,    -1,    -1,   641,
     642,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   889,    -1,
      -1,    -1,    -1,    69,    -1,   657,    -1,    -1,    -1,    75,
      -1,    -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,   676,    91,    92,    -1,    -1,   187,
     188,    -1,    -1,    -1,   192,    -1,   194,   195,    -1,   930,
     692,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
     116,    -1,    -1,   705,  1475,   707,   122,   123,   124,   125,
     126,   127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   962,    -1,    -1,   965,    -1,    -1,   337,    -1,    -1,
      -1,    -1,   342,   343,  1505,  1506,    -1,    -1,    -1,   980,
     981,   743,   983,   984,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   363,    -1,    -1,    -1,   367,    -1,    -1,
      -1,    -1,    -1,    -1,  1535,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,    -1,  1283,
      -1,    -1,    -1,  1287,    -1,    -1,    -1,   789,   790,    -1,
      -1,   793,    -1,   795,   796,    -1,    -1,    -1,    -1,   801,
    1041,  1042,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     430,    -1,    -1,    -1,    -1,    -1,   334,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,
      -1,    -1,    -1,    -1,    75,   353,    -1,    -1,    79,    -1,
     460,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   479,
      -1,    -1,    -1,  1114,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,   116,    -1,   889,    -1,    -1,
      -1,   122,   123,   124,   125,   126,   127,   405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   524,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   930,    -1,
      -1,    -1,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,
     962,    -1,    -1,   965,    42,    43,    -1,    -1,  1209,    -1,
    1211,    -1,    -1,    -1,    -1,    -1,   586,   587,   980,   981,
     590,   983,   984,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    -1,  1238,    -1,    77,
      78,    -1,    -1,    -1,    -1,  1246,  1247,  1248,    -1,    -1,
      -1,    -1,   622,    -1,    -1,   625,  1257,  1258,  1522,    -1,
      -1,    -1,   632,    -1,   634,    -1,    -1,    -1,   638,    -1,
      -1,   641,   642,    -1,    -1,    -1,    -1,    -1,   116,  1041,
    1042,    -1,   120,    -1,   122,   123,    -1,   657,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   571,   572,    -1,   676,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   692,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   705,   604,   707,    -1,   607,
     608,    -1,   610,    -1,   612,   613,    -1,    -1,    -1,   617,
     618,    -1,  1114,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   743,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1384,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   661,    -1,    -1,    -1,   665,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,
      -1,    -1,  1413,    -1,    -1,    -1,    -1,    -1,    -1,   789,
     790,    -1,    -1,   793,    -1,   795,   796,    -1,    -1,    -1,
      -1,   801,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1441,    -1,  1443,    -1,    -1,    -1,    -1,  1209,    -1,  1211,
      -1,    -1,    -1,    -1,    -1,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,  1476,  1238,    32,    33,    34,
    1481,    -1,  1483,    -1,  1246,  1247,  1248,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1257,  1258,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,   889,
      -1,    -1,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,
       0,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
     930,   116,    32,    33,    34,    35,    -1,   122,   123,    39,
      -1,    -1,    42,    43,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   962,    -1,    -1,   965,    -1,    67,    -1,    -1,
      70,    -1,    72,    -1,    74,    75,    -1,    77,    78,    79,
     980,   981,    -1,   983,   984,    -1,    -1,    -1,    88,    89,
      -1,    -1,  1384,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,   114,    -1,   116,    -1,    -1,    -1,
      -1,  1413,   122,   123,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1041,  1042,    -1,    -1,    -1,    -1,    -1,    -1,  1441,
      -1,  1443,    -1,    70,   952,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,
     968,    -1,    -1,   971,   972,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1476,    -1,    -1,    -1,    -1,  1481,
      -1,  1483,    -1,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,  1114,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1044,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    78,    -1,    -1,  1062,  1063,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    33,    34,
      35,    -1,    -1,    -1,    39,   122,   123,    42,    43,  1209,
      -1,  1211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    70,    -1,    72,  1238,    74,
      75,    -1,    77,    78,    79,    -1,  1246,  1247,  1248,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,  1257,  1258,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      -1,   116,    -1,  1181,    -1,   120,    -1,   122,   123,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1200,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    33,    34,    35,    -1,
      -1,    -1,    39,    40,    41,    42,    43,    44,    -1,    46,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    -1,    60,    -1,    -1,    -1,    64,    65,    -1,
      67,    -1,    69,    70,    -1,    72,    -1,    74,    75,    -1,
      77,    78,    79,    -1,  1384,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    -1,    -1,  1296,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1413,    -1,    -1,    -1,   114,    -1,   116,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,   125,   126,
     127,    -1,    -1,    -1,    -1,   132,    -1,    -1,    -1,    -1,
     137,  1441,    -1,  1443,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,  1476,    32,    33,    34,
      35,  1481,    -1,  1483,    39,    40,    41,    42,    43,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    -1,    -1,    69,    70,    -1,    72,    -1,    74,
      75,    42,    77,    78,    79,    -1,    -1,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      81,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,   124,
     125,   126,   127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   137,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    33,    34,    35,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    33,    34,    69,
      70,    -1,    72,    -1,    74,    75,    42,    77,    78,    79,
      -1,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    78,    -1,   114,    -1,   116,    -1,    -1,    -1,
      -1,    -1,   122,   123,   124,   125,   126,   127,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    43,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    33,    34,    69,    70,    -1,    72,    -1,    74,    75,
      42,    77,    78,    79,    -1,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    78,    -1,   114,    -1,
     116,    -1,    -1,    -1,    -1,   121,   122,   123,   124,   125,
     126,   127,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    43,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    33,    34,    69,    70,    -1,
      72,    -1,    74,    75,    42,    77,    78,    79,    -1,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      78,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,   121,
     122,   123,   124,   125,   126,   127,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    43,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    70,    -1,    72,    -1,    74,    75,    -1,    77,
      78,    79,    -1,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,
      -1,    -1,    -1,    -1,   122,   123,   124,   125,   126,   127,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    43,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    70,    -1,    72,    -1,
      74,    75,    -1,    77,    78,    79,    -1,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,
     124,   125,   126,   127,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    43,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,
      70,    -1,    72,    -1,    74,    75,    -1,    77,    78,    79,
      -1,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,   116,    -1,    -1,    -1,
      -1,    -1,   122,   123,   124,   125,   126,   127,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    33,    34,
      35,    -1,    -1,    -1,    39,    -1,    -1,    42,    43,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    70,    -1,    72,    -1,    74,
      75,    -1,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      -1,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    72,    -1,
      74,    75,    -1,    77,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      33,    34,    35,    -1,    -1,    -1,    39,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    72,
      -1,    74,    -1,    -1,    77,    78,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,   116,    -1,    42,    -1,    -1,    -1,   122,
     123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    72,    -1,    74,    -1,    -1,
      77,    78,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,   116,
      42,    -1,    -1,    -1,    -1,   122,   123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      72,    -1,    74,    75,    -1,    77,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,
     122,   123,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      72,    -1,    74,    -1,    -1,    77,    78,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,   115,   116,    42,    -1,    -1,    -1,    -1,
     122,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    72,    -1,    74,    -1,    -1,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,
      -1,    -1,    -1,    -1,    -1,   122,   123,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    -1,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      33,    34,    -1,    70,    -1,    72,    -1,    74,    -1,    42,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    77,    78,    -1,    -1,    -1,   116,
      -1,    -1,    -1,    -1,    -1,   122,   123,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,   116,    -1,    32,    33,    34,    -1,   122,
     123,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    72,    -1,    74,    -1,    -1,
      77,    78,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,   116,
      42,    -1,    -1,    -1,    -1,   122,   123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      72,    -1,    74,    -1,    -1,    77,    78,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    -1,   116,    42,    -1,    -1,    -1,    -1,
     122,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    72,    -1,    74,    -1,    -1,
      77,    78,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    43,    -1,    -1,    -1,   116,
      -1,    -1,    -1,    -1,    -1,   122,   123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    70,    -1,    -1,    -1,    -1,    75,    -1,    77,
      78,    79,    -1,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,
      -1,   119,    -1,    -1,   122,   123,   124,   125,   126,   127,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    43,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,
      70,    -1,    -1,    -1,    -1,    75,    -1,    77,    78,    79,
      -1,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,   115,   116,    -1,    -1,    -1,
      -1,    -1,   122,   123,   124,   125,   126,   127,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,    -1,
      -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,
     122,   123,   124,   125,   126,   127,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    43,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    70,    -1,    -1,    -1,
      -1,    75,    -1,    77,    78,    79,    -1,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,   123,
     124,   125,   126,   127,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    43,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    69,    70,    -1,    -1,    -1,    -1,    75,
      -1,    77,    78,    79,    -1,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
     116,    -1,    -1,    -1,    -1,    -1,   122,   123,   124,   125,
     126,   127,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,    70,
      -1,    72,    -1,    74,    42,    -1,    77,    78,    -1,    -1,
      -1,    -1,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    70,    -1,    32,    33,    34,    75,    -1,    77,
      78,    79,    -1,    -1,    42,    -1,    -1,    -1,   119,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    -1,    -1,   114,    75,   116,    77,
      78,    79,    -1,    -1,   122,   123,    -1,    -1,    -1,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,
      -1,    -1,    -1,    -1,   122,   123,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    70,    -1,    32,    33,
      34,    75,    -1,    77,    78,    -1,    -1,    -1,    42,    43,
      -1,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,   116,    77,    78,    -1,    -1,    -1,   122,   123,
      -1,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    42,    43,    -1,   120,    -1,   122,   123,
      -1,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    70,    -1,    32,    33,    34,    -1,    -1,    77,    78,
      -1,    -1,    -1,    42,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    33,    34,    -1,
      -1,    70,    -1,    -1,    -1,    -1,    42,   116,    77,    78,
      -1,   120,    -1,   122,   123,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    78,    -1,    -1,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    -1,   122,   123,    -1,    -1,    -1,    -1,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
     116,    32,    33,    34,    -1,    -1,   122,   123,    -1,    -1,
      -1,    42,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    42,    -1,    77,    78,    -1,    -1,
      -1,    -1,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    70,    -1,    32,    33,    34,    -1,    -1,    77,
      78,    -1,    -1,    -1,    42,   116,    -1,    -1,    -1,    -1,
      -1,   122,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,   116,    77,
      78,    -1,    -1,    -1,   122,   123,    -1,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,   116,    42,
      -1,    -1,    -1,    -1,   122,   123,    -1,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    70,    -1,    32,
      33,    34,    -1,    -1,    77,    78,    -1,    -1,    -1,    42,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    33,    34,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    42,   116,    77,    78,    -1,    -1,    -1,   122,
     123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,
      -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,
     123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,   122,   123,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    -1,    40,    41,    -1,    43,    44,    -1,
      46,    -1,    -1,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      70,    67,    72,    69,    74,    -1,    -1,    77,    78,    75,
      -1,    77,    78,    79,    -1,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   115,    -1,    -1,   114,    -1,
     116,    -1,    -1,   119,    -1,    -1,   122,   123,   124,   125,
     126,   127,    -1,    -1,    40,    41,   132,    43,    44,    -1,
      46,   137,    -1,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    -1,    -1,    60,    -1,    -1,    -1,    64,    65,
      -1,    67,    -1,    69,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    77,    78,    79,    -1,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
     116,    -1,    -1,   119,    -1,    -1,   122,   123,   124,   125,
     126,   127,    -1,    -1,    -1,    -1,   132,    -1,    -1,    -1,
      -1,   137,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    -1,    40,    41,    -1,    43,    44,    -1,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    70,    67,
      72,    69,    74,    -1,    -1,    77,    78,    75,    -1,    77,
      78,    79,    -1,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    -1,    -1,    -1,    -1,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,
      -1,   119,    -1,    -1,   122,   123,   124,   125,   126,   127,
      -1,    -1,    40,    41,   132,    43,    44,    -1,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    -1,    60,    -1,    -1,    -1,    64,    65,    -1,    67,
      -1,    69,    -1,    -1,    -1,    -1,    -1,    75,    -1,    77,
      78,    79,    -1,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,
      -1,   119,    -1,    -1,   122,   123,   124,   125,   126,   127,
      -1,    -1,    40,    41,   132,    43,    44,    -1,    46,    -1,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    -1,    60,    -1,    -1,    -1,    64,    65,    -1,    67,
      -1,    69,    -1,    -1,    -1,    -1,    -1,    75,    -1,    77,
      78,    79,    -1,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,
      -1,   119,    -1,    -1,   122,   123,   124,   125,   126,   127,
      -1,    -1,    -1,    -1,   132,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    33,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    70,    -1,    32,    33,    34,
      75,    -1,    77,    78,    -1,    -1,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    -1,    72,    -1,    74,
      -1,    -1,    77,    78,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    72,    -1,    74,    -1,    -1,    77,    78,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    72,    -1,
      74,    -1,    -1,    77,    78,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    72,    -1,    74,    -1,    -1,    77,    78,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    33,    34,    35,    36,    37,    38,    -1,
      -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    32,    33,
      34,    35,    39,    42,    43,    67,    70,    72,    74,    75,
      77,    78,    79,    88,    89,   114,   116,   122,   123,   142,
     145,   157,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   232,   234,   236,   237,   238,   239,   241,
     242,   243,   244,   245,   246,   247,   249,   250,   253,   254,
     255,   257,   259,   260,   268,   270,   296,   297,   298,   306,
     309,   315,   316,   318,   320,   321,   327,   332,   336,   337,
     338,   339,   340,   341,   342,   343,   363,   380,   381,   382,
     383,    75,   144,   145,   157,   223,   225,   234,   237,   246,
     250,   254,   297,    84,   114,   325,   326,   327,    75,    77,
      78,    79,   143,   144,   286,   287,   307,   308,    77,    78,
     287,   114,   318,   114,   114,   157,   332,   337,   338,   339,
     341,   342,   343,   117,   139,   226,   234,   237,   336,   340,
     379,   380,   383,   384,   140,   112,   136,   290,   119,   140,
     181,    77,    78,   142,   285,   140,   140,   140,    77,    78,
     114,   157,   231,   322,   331,   332,   333,   334,   335,   336,
     340,   344,   345,   346,   347,   348,   354,     3,    30,    81,
     248,     3,     5,    77,   116,   157,   225,   238,   242,   244,
     255,   298,   336,   340,   383,   223,   225,   237,   246,   250,
     254,   297,   336,   340,    35,   243,   243,   238,   244,   140,
     243,   238,   243,   238,   325,   243,   238,   121,   140,   140,
       0,   139,   114,   181,   325,   325,   139,   116,   234,   237,
     381,   285,   285,   136,   237,   114,   157,   322,   332,   336,
     116,   157,   383,   319,   240,   119,   287,   327,   114,   303,
     114,   114,    84,   146,   147,    40,    41,    43,    69,    75,
      79,    82,    83,    85,    86,    87,    91,    92,   114,   116,
     124,   125,   126,   127,   141,   145,   146,   148,   149,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   172,   175,   234,   288,   289,   305,
     379,   384,   237,   115,   115,   115,   115,   115,   115,   115,
     116,   234,   363,   381,    32,   116,   122,   157,   172,   225,
     226,   233,   237,   241,   242,   245,   246,   251,   252,   253,
     254,   256,   259,   260,   270,   275,   276,   280,   281,   282,
     283,   296,   297,   363,   375,   376,   377,   378,   383,   384,
     114,   336,   340,   383,   114,   121,   137,   116,   119,   157,
     172,   291,   291,   120,   139,   121,   137,   114,   121,   137,
     121,   137,   121,   137,   332,   333,   334,   335,   345,   346,
     347,   348,   237,   331,   344,   121,   140,    67,   324,   116,
     325,   362,   363,   325,   325,   181,   139,   114,   325,   362,
     325,   325,   237,   322,   114,   114,   236,   237,   234,   237,
     139,   234,   379,   384,   181,   139,   285,   290,   225,   242,
     336,   340,   181,   139,   307,   237,   246,   137,   237,   237,
      78,   114,   119,   287,   298,   237,   307,   137,   137,   318,
     139,   144,   284,     3,   140,   215,   216,   230,   232,   237,
     241,   139,   324,   114,   324,   172,   332,   237,   114,   139,
     285,   119,    35,    36,    37,    38,   234,   299,   300,   302,
     271,   287,   269,   139,   133,   136,   304,   139,    10,    75,
      77,    78,   328,   329,   330,   115,    84,   114,   156,   114,
     156,   159,   114,   156,   114,   114,   156,   156,   116,   172,
     177,   181,   288,   383,   139,    86,    90,    91,    92,   114,
     116,   118,   119,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   136,   174,   159,   159,   122,   128,
     129,   124,   125,    93,    94,    95,    96,   130,   131,    97,
      98,   123,   132,   133,    99,   100,   134,   114,   157,   358,
     359,   360,   361,   362,   115,   121,   114,   362,   363,   114,
     362,   363,   139,   234,   381,   325,   117,   139,   140,   235,
     237,   246,   252,   254,   297,   374,   375,   383,   384,   140,
     114,   116,   136,   157,   332,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   363,   364,   365,   366,   367,   368,
     369,   386,   157,   256,   383,   237,   252,   243,   238,   325,
     140,   140,   157,   235,   237,   376,   285,   235,   363,   376,
     285,   139,   139,   139,   139,    75,   116,   118,   145,   287,
     291,   292,   293,   294,   295,   139,   139,   139,   139,   139,
     139,   115,   115,   115,   115,   115,   115,   115,   331,   344,
     325,   137,   114,   290,   117,   215,   139,   322,   177,   289,
     177,   289,   322,   116,   215,   324,   181,   139,   215,   305,
     261,   258,   237,   277,   278,   279,   282,   283,   115,   121,
     181,   139,   237,   122,   172,   139,   233,   237,   276,   375,
     383,   316,   317,   114,   157,   349,   115,   121,   386,   287,
     121,   385,   136,   272,   119,   299,   114,   119,   287,   289,
     299,   115,   121,   114,   137,   288,   116,   288,   288,   151,
     172,   289,   288,   139,   115,   121,   115,   115,   121,   172,
     116,   144,   150,   151,   139,   116,   144,   150,   172,   159,
     159,   159,   160,   160,   161,   161,   162,   162,   162,   162,
     163,   163,   164,   165,   166,   167,   168,   135,   177,   139,
     359,   360,   361,   237,   358,   325,   325,   172,   289,   139,
     139,   287,   235,   363,   376,   237,   241,   117,   383,   117,
     114,   139,   332,   350,   351,   352,   355,   365,   366,   367,
     117,   139,   172,   237,   349,   353,   364,   114,   325,   368,
     386,   325,   325,   386,   114,   325,   368,   325,   325,   386,
     325,   325,   363,   235,   374,   384,   285,   237,   287,   117,
     121,   117,   121,   386,   235,   376,   386,   273,   274,   275,
     276,   273,   285,   172,   139,   116,   287,   135,   121,   385,
     291,   116,   135,   295,    31,   217,   218,   285,   273,   144,
     322,   144,   114,   325,   362,   363,   114,   325,   362,   363,
     322,   146,   363,   181,   277,   115,   115,   115,   115,   139,
     181,   215,   181,   115,    43,   120,   234,   262,   263,   379,
     119,   140,   140,   144,   230,   140,   140,   273,   114,   157,
     383,   140,   120,   237,   300,   301,   287,   120,   170,   171,
     271,   140,   139,   139,   114,   140,   115,   329,   150,   115,
     139,   121,   115,   115,   115,   115,   172,   119,   159,   172,
     173,   176,   121,   139,   115,   121,   172,   139,   120,   170,
     135,   277,   115,   115,   115,   358,   277,   277,   235,   376,
     116,   122,   157,   172,   172,   237,   355,   277,   115,   115,
     115,   115,   115,   115,   115,     7,   237,   349,   353,   364,
     139,   139,   386,   139,   139,   140,   140,   140,   140,   290,
     170,   171,   172,   323,   139,   291,   293,   120,   139,   219,
     287,    43,    44,    46,    49,    50,    51,    52,    53,    54,
      55,    56,    60,    64,    65,    67,    75,    77,    78,    79,
     132,   145,   177,   178,   179,   180,   181,   182,   183,   185,
     186,   198,   200,   201,   206,   220,   285,   321,    31,   140,
     136,   139,   139,   324,   115,   140,   181,   119,   234,   263,
     114,   135,   157,   264,   265,   267,   331,   332,   344,   362,
     370,   371,   372,   373,   121,   137,   287,   261,   115,   121,
     117,   117,   140,   237,   121,   386,   303,   272,   385,   115,
     299,   223,   225,   234,   311,   312,   313,   314,   305,   115,
     115,   144,   292,   121,   140,   176,    82,    85,    87,   144,
     152,   153,   154,   151,   140,   152,   170,   140,   114,   325,
     362,   363,   140,   140,   139,   140,   140,   140,   172,   115,
     140,   114,   325,   362,   363,   114,   325,   368,   114,   325,
     368,   363,   236,     7,   122,   140,   172,   277,   277,   276,
     280,   280,   281,   115,   121,   121,   115,   101,   127,   140,
     140,   152,   291,   172,   121,   137,   220,   321,   114,   114,
     179,   114,   114,   137,   285,   137,   285,   122,   285,   178,
     114,   181,   173,   173,    11,   207,   149,   137,   140,   139,
     140,   135,   219,   115,   172,   277,   277,   290,   325,   115,
     261,   264,   137,   332,   371,   372,   373,   171,   237,   370,
     121,   137,   266,   267,   266,   325,   325,   287,   120,   139,
     115,   139,   120,   140,   322,   120,   139,   140,   140,   115,
     119,   115,   385,   173,   117,   140,   155,   116,   153,   155,
     155,   121,   140,    90,   118,   117,   140,   115,   139,   115,
     115,   117,   117,   117,   140,   115,   139,   139,   139,   172,
     172,   140,   117,   140,   140,   140,   140,   139,   139,   171,
     171,   117,   117,   140,   287,   177,   177,    50,   177,   139,
     137,   137,   177,   137,   137,   177,    61,    62,    63,   202,
     203,   204,   137,    66,   137,    54,   114,   119,   183,   120,
     325,   137,   140,   140,   120,   137,   115,   115,   115,   370,
     325,   101,   282,   283,   115,   312,   121,   137,   121,   137,
     120,   310,   120,   117,    86,   139,   153,   117,   116,   153,
     116,   153,   117,   277,   117,   277,   277,   277,   140,   140,
     117,   117,   115,   115,   117,   121,   101,   276,   101,   140,
     117,   115,   115,   114,   115,   178,   199,   220,   224,   237,
     241,   137,   115,   114,   114,   181,   204,    61,    62,   172,
     114,   146,   150,   179,   115,   115,   114,   325,   362,   363,
     265,   119,   139,   139,   311,   152,   139,   139,   140,   140,
     140,   140,   117,   117,   139,   140,   117,   179,    47,    48,
     119,   189,   190,   191,   177,   179,   140,   115,   178,   237,
     119,   191,   101,   139,   101,   139,   114,   114,   137,   146,
     115,   135,   120,   139,   139,   285,   322,   120,   140,   152,
     152,   115,   115,   115,   115,   280,    45,   171,   187,   188,
     323,   135,   139,   179,   189,   115,   137,   179,   137,   139,
     115,   139,   115,   139,   101,   139,   101,   139,   135,   137,
     116,   146,   208,   209,   210,   137,   277,   311,   117,   140,
     140,   179,   101,   121,   135,   140,   213,   214,   220,   137,
     178,   178,   213,   181,   205,   235,   237,   379,   181,   205,
     115,   139,   115,   139,   135,   171,   114,   115,   135,   121,
     140,   120,   117,   117,   171,   187,   190,   192,   193,   139,
     137,   190,   194,   195,   140,   114,   157,   322,   370,   144,
     140,   181,   205,   181,   205,   208,   117,   171,   137,   208,
     210,   115,   114,   179,   184,   120,   190,   220,   178,    59,
     184,   197,   120,   190,   115,   237,   115,   140,   140,   135,
     146,   115,   115,   135,   305,   179,   184,   137,   196,   197,
     184,   197,   181,   181,   115,   115,   146,   211,   114,   137,
     211,   115,   196,   140,   140,   181,   181,   121,   135,   171,
     115,   140,   140,   146,   144,   212,   115,   137,   115,   121,
     137,   144
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 326 "parser.yy"
    { typedefTable.enterScope(); }
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 330 "parser.yy"
    { typedefTable.leaveScope(); }
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 337 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_constantInteger( *(yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 338 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_constantFloat( *(yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 339 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_constantFloat( *(yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 340 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_constantFloat( *(yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 341 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_constantChar( *(yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 366 "parser.yy"
    { (yyval.constant) = build_constantStr( *(yyvsp[(1) - (1)].str) ); }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 370 "parser.yy"
    { (yyval.str) = (yyvsp[(1) - (1)].tok); }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 372 "parser.yy"
    {
			appendStr( (yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].tok) );						// append 2nd juxtaposed string to 1st
			delete (yyvsp[(2) - (2)].tok);									// allocated by lexer
			(yyval.str) = (yyvsp[(1) - (2)].str);									// conversion from tok to str
		}
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 383 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_varref( (yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 385 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_constantZeroOne( *(yyvsp[(1) - (1)].tok) ) ); }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 388 "parser.yy"
    { (yyval.en) = (yyvsp[(2) - (3)].en); }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 390 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_valexpr( (yyvsp[(2) - (3)].sn) ) ); }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 400 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Index, (yyvsp[(1) - (6)].en), (yyvsp[(4) - (6)].en) ) ); }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 402 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_func( (yyvsp[(1) - (4)].en), (yyvsp[(3) - (4)].en) ) ); }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 404 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( (yyvsp[(1) - (3)].en), build_varref( (yyvsp[(3) - (3)].tok) ) ) ); }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 406 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( (yyvsp[(1) - (7)].en), build_tuple( (yyvsp[(5) - (7)].en) ) ) ); }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 408 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( (yyvsp[(1) - (2)].en), build_field_name_REALFRACTIONconstant( *(yyvsp[(2) - (2)].tok) ) ) ); }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 410 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_pfieldSel( (yyvsp[(1) - (3)].en), build_varref( (yyvsp[(3) - (3)].tok) ) ) ); }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 412 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_pfieldSel( (yyvsp[(1) - (7)].en), build_tuple( (yyvsp[(5) - (7)].en) ) ) ); }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 414 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_unary_ptr( OperKinds::IncrPost, (yyvsp[(1) - (2)].en) ) ); }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 416 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_unary_ptr( OperKinds::DecrPost, (yyvsp[(1) - (2)].en) ) ); }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 418 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_compoundLiteral( (yyvsp[(2) - (7)].decl), new InitializerNode( (yyvsp[(5) - (7)].in), true ) ) ); }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 420 "parser.yy"
    {
			Token fn;
			fn.str = new std::string( "?{}" );			// location undefined - use location of '{'?
			(yyval.en) = new ExpressionNode( new ConstructorExpr( build_func( new ExpressionNode( build_varref( fn ) ), (ExpressionNode *)( (yyvsp[(1) - (4)].en) )->set_last( (yyvsp[(3) - (4)].en) ) ) ) );
		}
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 430 "parser.yy"
    { (yyval.en) = (ExpressionNode *)( (yyvsp[(1) - (3)].en)->set_last( (yyvsp[(3) - (3)].en) )); }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 435 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 441 "parser.yy"
    { (yyval.en) = (ExpressionNode *)(yyvsp[(1) - (3)].en)->set_last( (yyvsp[(3) - (3)].en) ); }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 447 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( new ExpressionNode( build_field_name_REALDECIMALconstant( *(yyvsp[(1) - (2)].tok) ) ), maybeMoveBuild<Expression>( (yyvsp[(2) - (2)].en) ) ) ); }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 449 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( new ExpressionNode( build_field_name_REALDECIMALconstant( *(yyvsp[(1) - (6)].tok) ) ), build_tuple( (yyvsp[(4) - (6)].en) ) ) ); }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 451 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( (yyvsp[(1) - (3)].en), maybeMoveBuild<Expression>( (yyvsp[(3) - (3)].en) ) ) ); }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 453 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_fieldSel( (yyvsp[(1) - (7)].en), build_tuple( (yyvsp[(5) - (7)].en) ) ) ); }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 455 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_pfieldSel( (yyvsp[(1) - (3)].en), maybeMoveBuild<Expression>( (yyvsp[(3) - (3)].en) ) ) ); }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 457 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_pfieldSel( (yyvsp[(1) - (7)].en), build_tuple( (yyvsp[(5) - (7)].en) ) ) ); }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 462 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_field_name_fraction_constants( build_constantInteger( *(yyvsp[(1) - (2)].tok) ), (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 464 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_field_name_fraction_constants( build_field_name_FLOATINGconstant( *(yyvsp[(1) - (2)].tok) ), (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 466 "parser.yy"
    {
			if( (*(yyvsp[(1) - (2)].tok)) == "0" || (*(yyvsp[(1) - (2)].tok)) == "1" ) {
				(yyval.en) = new ExpressionNode( build_field_name_fraction_constants( build_constantZeroOne( *(yyvsp[(1) - (2)].tok) ), (yyvsp[(2) - (2)].en) ) );
			} else {
				(yyval.en) = new ExpressionNode( build_field_name_fraction_constants( build_varref( (yyvsp[(1) - (2)].tok) ), (yyvsp[(2) - (2)].en) ) );
			}
		}
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 477 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 479 "parser.yy"
    {
			Expression * constant = build_field_name_REALFRACTIONconstant( *(yyvsp[(2) - (2)].tok) );
			(yyval.en) = (yyvsp[(1) - (2)].en) != nullptr ? new ExpressionNode( build_fieldSel( (yyvsp[(1) - (2)].en),  constant ) ) : new ExpressionNode( constant );
		}
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 490 "parser.yy"
    { (yyval.en) = (yyvsp[(1) - (1)].en); }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 492 "parser.yy"
    { (yyval.en) = new ExpressionNode( (yyvsp[(1) - (1)].constant) ); }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 494 "parser.yy"
    { (yyval.en) = (yyvsp[(2) - (2)].en)->set_extension( true ); }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 499 "parser.yy"
    {
			switch ( (yyvsp[(1) - (2)].op) ) {
			  case OperKinds::AddressOf:
				(yyval.en) = new ExpressionNode( build_addressOf( (yyvsp[(2) - (2)].en) ) );
				break;
			  case OperKinds::PointTo:
				(yyval.en) = new ExpressionNode( build_unary_val( (yyvsp[(1) - (2)].op), (yyvsp[(2) - (2)].en) ) );
				break;
			  default:
				assert( false );
			}
		}
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 512 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_unary_val( (yyvsp[(1) - (2)].op), (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 514 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_unary_ptr( OperKinds::Incr, (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 516 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_unary_ptr( OperKinds::Decr, (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 518 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_sizeOfexpr( (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 520 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_sizeOftype( (yyvsp[(3) - (4)].decl) ) ); }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 522 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_alignOfexpr( (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 524 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_alignOftype( (yyvsp[(3) - (4)].decl) ) ); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 526 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_offsetOf( (yyvsp[(3) - (6)].decl), build_varref( (yyvsp[(5) - (6)].tok) ) ) ); }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 528 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_attrexpr( build_varref( (yyvsp[(1) - (1)].tok) ), nullptr ) ); }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 530 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_attrexpr( build_varref( (yyvsp[(1) - (4)].tok) ), (yyvsp[(3) - (4)].en) ) ); }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 532 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_attrtype( build_varref( (yyvsp[(1) - (4)].tok) ), (yyvsp[(3) - (4)].decl) ) ); }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 538 "parser.yy"
    { (yyval.op) = OperKinds::PointTo; }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 539 "parser.yy"
    { (yyval.op) = OperKinds::AddressOf; }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 545 "parser.yy"
    { (yyval.op) = OperKinds::UnPlus; }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 546 "parser.yy"
    { (yyval.op) = OperKinds::UnMinus; }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 547 "parser.yy"
    { (yyval.op) = OperKinds::Neg; }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 548 "parser.yy"
    { (yyval.op) = OperKinds::BitNeg; }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 554 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_cast( (yyvsp[(2) - (4)].decl), (yyvsp[(4) - (4)].en) ) ); }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 562 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Mul, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 564 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Div, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 566 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Mod, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 572 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Plus, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 574 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Minus, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 580 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::LShift, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 582 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::RShift, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 588 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::LThan, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 590 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::GThan, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 592 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::LEThan, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 594 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::GEThan, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 600 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Eq, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 602 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Neq, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 608 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::BitAnd, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 614 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::Xor, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 620 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_val( OperKinds::BitOr, (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 626 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_and_or( (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en), true ) ); }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 632 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_and_or( (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en), false ) ); }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 638 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_cond( (yyvsp[(1) - (5)].en), (yyvsp[(3) - (5)].en), (yyvsp[(5) - (5)].en) ) ); }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 641 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_cond( (yyvsp[(1) - (4)].en), (yyvsp[(1) - (4)].en), (yyvsp[(4) - (4)].en) ) ); }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 654 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_binary_ptr( (yyvsp[(2) - (3)].op), (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 661 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 666 "parser.yy"
    { (yyval.op) = OperKinds::Assign; }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 667 "parser.yy"
    { (yyval.op) = OperKinds::AtAssn; }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 668 "parser.yy"
    { (yyval.op) = OperKinds::MulAssn; }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 669 "parser.yy"
    { (yyval.op) = OperKinds::DivAssn; }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 670 "parser.yy"
    { (yyval.op) = OperKinds::ModAssn; }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 671 "parser.yy"
    { (yyval.op) = OperKinds::PlusAssn; }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 672 "parser.yy"
    { (yyval.op) = OperKinds::MinusAssn; }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 673 "parser.yy"
    { (yyval.op) = OperKinds::LSAssn; }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 674 "parser.yy"
    { (yyval.op) = OperKinds::RSAssn; }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 675 "parser.yy"
    { (yyval.op) = OperKinds::AndAssn; }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 676 "parser.yy"
    { (yyval.op) = OperKinds::ERAssn; }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 677 "parser.yy"
    { (yyval.op) = OperKinds::OrAssn; }
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 688 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_tuple( (ExpressionNode *)(new ExpressionNode( nullptr ) )->set_last( (yyvsp[(4) - (6)].en) ) ) ); }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 690 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_tuple( (ExpressionNode *)(yyvsp[(3) - (7)].en)->set_last( (yyvsp[(5) - (7)].en) ) ) ); }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 696 "parser.yy"
    { (yyval.en) = (ExpressionNode *)(yyvsp[(1) - (3)].en)->set_last( (yyvsp[(3) - (3)].en) ); }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 702 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_comma( (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 707 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 716 "parser.yy"
    { (yyval.sn) = (yyvsp[(1) - (1)].sn); }
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 723 "parser.yy"
    {
			Token fn;
			fn.str = new string( "^?{}" );				// location undefined
			(yyval.sn) = new StatementNode( build_expr( new ExpressionNode( build_func( new ExpressionNode( build_varref( fn ) ), (ExpressionNode *)( (yyvsp[(2) - (6)].en) )->set_last( (yyvsp[(4) - (6)].en) ) ) ) ) );
		}
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 733 "parser.yy"
    {
			(yyval.sn) = (yyvsp[(4) - (4)].sn)->add_label( (yyvsp[(1) - (4)].tok), (yyvsp[(3) - (4)].decl) );
		}
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 740 "parser.yy"
    { (yyval.sn) = new StatementNode( build_compound( (StatementNode *)0 ) ); }
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 748 "parser.yy"
    { (yyval.sn) = new StatementNode( build_compound( (yyvsp[(5) - (7)].sn) ) ); }
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 754 "parser.yy"
    { if ( (yyvsp[(1) - (3)].sn) != 0 ) { (yyvsp[(1) - (3)].sn)->set_last( (yyvsp[(3) - (3)].sn) ); (yyval.sn) = (yyvsp[(1) - (3)].sn); } }
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 759 "parser.yy"
    { (yyval.sn) = new StatementNode( (yyvsp[(1) - (1)].decl) ); }
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 761 "parser.yy"
    {
			distExt( (yyvsp[(2) - (2)].decl) );
			(yyval.sn) = new StatementNode( (yyvsp[(2) - (2)].decl) );
		}
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 766 "parser.yy"
    { (yyval.sn) = new StatementNode( (yyvsp[(1) - (1)].decl) ); }
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 768 "parser.yy"
    {
			distExt( (yyvsp[(2) - (2)].decl) );
			(yyval.sn) = new StatementNode( (yyvsp[(2) - (2)].decl) );
		}
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 778 "parser.yy"
    { if ( (yyvsp[(1) - (2)].sn) != 0 ) { (yyvsp[(1) - (2)].sn)->set_last( (yyvsp[(2) - (2)].sn) ); (yyval.sn) = (yyvsp[(1) - (2)].sn); } }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 783 "parser.yy"
    { (yyval.sn) = new StatementNode( build_expr( (yyvsp[(1) - (2)].en) ) ); }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 789 "parser.yy"
    { (yyval.sn) = new StatementNode( build_if( (yyvsp[(3) - (5)].en), (yyvsp[(5) - (5)].sn), nullptr ) ); }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 791 "parser.yy"
    { (yyval.sn) = new StatementNode( build_if( (yyvsp[(3) - (7)].en), (yyvsp[(5) - (7)].sn), (yyvsp[(7) - (7)].sn) ) ); }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 793 "parser.yy"
    { (yyval.sn) = new StatementNode( build_switch( (yyvsp[(3) - (5)].en), (yyvsp[(5) - (5)].sn) ) ); }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 795 "parser.yy"
    {
			StatementNode *sw = new StatementNode( build_switch( (yyvsp[(3) - (9)].en), (yyvsp[(8) - (9)].sn) ) );
			// The semantics of the declaration list is changed to include associated initialization, which is performed
			// *before* the transfer to the appropriate case clause by hoisting the declarations into a compound
			// statement around the switch.  Statements after the initial declaration list can never be executed, and
			// therefore, are removed from the grammar even though C allows it. The change also applies to choose
			// statement.
			(yyval.sn) = (yyvsp[(7) - (9)].decl) ? new StatementNode( build_compound( (StatementNode *)((new StatementNode( (yyvsp[(7) - (9)].decl) ))->set_last( sw )) ) ) : sw;
		}
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 805 "parser.yy"
    { (yyval.sn) = new StatementNode( build_switch( (yyvsp[(3) - (5)].en), (yyvsp[(5) - (5)].sn) ) ); }
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 807 "parser.yy"
    {
			StatementNode *sw = new StatementNode( build_switch( (yyvsp[(3) - (9)].en), (yyvsp[(8) - (9)].sn) ) );
			(yyval.sn) = (yyvsp[(7) - (9)].decl) ? new StatementNode( build_compound( (StatementNode *)((new StatementNode( (yyvsp[(7) - (9)].decl) ))->set_last( sw )) ) ) : sw;
		}
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 817 "parser.yy"
    { (yyval.en) = (yyvsp[(1) - (1)].en); }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 819 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_range( (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 824 "parser.yy"
    { (yyval.sn) = new StatementNode( build_case( (yyvsp[(1) - (1)].en) ) ); }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 826 "parser.yy"
    { (yyval.sn) = (StatementNode *)((yyvsp[(1) - (3)].sn)->set_last( new StatementNode( build_case( (yyvsp[(3) - (3)].en) ) ) ) ); }
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 830 "parser.yy"
    { (yyval.sn) = (yyvsp[(2) - (3)].sn); }
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 831 "parser.yy"
    { (yyval.sn) = new StatementNode( build_default() ); }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 837 "parser.yy"
    { (yyval.sn) = (StatementNode *)( (yyvsp[(1) - (2)].sn)->set_last( (yyvsp[(2) - (2)].sn) )); }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 841 "parser.yy"
    { (yyval.sn) = (yyvsp[(1) - (2)].sn)->append_last_case( new StatementNode( build_compound( (yyvsp[(2) - (2)].sn) ) ) ); }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 846 "parser.yy"
    { (yyval.sn) = nullptr; }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 852 "parser.yy"
    { (yyval.sn) = (yyvsp[(1) - (2)].sn)->append_last_case( new StatementNode( build_compound( (yyvsp[(2) - (2)].sn) ) ) ); }
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 854 "parser.yy"
    { (yyval.sn) = (StatementNode *)( (yyvsp[(1) - (3)].sn)->set_last( (yyvsp[(2) - (3)].sn)->append_last_case( new StatementNode( build_compound( (yyvsp[(3) - (3)].sn) ) ) ) ) ); }
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 859 "parser.yy"
    { (yyval.sn) = nullptr; }
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 865 "parser.yy"
    { (yyval.sn) = (yyvsp[(1) - (2)].sn)->append_last_case( (yyvsp[(2) - (2)].sn) ); }
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 867 "parser.yy"
    { (yyval.sn) = (yyvsp[(1) - (3)].sn)->append_last_case( new StatementNode( build_compound( (StatementNode *)(yyvsp[(2) - (3)].sn)->set_last( (yyvsp[(3) - (3)].sn) ) ) ) ); }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 869 "parser.yy"
    { (yyval.sn) = (StatementNode *)( (yyvsp[(1) - (3)].sn)->set_last( (yyvsp[(2) - (3)].sn)->append_last_case( (yyvsp[(3) - (3)].sn) ))); }
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 871 "parser.yy"
    { (yyval.sn) = (StatementNode *)( (yyvsp[(1) - (4)].sn)->set_last( (yyvsp[(2) - (4)].sn)->append_last_case( new StatementNode( build_compound( (StatementNode *)(yyvsp[(3) - (4)].sn)->set_last( (yyvsp[(4) - (4)].sn) ) ) ) ) ) ); }
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 876 "parser.yy"
    { (yyval.sn) = new StatementNode( build_branch( BranchStmt::Break ) ); }
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 882 "parser.yy"
    { (yyval.sn) = nullptr; }
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 884 "parser.yy"
    { (yyval.sn) = nullptr; }
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 889 "parser.yy"
    { (yyval.sn) = new StatementNode( build_while( (yyvsp[(3) - (5)].en), (yyvsp[(5) - (5)].sn) ) ); }
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 891 "parser.yy"
    { (yyval.sn) = new StatementNode( build_while( (yyvsp[(5) - (7)].en), (yyvsp[(2) - (7)].sn), true ) ); }
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 893 "parser.yy"
    { (yyval.sn) = new StatementNode( build_for( (yyvsp[(4) - (6)].fctl), (yyvsp[(6) - (6)].sn) ) ); }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 898 "parser.yy"
    { (yyval.fctl) = new ForCtl( (yyvsp[(1) - (6)].en), (yyvsp[(4) - (6)].en), (yyvsp[(6) - (6)].en) ); }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 900 "parser.yy"
    { (yyval.fctl) = new ForCtl( (yyvsp[(1) - (4)].decl), (yyvsp[(2) - (4)].en), (yyvsp[(4) - (4)].en) ); }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 905 "parser.yy"
    { (yyval.sn) = new StatementNode( build_branch( (yyvsp[(2) - (3)].tok), BranchStmt::Goto ) ); }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 909 "parser.yy"
    { (yyval.sn) = new StatementNode( build_computedgoto( (yyvsp[(3) - (4)].en) ) ); }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 912 "parser.yy"
    { (yyval.sn) = new StatementNode( build_branch( BranchStmt::Continue ) ); }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 916 "parser.yy"
    { (yyval.sn) = new StatementNode( build_branch( (yyvsp[(2) - (3)].tok), BranchStmt::Continue ) ); }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 919 "parser.yy"
    { (yyval.sn) = new StatementNode( build_branch( BranchStmt::Break ) ); }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 923 "parser.yy"
    { (yyval.sn) = new StatementNode( build_branch( (yyvsp[(2) - (3)].tok), BranchStmt::Break ) ); }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 925 "parser.yy"
    { (yyval.sn) = new StatementNode( build_return( (yyvsp[(2) - (3)].en) ) ); }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 927 "parser.yy"
    { (yyval.sn) = new StatementNode( build_throw( (yyvsp[(2) - (3)].en) ) ); }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 929 "parser.yy"
    { (yyval.sn) = new StatementNode( build_throw( (yyvsp[(2) - (3)].en) ) ); }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 931 "parser.yy"
    { (yyval.sn) = new StatementNode( build_throw( (yyvsp[(2) - (5)].en) ) ); }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 936 "parser.yy"
    { (yyval.sn) = new StatementNode( build_try( (yyvsp[(2) - (3)].sn), (yyvsp[(3) - (3)].sn), 0 ) ); }
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 938 "parser.yy"
    { (yyval.sn) = new StatementNode( build_try( (yyvsp[(2) - (3)].sn), 0, (yyvsp[(3) - (3)].sn) ) ); }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 940 "parser.yy"
    { (yyval.sn) = new StatementNode( build_try( (yyvsp[(2) - (4)].sn), (yyvsp[(3) - (4)].sn), (yyvsp[(4) - (4)].sn) ) ); }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 947 "parser.yy"
    { (yyval.sn) = new StatementNode( build_catch( 0, (yyvsp[(5) - (5)].sn), true ) ); }
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 949 "parser.yy"
    { (yyval.sn) = (StatementNode *)(yyvsp[(1) - (6)].sn)->set_last( new StatementNode( build_catch( 0, (yyvsp[(6) - (6)].sn), true ) ) ); }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 951 "parser.yy"
    { (yyval.sn) = new StatementNode( build_catch( 0, (yyvsp[(5) - (5)].sn), true ) ); }
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 953 "parser.yy"
    { (yyval.sn) = (StatementNode *)(yyvsp[(1) - (6)].sn)->set_last( new StatementNode( build_catch( 0, (yyvsp[(6) - (6)].sn), true ) ) ); }
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 958 "parser.yy"
    { (yyval.sn) = new StatementNode( build_catch( (yyvsp[(5) - (9)].decl), (yyvsp[(8) - (9)].sn) ) ); }
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 960 "parser.yy"
    { (yyval.sn) = (StatementNode *)(yyvsp[(1) - (10)].sn)->set_last( new StatementNode( build_catch( (yyvsp[(6) - (10)].decl), (yyvsp[(9) - (10)].sn) ) ) ); }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 962 "parser.yy"
    { (yyval.sn) = new StatementNode( build_catch( (yyvsp[(5) - (9)].decl), (yyvsp[(8) - (9)].sn) ) ); }
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 964 "parser.yy"
    { (yyval.sn) = (StatementNode *)(yyvsp[(1) - (10)].sn)->set_last( new StatementNode( build_catch( (yyvsp[(6) - (10)].decl), (yyvsp[(9) - (10)].sn) ) ) ); }
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 969 "parser.yy"
    {
			(yyval.sn) = new StatementNode( build_finally( (yyvsp[(2) - (2)].sn) ) );
		}
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 978 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (2)].decl)->addType( (yyvsp[(1) - (2)].decl) );
		}
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 983 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addType( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 985 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (2)].decl)->addName( (yyvsp[(2) - (2)].tok) );
		}
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 994 "parser.yy"
    { (yyval.sn) = new StatementNode( build_asmstmt( (yyvsp[(2) - (6)].flag), (yyvsp[(4) - (6)].constant), 0 ) ); }
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 996 "parser.yy"
    { (yyval.sn) = new StatementNode( build_asmstmt( (yyvsp[(2) - (8)].flag), (yyvsp[(4) - (8)].constant), (yyvsp[(6) - (8)].en) ) ); }
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 998 "parser.yy"
    { (yyval.sn) = new StatementNode( build_asmstmt( (yyvsp[(2) - (10)].flag), (yyvsp[(4) - (10)].constant), (yyvsp[(6) - (10)].en), (yyvsp[(8) - (10)].en) ) ); }
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 1000 "parser.yy"
    { (yyval.sn) = new StatementNode( build_asmstmt( (yyvsp[(2) - (12)].flag), (yyvsp[(4) - (12)].constant), (yyvsp[(6) - (12)].en), (yyvsp[(8) - (12)].en), (yyvsp[(10) - (12)].en) ) ); }
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 1002 "parser.yy"
    { (yyval.sn) = new StatementNode( build_asmstmt( (yyvsp[(2) - (14)].flag), (yyvsp[(5) - (14)].constant), 0, (yyvsp[(8) - (14)].en), (yyvsp[(10) - (14)].en), (yyvsp[(12) - (14)].label) ) ); }
    break;

  case 226:

/* Line 1806 of yacc.c  */
#line 1007 "parser.yy"
    { (yyval.flag) = false; }
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 1009 "parser.yy"
    { (yyval.flag) = true; }
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 1014 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 1021 "parser.yy"
    { (yyval.en) = (ExpressionNode *)(yyvsp[(1) - (3)].en)->set_last( (yyvsp[(3) - (3)].en) ); }
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 1026 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_asmexpr( 0, (yyvsp[(1) - (4)].constant), (yyvsp[(3) - (4)].en) ) ); }
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 1028 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_asmexpr( (yyvsp[(2) - (7)].en), (yyvsp[(4) - (7)].constant), (yyvsp[(6) - (7)].en) ) ); }
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 1033 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 1035 "parser.yy"
    { (yyval.en) = new ExpressionNode( (yyvsp[(1) - (1)].constant) ); }
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 1038 "parser.yy"
    { (yyval.en) = (ExpressionNode *)(yyvsp[(1) - (3)].en)->set_last( new ExpressionNode( (yyvsp[(3) - (3)].constant) ) ); }
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 1043 "parser.yy"
    {
			(yyval.label) = new LabelNode(); (yyval.label)->labels.push_back( *(yyvsp[(1) - (1)].tok) );
			delete (yyvsp[(1) - (1)].tok);									// allocated by lexer
		}
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 1048 "parser.yy"
    {
			(yyval.label) = (yyvsp[(1) - (3)].label); (yyvsp[(1) - (3)].label)->labels.push_back( *(yyvsp[(3) - (3)].tok) );
			delete (yyvsp[(3) - (3)].tok);									// allocated by lexer
		}
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 1058 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 1065 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->appendList( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 1070 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1077 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->appendList( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 1091 "parser.yy"
    {}
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 1092 "parser.yy"
    {}
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 1121 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (2)].decl)->addInitializer( (yyvsp[(2) - (2)].in) );
		}
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 1128 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (3)].decl)->addQualifiers( (yyvsp[(1) - (3)].decl) )->addInitializer( (yyvsp[(3) - (3)].in) );;
		}
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 1133 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(5) - (6)].tok), TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (6)].decl)->appendList( (yyvsp[(1) - (6)].decl)->cloneType( (yyvsp[(5) - (6)].tok) )->addInitializer( (yyvsp[(6) - (6)].in) ) );
		}
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 1143 "parser.yy"
    {
			typedefTable.setNextIdentifier( *(yyvsp[(2) - (3)].tok) );
			(yyval.decl) = (yyvsp[(1) - (3)].decl)->addName( (yyvsp[(2) - (3)].tok) )->addAsmName( (yyvsp[(3) - (3)].decl) );
		}
    break;

  case 264:

/* Line 1806 of yacc.c  */
#line 1148 "parser.yy"
    {
			typedefTable.setNextIdentifier( *(yyvsp[(2) - (3)].tok) );
			(yyval.decl) = (yyvsp[(1) - (3)].decl)->addName( (yyvsp[(2) - (3)].tok) )->addAsmName( (yyvsp[(3) - (3)].decl) );
		}
    break;

  case 265:

/* Line 1806 of yacc.c  */
#line 1153 "parser.yy"
    {
			typedefTable.setNextIdentifier( *(yyvsp[(3) - (4)].tok) );
			(yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(1) - (4)].decl) )->addName( (yyvsp[(3) - (4)].tok) )->addAsmName( (yyvsp[(4) - (4)].decl) );
		}
    break;

  case 266:

/* Line 1806 of yacc.c  */
#line 1161 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (1)].decl);
		}
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 1166 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) );
		}
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 1171 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) );
		}
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 1176 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(3) - (3)].decl)->addQualifiers( (yyvsp[(1) - (3)].decl) )->addQualifiers( (yyvsp[(2) - (3)].decl) );
		}
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 1181 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(5) - (5)].tok), TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(1) - (5)].decl)->cloneType( (yyvsp[(5) - (5)].tok) ) );
		}
    break;

  case 271:

/* Line 1806 of yacc.c  */
#line 1212 "parser.yy"
    {
			(yyval.decl) = DeclarationNode::newFunction( (yyvsp[(2) - (7)].tok), (yyvsp[(1) - (7)].decl), (yyvsp[(5) - (7)].decl), 0, true );
		}
    break;

  case 272:

/* Line 1806 of yacc.c  */
#line 1216 "parser.yy"
    {
			(yyval.decl) = DeclarationNode::newFunction( (yyvsp[(2) - (7)].tok), (yyvsp[(1) - (7)].decl), (yyvsp[(5) - (7)].decl), 0, true );
		}
    break;

  case 273:

/* Line 1806 of yacc.c  */
#line 1223 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTuple( (yyvsp[(3) - (5)].decl) ); }
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 1227 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTuple( (yyvsp[(3) - (9)].decl)->appendList( (yyvsp[(7) - (9)].decl) ) ); }
    break;

  case 275:

/* Line 1806 of yacc.c  */
#line 1232 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(2) - (2)].decl)->addTypedef();
		}
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 1237 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(2) - (2)].decl)->addTypedef();
		}
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 1242 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(5) - (5)].tok), TypedefTable::TD );
			(yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(1) - (5)].decl)->cloneType( (yyvsp[(5) - (5)].tok) ) );
		}
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 1253 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(3) - (3)].decl)->addType( (yyvsp[(2) - (3)].decl) )->addTypedef();
		}
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 1258 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(1) - (5)].decl)->cloneBaseType( (yyvsp[(5) - (5)].decl) )->addTypedef() );
		}
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 1263 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(4) - (4)].decl)->addType( (yyvsp[(3) - (4)].decl) )->addQualifiers( (yyvsp[(1) - (4)].decl) )->addTypedef();
		}
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 1268 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(3) - (3)].decl)->addType( (yyvsp[(1) - (3)].decl) )->addTypedef();
		}
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 1273 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::TD );
			(yyval.decl) = (yyvsp[(4) - (4)].decl)->addQualifiers( (yyvsp[(1) - (4)].decl) )->addTypedef()->addType( (yyvsp[(1) - (4)].decl) );
		}
    break;

  case 283:

/* Line 1806 of yacc.c  */
#line 1282 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(2) - (4)].tok), TypedefTable::TD );
			(yyval.decl) = DeclarationNode::newName( 0 );			// unimplemented
		}
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 1287 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(5) - (7)].tok), TypedefTable::TD );
			(yyval.decl) = DeclarationNode::newName( 0 );			// unimplemented
		}
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 1317 "parser.yy"
    {
			(yyval.decl) = distAttr( (yyvsp[(1) - (4)].decl), (yyvsp[(2) - (4)].decl) );
		}
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 1329 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (3)].decl)->addAsmName( (yyvsp[(2) - (3)].decl) )->addInitializer( (yyvsp[(3) - (3)].in) );
		}
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 1334 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (6)].decl)->appendList( (yyvsp[(4) - (6)].decl)->addQualifiers( (yyvsp[(3) - (6)].decl) )->addAsmName( (yyvsp[(5) - (6)].decl) )->addInitializer( (yyvsp[(6) - (6)].in) ) );
		}
    break;

  case 307:

/* Line 1806 of yacc.c  */
#line 1380 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 1392 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 313:

/* Line 1806 of yacc.c  */
#line 1402 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTypeQualifier( DeclarationNode::Const ); }
    break;

  case 314:

/* Line 1806 of yacc.c  */
#line 1404 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTypeQualifier( DeclarationNode::Restrict ); }
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 1406 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTypeQualifier( DeclarationNode::Volatile ); }
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 1408 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTypeQualifier( DeclarationNode::Lvalue ); }
    break;

  case 317:

/* Line 1806 of yacc.c  */
#line 1410 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTypeQualifier( DeclarationNode::Atomic ); }
    break;

  case 318:

/* Line 1806 of yacc.c  */
#line 1412 "parser.yy"
    {
			typedefTable.enterScope();
		}
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 1416 "parser.yy"
    {
			typedefTable.leaveScope();
			(yyval.decl) = DeclarationNode::newForall( (yyvsp[(4) - (5)].decl) );
		}
    break;

  case 321:

/* Line 1806 of yacc.c  */
#line 1425 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 1427 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) )->addQualifiers( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 1438 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 1443 "parser.yy"
    { (yyval.decl) = DeclarationNode::newStorageClass( DeclarationNode::Extern ); }
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 1445 "parser.yy"
    { (yyval.decl) = DeclarationNode::newStorageClass( DeclarationNode::Static ); }
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 1447 "parser.yy"
    { (yyval.decl) = DeclarationNode::newStorageClass( DeclarationNode::Auto ); }
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 1449 "parser.yy"
    { (yyval.decl) = DeclarationNode::newStorageClass( DeclarationNode::Register ); }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 1451 "parser.yy"
    { (yyval.decl) = DeclarationNode::newStorageClass( DeclarationNode::Threadlocal ); }
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 1454 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFuncSpecifier( DeclarationNode::Inline ); }
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 1456 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFuncSpecifier( DeclarationNode::Fortran ); }
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 1458 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFuncSpecifier( DeclarationNode::Noreturn ); }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 1463 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBasicType( DeclarationNode::Char ); }
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 1465 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBasicType( DeclarationNode::Double ); }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 1467 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBasicType( DeclarationNode::Float ); }
    break;

  case 336:

/* Line 1806 of yacc.c  */
#line 1469 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBasicType( DeclarationNode::Int ); }
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 1471 "parser.yy"
    { (yyval.decl) = DeclarationNode::newLength( DeclarationNode::Long ); }
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 1473 "parser.yy"
    { (yyval.decl) = DeclarationNode::newLength( DeclarationNode::Short ); }
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 1475 "parser.yy"
    { (yyval.decl) = DeclarationNode::newSignedNess( DeclarationNode::Signed ); }
    break;

  case 340:

/* Line 1806 of yacc.c  */
#line 1477 "parser.yy"
    { (yyval.decl) = DeclarationNode::newSignedNess( DeclarationNode::Unsigned ); }
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 1479 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBasicType( DeclarationNode::Void ); }
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 1481 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBasicType( DeclarationNode::Bool ); }
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 1483 "parser.yy"
    { (yyval.decl) = DeclarationNode::newComplexType( DeclarationNode::Complex ); }
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 1485 "parser.yy"
    { (yyval.decl) = DeclarationNode::newComplexType( DeclarationNode::Imaginary ); }
    break;

  case 345:

/* Line 1806 of yacc.c  */
#line 1487 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBuiltinType( DeclarationNode::Valist ); }
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 1489 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBuiltinType( DeclarationNode::Zero ); }
    break;

  case 347:

/* Line 1806 of yacc.c  */
#line 1491 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBuiltinType( DeclarationNode::One ); }
    break;

  case 349:

/* Line 1806 of yacc.c  */
#line 1498 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 1500 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 1502 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) )->addQualifiers( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 1504 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) )->addType( (yyvsp[(1) - (3)].decl) ); }
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 1510 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl)->addQualifiers( (yyvsp[(1) - (3)].decl) )->addQualifiers( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 1517 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 1519 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 1521 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addType( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 1526 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (4)].decl); }
    break;

  case 360:

/* Line 1806 of yacc.c  */
#line 1528 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTypeof( (yyvsp[(3) - (4)].en) ); }
    break;

  case 361:

/* Line 1806 of yacc.c  */
#line 1530 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAttr( (yyvsp[(1) - (4)].tok), (yyvsp[(3) - (4)].decl) ); }
    break;

  case 362:

/* Line 1806 of yacc.c  */
#line 1532 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAttr( (yyvsp[(1) - (4)].tok), (yyvsp[(3) - (4)].en) ); }
    break;

  case 364:

/* Line 1806 of yacc.c  */
#line 1538 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 365:

/* Line 1806 of yacc.c  */
#line 1540 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 1542 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) )->addQualifiers( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 368:

/* Line 1806 of yacc.c  */
#line 1548 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 369:

/* Line 1806 of yacc.c  */
#line 1550 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 371:

/* Line 1806 of yacc.c  */
#line 1556 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 372:

/* Line 1806 of yacc.c  */
#line 1558 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 373:

/* Line 1806 of yacc.c  */
#line 1560 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) )->addQualifiers( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 375:

/* Line 1806 of yacc.c  */
#line 1566 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 376:

/* Line 1806 of yacc.c  */
#line 1568 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 378:

/* Line 1806 of yacc.c  */
#line 1574 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 379:

/* Line 1806 of yacc.c  */
#line 1576 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 380:

/* Line 1806 of yacc.c  */
#line 1578 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) )->addQualifiers( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 381:

/* Line 1806 of yacc.c  */
#line 1583 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFromTypedef( (yyvsp[(1) - (1)].tok) ); }
    break;

  case 382:

/* Line 1806 of yacc.c  */
#line 1585 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFromTypedef( (yyvsp[(2) - (2)].tok) )->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 383:

/* Line 1806 of yacc.c  */
#line 1587 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 388:

/* Line 1806 of yacc.c  */
#line 1602 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAggregate( (yyvsp[(1) - (5)].aggKey), nullptr, nullptr, (yyvsp[(4) - (5)].decl), true )->addQualifiers( (yyvsp[(2) - (5)].decl) ); }
    break;

  case 389:

/* Line 1806 of yacc.c  */
#line 1604 "parser.yy"
    { typedefTable.makeTypedef( *(yyvsp[(3) - (3)].tok) ); }
    break;

  case 390:

/* Line 1806 of yacc.c  */
#line 1606 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAggregate( (yyvsp[(1) - (7)].aggKey), (yyvsp[(3) - (7)].tok), nullptr, (yyvsp[(6) - (7)].decl), true )->addQualifiers( (yyvsp[(2) - (7)].decl) ); }
    break;

  case 391:

/* Line 1806 of yacc.c  */
#line 1608 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAggregate( (yyvsp[(1) - (8)].aggKey), nullptr, (yyvsp[(4) - (8)].en), (yyvsp[(7) - (8)].decl), false )->addQualifiers( (yyvsp[(2) - (8)].decl) ); }
    break;

  case 393:

/* Line 1806 of yacc.c  */
#line 1614 "parser.yy"
    {
			typedefTable.makeTypedef( *(yyvsp[(3) - (3)].tok) );
			(yyval.decl) = DeclarationNode::newAggregate( (yyvsp[(1) - (3)].aggKey), (yyvsp[(3) - (3)].tok), nullptr, nullptr, false )->addQualifiers( (yyvsp[(2) - (3)].decl) );
		}
    break;

  case 394:

/* Line 1806 of yacc.c  */
#line 1619 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) ); }
    break;

  case 395:

/* Line 1806 of yacc.c  */
#line 1624 "parser.yy"
    { (yyval.aggKey) = DeclarationNode::Struct; }
    break;

  case 396:

/* Line 1806 of yacc.c  */
#line 1626 "parser.yy"
    { (yyval.aggKey) = DeclarationNode::Union; }
    break;

  case 397:

/* Line 1806 of yacc.c  */
#line 1631 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 398:

/* Line 1806 of yacc.c  */
#line 1633 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl) ? (yyvsp[(1) - (2)].decl)->appendList( (yyvsp[(2) - (2)].decl) ) : (yyvsp[(2) - (2)].decl); }
    break;

  case 400:

/* Line 1806 of yacc.c  */
#line 1639 "parser.yy"
    {
			distExt( (yyvsp[(2) - (3)].decl) );								// mark all fields in list
			(yyval.decl) = (yyvsp[(2) - (3)].decl);
		}
    break;

  case 401:

/* Line 1806 of yacc.c  */
#line 1644 "parser.yy"
    {
			(yyval.decl) = distAttr( (yyvsp[(1) - (3)].decl), (yyvsp[(2) - (3)].decl) ); }
    break;

  case 402:

/* Line 1806 of yacc.c  */
#line 1647 "parser.yy"
    {
			distExt( (yyvsp[(3) - (4)].decl) );								// mark all fields in list
			(yyval.decl) = distAttr( (yyvsp[(2) - (4)].decl), (yyvsp[(3) - (4)].decl) );
		}
    break;

  case 404:

/* Line 1806 of yacc.c  */
#line 1656 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addName( (yyvsp[(2) - (2)].tok) ); }
    break;

  case 405:

/* Line 1806 of yacc.c  */
#line 1658 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->appendList( (yyvsp[(1) - (3)].decl)->cloneType( (yyvsp[(3) - (3)].tok) ) ); }
    break;

  case 406:

/* Line 1806 of yacc.c  */
#line 1660 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->appendList( (yyvsp[(1) - (2)].decl)->cloneType( 0 ) ); }
    break;

  case 408:

/* Line 1806 of yacc.c  */
#line 1666 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (4)].decl)->appendList( (yyvsp[(4) - (4)].decl)->addQualifiers( (yyvsp[(3) - (4)].decl) ) ); }
    break;

  case 409:

/* Line 1806 of yacc.c  */
#line 1671 "parser.yy"
    { (yyval.decl) = DeclarationNode::newName( 0 ); /* XXX */ }
    break;

  case 410:

/* Line 1806 of yacc.c  */
#line 1673 "parser.yy"
    { (yyval.decl) = DeclarationNode::newBitfield( (yyvsp[(1) - (1)].en) ); }
    break;

  case 411:

/* Line 1806 of yacc.c  */
#line 1676 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addBitfield( (yyvsp[(2) - (2)].en) ); }
    break;

  case 412:

/* Line 1806 of yacc.c  */
#line 1679 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addBitfield( (yyvsp[(2) - (2)].en) ); }
    break;

  case 414:

/* Line 1806 of yacc.c  */
#line 1685 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 415:

/* Line 1806 of yacc.c  */
#line 1687 "parser.yy"
    { (yyval.en) = (yyvsp[(1) - (1)].en); }
    break;

  case 416:

/* Line 1806 of yacc.c  */
#line 1692 "parser.yy"
    { (yyval.en) = (yyvsp[(2) - (2)].en); }
    break;

  case 417:

/* Line 1806 of yacc.c  */
#line 1697 "parser.yy"
    { (yyval.decl) = DeclarationNode::newEnum( nullptr, (yyvsp[(4) - (6)].decl), true )->addQualifiers( (yyvsp[(2) - (6)].decl) ); }
    break;

  case 418:

/* Line 1806 of yacc.c  */
#line 1699 "parser.yy"
    { typedefTable.makeTypedef( *(yyvsp[(3) - (3)].tok) ); }
    break;

  case 419:

/* Line 1806 of yacc.c  */
#line 1701 "parser.yy"
    { (yyval.decl) = DeclarationNode::newEnum( (yyvsp[(3) - (8)].tok), (yyvsp[(6) - (8)].decl), true )->addQualifiers( (yyvsp[(2) - (8)].decl) ); }
    break;

  case 421:

/* Line 1806 of yacc.c  */
#line 1707 "parser.yy"
    {
			typedefTable.makeTypedef( *(yyvsp[(3) - (3)].tok) );
			(yyval.decl) = DeclarationNode::newEnum( (yyvsp[(3) - (3)].tok), 0, false )->addQualifiers( (yyvsp[(2) - (3)].decl) );
		}
    break;

  case 422:

/* Line 1806 of yacc.c  */
#line 1715 "parser.yy"
    { (yyval.decl) = DeclarationNode::newEnumConstant( (yyvsp[(1) - (2)].tok), (yyvsp[(2) - (2)].en) ); }
    break;

  case 423:

/* Line 1806 of yacc.c  */
#line 1717 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (4)].decl)->appendList( DeclarationNode::newEnumConstant( (yyvsp[(3) - (4)].tok), (yyvsp[(4) - (4)].en) ) ); }
    break;

  case 424:

/* Line 1806 of yacc.c  */
#line 1722 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 425:

/* Line 1806 of yacc.c  */
#line 1724 "parser.yy"
    { (yyval.en) = (yyvsp[(2) - (2)].en); }
    break;

  case 426:

/* Line 1806 of yacc.c  */
#line 1731 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 430:

/* Line 1806 of yacc.c  */
#line 1739 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(5) - (5)].decl) ); }
    break;

  case 431:

/* Line 1806 of yacc.c  */
#line 1741 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->addVarArgs(); }
    break;

  case 432:

/* Line 1806 of yacc.c  */
#line 1743 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->addVarArgs(); }
    break;

  case 434:

/* Line 1806 of yacc.c  */
#line 1751 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(5) - (5)].decl) ); }
    break;

  case 435:

/* Line 1806 of yacc.c  */
#line 1753 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(5) - (5)].decl) ); }
    break;

  case 436:

/* Line 1806 of yacc.c  */
#line 1755 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (9)].decl)->appendList( (yyvsp[(5) - (9)].decl) )->appendList( (yyvsp[(9) - (9)].decl) ); }
    break;

  case 438:

/* Line 1806 of yacc.c  */
#line 1761 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(5) - (5)].decl) ); }
    break;

  case 439:

/* Line 1806 of yacc.c  */
#line 1766 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 442:

/* Line 1806 of yacc.c  */
#line 1773 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->addVarArgs(); }
    break;

  case 445:

/* Line 1806 of yacc.c  */
#line 1780 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(5) - (5)].decl) ); }
    break;

  case 446:

/* Line 1806 of yacc.c  */
#line 1782 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(5) - (5)].decl) ); }
    break;

  case 448:

/* Line 1806 of yacc.c  */
#line 1791 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addName( (yyvsp[(2) - (3)].tok) ); }
    break;

  case 449:

/* Line 1806 of yacc.c  */
#line 1794 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addName( (yyvsp[(2) - (3)].tok) ); }
    break;

  case 450:

/* Line 1806 of yacc.c  */
#line 1796 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addName( (yyvsp[(3) - (4)].tok) )->addQualifiers( (yyvsp[(1) - (4)].decl) ); }
    break;

  case 455:

/* Line 1806 of yacc.c  */
#line 1806 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 457:

/* Line 1806 of yacc.c  */
#line 1813 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (3)].decl)->addType( (yyvsp[(1) - (3)].decl) )->addInitializer( (yyvsp[(3) - (3)].en) ? new InitializerNode( (yyvsp[(3) - (3)].en) ) : nullptr );
		}
    break;

  case 458:

/* Line 1806 of yacc.c  */
#line 1818 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (3)].decl)->addType( (yyvsp[(1) - (3)].decl) )->addInitializer( (yyvsp[(3) - (3)].en) ? new InitializerNode( (yyvsp[(3) - (3)].en) ) : nullptr );
		}
    break;

  case 459:

/* Line 1806 of yacc.c  */
#line 1826 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addInitializer( (yyvsp[(2) - (2)].en) ? new InitializerNode( (yyvsp[(2) - (2)].en) ) : nullptr ); }
    break;

  case 460:

/* Line 1806 of yacc.c  */
#line 1828 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl)->addType( (yyvsp[(1) - (3)].decl) )->addInitializer( (yyvsp[(3) - (3)].en) ? new InitializerNode( (yyvsp[(3) - (3)].en) ) : nullptr ); }
    break;

  case 461:

/* Line 1806 of yacc.c  */
#line 1837 "parser.yy"
    { (yyval.decl) = DeclarationNode::newName( (yyvsp[(1) - (1)].tok) ); }
    break;

  case 462:

/* Line 1806 of yacc.c  */
#line 1839 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->appendList( DeclarationNode::newName( (yyvsp[(3) - (3)].tok) ) ); }
    break;

  case 474:

/* Line 1806 of yacc.c  */
#line 1864 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addType( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 477:

/* Line 1806 of yacc.c  */
#line 1874 "parser.yy"
    { (yyval.in) = nullptr; }
    break;

  case 478:

/* Line 1806 of yacc.c  */
#line 1876 "parser.yy"
    { (yyval.in) = (yyvsp[(2) - (2)].in); }
    break;

  case 479:

/* Line 1806 of yacc.c  */
#line 1878 "parser.yy"
    { (yyval.in) = (yyvsp[(2) - (2)].in)->set_maybeConstructed( false ); }
    break;

  case 480:

/* Line 1806 of yacc.c  */
#line 1882 "parser.yy"
    { (yyval.in) = new InitializerNode( (yyvsp[(1) - (1)].en) ); }
    break;

  case 481:

/* Line 1806 of yacc.c  */
#line 1883 "parser.yy"
    { (yyval.in) = new InitializerNode( (yyvsp[(2) - (4)].in), true ); }
    break;

  case 482:

/* Line 1806 of yacc.c  */
#line 1888 "parser.yy"
    { (yyval.in) = nullptr; }
    break;

  case 484:

/* Line 1806 of yacc.c  */
#line 1890 "parser.yy"
    { (yyval.in) = (yyvsp[(2) - (2)].in)->set_designators( (yyvsp[(1) - (2)].en) ); }
    break;

  case 485:

/* Line 1806 of yacc.c  */
#line 1891 "parser.yy"
    { (yyval.in) = (InitializerNode *)( (yyvsp[(1) - (3)].in)->set_last( (yyvsp[(3) - (3)].in) ) ); }
    break;

  case 486:

/* Line 1806 of yacc.c  */
#line 1893 "parser.yy"
    { (yyval.in) = (InitializerNode *)( (yyvsp[(1) - (4)].in)->set_last( (yyvsp[(4) - (4)].in)->set_designators( (yyvsp[(3) - (4)].en) ) ) ); }
    break;

  case 488:

/* Line 1806 of yacc.c  */
#line 1909 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_varref( (yyvsp[(1) - (2)].tok) ) ); }
    break;

  case 490:

/* Line 1806 of yacc.c  */
#line 1915 "parser.yy"
    { (yyval.en) = (ExpressionNode *)( (yyvsp[(1) - (2)].en)->set_last( (yyvsp[(2) - (2)].en) ) ); }
    break;

  case 491:

/* Line 1806 of yacc.c  */
#line 1921 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_varref( (yyvsp[(2) - (2)].tok) ) ); }
    break;

  case 492:

/* Line 1806 of yacc.c  */
#line 1924 "parser.yy"
    { (yyval.en) = (yyvsp[(3) - (5)].en); }
    break;

  case 493:

/* Line 1806 of yacc.c  */
#line 1926 "parser.yy"
    { (yyval.en) = (yyvsp[(3) - (5)].en); }
    break;

  case 494:

/* Line 1806 of yacc.c  */
#line 1928 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_range( (yyvsp[(3) - (7)].en), (yyvsp[(5) - (7)].en) ) ); }
    break;

  case 495:

/* Line 1806 of yacc.c  */
#line 1930 "parser.yy"
    { (yyval.en) = (yyvsp[(4) - (6)].en); }
    break;

  case 497:

/* Line 1806 of yacc.c  */
#line 1954 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 498:

/* Line 1806 of yacc.c  */
#line 1956 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 499:

/* Line 1806 of yacc.c  */
#line 1958 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->addQualifiers( (yyvsp[(2) - (3)].decl) )->addQualifiers( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 501:

/* Line 1806 of yacc.c  */
#line 1964 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 502:

/* Line 1806 of yacc.c  */
#line 1966 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 503:

/* Line 1806 of yacc.c  */
#line 1971 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFromTypeGen( (yyvsp[(1) - (4)].tok), (yyvsp[(3) - (4)].en) ); }
    break;

  case 505:

/* Line 1806 of yacc.c  */
#line 1977 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (4)].decl)->appendList( (yyvsp[(3) - (4)].decl) ); }
    break;

  case 506:

/* Line 1806 of yacc.c  */
#line 1982 "parser.yy"
    { typedefTable.addToEnclosingScope( *(yyvsp[(2) - (2)].tok), TypedefTable::TD ); }
    break;

  case 507:

/* Line 1806 of yacc.c  */
#line 1984 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTypeParam( (yyvsp[(1) - (4)].tclass), (yyvsp[(2) - (4)].tok) )->addAssertions( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 509:

/* Line 1806 of yacc.c  */
#line 1990 "parser.yy"
    { (yyval.tclass) = DeclarationNode::Otype; }
    break;

  case 510:

/* Line 1806 of yacc.c  */
#line 1992 "parser.yy"
    { (yyval.tclass) = DeclarationNode::Dtype; }
    break;

  case 511:

/* Line 1806 of yacc.c  */
#line 1994 "parser.yy"
    { (yyval.tclass) = DeclarationNode::Ftype; }
    break;

  case 512:

/* Line 1806 of yacc.c  */
#line 1996 "parser.yy"
    { (yyval.tclass) = DeclarationNode::Ttype; }
    break;

  case 513:

/* Line 1806 of yacc.c  */
#line 2001 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 514:

/* Line 1806 of yacc.c  */
#line 2003 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl) ? (yyvsp[(1) - (2)].decl)->appendList( (yyvsp[(2) - (2)].decl) ) : (yyvsp[(2) - (2)].decl); }
    break;

  case 515:

/* Line 1806 of yacc.c  */
#line 2008 "parser.yy"
    {
			typedefTable.openTrait( *(yyvsp[(2) - (5)].tok) );
			(yyval.decl) = DeclarationNode::newTraitUse( (yyvsp[(2) - (5)].tok), (yyvsp[(4) - (5)].en) );
		}
    break;

  case 516:

/* Line 1806 of yacc.c  */
#line 2013 "parser.yy"
    { (yyval.decl) = (yyvsp[(4) - (5)].decl); }
    break;

  case 517:

/* Line 1806 of yacc.c  */
#line 2015 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 518:

/* Line 1806 of yacc.c  */
#line 2020 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_typevalue( (yyvsp[(1) - (1)].decl) ) ); }
    break;

  case 520:

/* Line 1806 of yacc.c  */
#line 2023 "parser.yy"
    { (yyval.en) = (ExpressionNode *)( (yyvsp[(1) - (3)].en)->set_last( new ExpressionNode( build_typevalue( (yyvsp[(3) - (3)].decl) ) ) ) ); }
    break;

  case 521:

/* Line 1806 of yacc.c  */
#line 2025 "parser.yy"
    { (yyval.en) = (ExpressionNode *)( (yyvsp[(1) - (3)].en)->set_last( (yyvsp[(3) - (3)].en) )); }
    break;

  case 522:

/* Line 1806 of yacc.c  */
#line 2030 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl); }
    break;

  case 523:

/* Line 1806 of yacc.c  */
#line 2032 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addQualifiers( (yyvsp[(1) - (3)].decl) ); }
    break;

  case 524:

/* Line 1806 of yacc.c  */
#line 2034 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->appendList( (yyvsp[(3) - (3)].decl)->copyStorageClasses( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 525:

/* Line 1806 of yacc.c  */
#line 2039 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addAssertions( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 526:

/* Line 1806 of yacc.c  */
#line 2041 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (4)].decl)->addAssertions( (yyvsp[(2) - (4)].decl) )->addType( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 527:

/* Line 1806 of yacc.c  */
#line 2046 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(1) - (1)].tok), TypedefTable::TD );
			(yyval.decl) = DeclarationNode::newTypeDecl( (yyvsp[(1) - (1)].tok), 0 );
		}
    break;

  case 528:

/* Line 1806 of yacc.c  */
#line 2051 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(1) - (6)].tok), TypedefTable::TG );
			(yyval.decl) = DeclarationNode::newTypeDecl( (yyvsp[(1) - (6)].tok), (yyvsp[(4) - (6)].decl) );
		}
    break;

  case 529:

/* Line 1806 of yacc.c  */
#line 2059 "parser.yy"
    {
			typedefTable.addToEnclosingScope( *(yyvsp[(2) - (9)].tok), TypedefTable::ID );
			(yyval.decl) = DeclarationNode::newTrait( (yyvsp[(2) - (9)].tok), (yyvsp[(5) - (9)].decl), 0 );
		}
    break;

  case 530:

/* Line 1806 of yacc.c  */
#line 2064 "parser.yy"
    {
			typedefTable.enterTrait( *(yyvsp[(2) - (8)].tok) );
			typedefTable.enterScope();
		}
    break;

  case 531:

/* Line 1806 of yacc.c  */
#line 2069 "parser.yy"
    {
			typedefTable.leaveTrait();
			typedefTable.addToEnclosingScope( *(yyvsp[(2) - (11)].tok), TypedefTable::ID );
			(yyval.decl) = DeclarationNode::newTrait( (yyvsp[(2) - (11)].tok), (yyvsp[(5) - (11)].decl), (yyvsp[(10) - (11)].decl) );
		}
    break;

  case 533:

/* Line 1806 of yacc.c  */
#line 2079 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl)->appendList( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 536:

/* Line 1806 of yacc.c  */
#line 2089 "parser.yy"
    {
			typedefTable.addToEnclosingScope2( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (1)].decl);
		}
    break;

  case 537:

/* Line 1806 of yacc.c  */
#line 2094 "parser.yy"
    {
			typedefTable.addToEnclosingScope2( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (1)].decl);
		}
    break;

  case 538:

/* Line 1806 of yacc.c  */
#line 2099 "parser.yy"
    {
			typedefTable.addToEnclosingScope2( *(yyvsp[(5) - (5)].tok), TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(1) - (5)].decl)->cloneType( (yyvsp[(5) - (5)].tok) ) );
		}
    break;

  case 539:

/* Line 1806 of yacc.c  */
#line 2107 "parser.yy"
    {
			typedefTable.addToEnclosingScope2( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(2) - (2)].decl)->addType( (yyvsp[(1) - (2)].decl) );
		}
    break;

  case 540:

/* Line 1806 of yacc.c  */
#line 2112 "parser.yy"
    {
			typedefTable.addToEnclosingScope2( TypedefTable::ID );
			(yyval.decl) = (yyvsp[(1) - (5)].decl)->appendList( (yyvsp[(1) - (5)].decl)->cloneBaseType( (yyvsp[(5) - (5)].decl) ) );
		}
    break;

  case 541:

/* Line 1806 of yacc.c  */
#line 2122 "parser.yy"
    {}
    break;

  case 542:

/* Line 1806 of yacc.c  */
#line 2124 "parser.yy"
    { parseTree = parseTree ? parseTree->appendList( (yyvsp[(1) - (1)].decl) ) : (yyvsp[(1) - (1)].decl);	}
    break;

  case 544:

/* Line 1806 of yacc.c  */
#line 2130 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (3)].decl) ? (yyvsp[(1) - (3)].decl)->appendList( (yyvsp[(3) - (3)].decl) ) : (yyvsp[(3) - (3)].decl); }
    break;

  case 545:

/* Line 1806 of yacc.c  */
#line 2135 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 549:

/* Line 1806 of yacc.c  */
#line 2143 "parser.yy"
    {
			(yyval.decl) = DeclarationNode::newAsmStmt( new StatementNode( build_asmstmt( false, (yyvsp[(3) - (5)].constant), 0 ) ) );
		}
    break;

  case 550:

/* Line 1806 of yacc.c  */
#line 2147 "parser.yy"
    {
			linkageStack.push( linkage );				// handle nested extern "C"/"Cforall"
			linkage = LinkageSpec::linkageCheck( (yyvsp[(2) - (2)].tok) );
		}
    break;

  case 551:

/* Line 1806 of yacc.c  */
#line 2152 "parser.yy"
    {
			linkage = linkageStack.top();
			linkageStack.pop();
			(yyval.decl) = (yyvsp[(5) - (6)].decl);
		}
    break;

  case 552:

/* Line 1806 of yacc.c  */
#line 2158 "parser.yy"
    {
			distExt( (yyvsp[(2) - (2)].decl) );								// mark all fields in list
			(yyval.decl) = (yyvsp[(2) - (2)].decl);
		}
    break;

  case 554:

/* Line 1806 of yacc.c  */
#line 2172 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(1) - (2)].decl)->addFunctionBody( (yyvsp[(2) - (2)].sn) );
		}
    break;

  case 555:

/* Line 1806 of yacc.c  */
#line 2178 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(1) - (4)].decl)->addOldDeclList( (yyvsp[(3) - (4)].decl) )->addFunctionBody( (yyvsp[(4) - (4)].sn) );
		}
    break;

  case 556:

/* Line 1806 of yacc.c  */
#line 2187 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(1) - (2)].decl)->addFunctionBody( (yyvsp[(2) - (2)].sn) );
		}
    break;

  case 557:

/* Line 1806 of yacc.c  */
#line 2193 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(2) - (3)].decl)->addFunctionBody( (yyvsp[(3) - (3)].sn) )->addType( (yyvsp[(1) - (3)].decl) );
		}
    break;

  case 558:

/* Line 1806 of yacc.c  */
#line 2199 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(2) - (3)].decl)->addFunctionBody( (yyvsp[(3) - (3)].sn) )->addQualifiers( (yyvsp[(1) - (3)].decl) );
		}
    break;

  case 559:

/* Line 1806 of yacc.c  */
#line 2205 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(2) - (3)].decl)->addFunctionBody( (yyvsp[(3) - (3)].sn) )->addQualifiers( (yyvsp[(1) - (3)].decl) );
		}
    break;

  case 560:

/* Line 1806 of yacc.c  */
#line 2211 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(3) - (4)].decl)->addFunctionBody( (yyvsp[(4) - (4)].sn) )->addQualifiers( (yyvsp[(2) - (4)].decl) )->addQualifiers( (yyvsp[(1) - (4)].decl) );
		}
    break;

  case 561:

/* Line 1806 of yacc.c  */
#line 2219 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(2) - (5)].decl)->addOldDeclList( (yyvsp[(4) - (5)].decl) )->addFunctionBody( (yyvsp[(5) - (5)].sn) )->addType( (yyvsp[(1) - (5)].decl) );
		}
    break;

  case 562:

/* Line 1806 of yacc.c  */
#line 2225 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(2) - (5)].decl)->addOldDeclList( (yyvsp[(4) - (5)].decl) )->addFunctionBody( (yyvsp[(5) - (5)].sn) )->addQualifiers( (yyvsp[(1) - (5)].decl) );
		}
    break;

  case 563:

/* Line 1806 of yacc.c  */
#line 2233 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(2) - (5)].decl)->addOldDeclList( (yyvsp[(4) - (5)].decl) )->addFunctionBody( (yyvsp[(5) - (5)].sn) )->addQualifiers( (yyvsp[(1) - (5)].decl) );
		}
    break;

  case 564:

/* Line 1806 of yacc.c  */
#line 2239 "parser.yy"
    {
			typedefTable.addToEnclosingScope( TypedefTable::ID );
			typedefTable.leaveScope();
			(yyval.decl) = (yyvsp[(3) - (6)].decl)->addOldDeclList( (yyvsp[(5) - (6)].decl) )->addFunctionBody( (yyvsp[(6) - (6)].sn) )->addQualifiers( (yyvsp[(2) - (6)].decl) )->addQualifiers( (yyvsp[(1) - (6)].decl) );
		}
    break;

  case 568:

/* Line 1806 of yacc.c  */
#line 2254 "parser.yy"
    { (yyval.en) = new ExpressionNode( build_range( (yyvsp[(1) - (3)].en), (yyvsp[(3) - (3)].en) ) ); }
    break;

  case 569:

/* Line 1806 of yacc.c  */
#line 2259 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 570:

/* Line 1806 of yacc.c  */
#line 2261 "parser.yy"
    {
			DeclarationNode * name = new DeclarationNode();
			name->asmName = (yyvsp[(3) - (5)].constant);
			(yyval.decl) = name->addQualifiers( (yyvsp[(5) - (5)].decl) );
		}
    break;

  case 571:

/* Line 1806 of yacc.c  */
#line 2270 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 574:

/* Line 1806 of yacc.c  */
#line 2277 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 575:

/* Line 1806 of yacc.c  */
#line 2282 "parser.yy"
    { (yyval.decl) = (yyvsp[(4) - (6)].decl); }
    break;

  case 577:

/* Line 1806 of yacc.c  */
#line 2288 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addQualifiers( (yyvsp[(1) - (3)].decl) ); }
    break;

  case 578:

/* Line 1806 of yacc.c  */
#line 2293 "parser.yy"
    { (yyval.decl) = nullptr; }
    break;

  case 579:

/* Line 1806 of yacc.c  */
#line 2295 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAttribute( (yyvsp[(1) - (1)].tok) ); }
    break;

  case 580:

/* Line 1806 of yacc.c  */
#line 2297 "parser.yy"
    { (yyval.decl) = DeclarationNode::newAttribute( (yyvsp[(1) - (4)].tok), (yyvsp[(3) - (4)].en) ); }
    break;

  case 584:

/* Line 1806 of yacc.c  */
#line 2305 "parser.yy"
    { (yyval.tok) = Token{ new string( "__const__" ) }; }
    break;

  case 585:

/* Line 1806 of yacc.c  */
#line 2340 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 587:

/* Line 1806 of yacc.c  */
#line 2343 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 588:

/* Line 1806 of yacc.c  */
#line 2345 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 589:

/* Line 1806 of yacc.c  */
#line 2350 "parser.yy"
    {
			typedefTable.setNextIdentifier( *(yyvsp[(1) - (1)].tok) );
			(yyval.decl) = DeclarationNode::newName( (yyvsp[(1) - (1)].tok) );
		}
    break;

  case 590:

/* Line 1806 of yacc.c  */
#line 2355 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 591:

/* Line 1806 of yacc.c  */
#line 2360 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 592:

/* Line 1806 of yacc.c  */
#line 2362 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 593:

/* Line 1806 of yacc.c  */
#line 2364 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 594:

/* Line 1806 of yacc.c  */
#line 2369 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addArray( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 595:

/* Line 1806 of yacc.c  */
#line 2371 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 596:

/* Line 1806 of yacc.c  */
#line 2373 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 597:

/* Line 1806 of yacc.c  */
#line 2375 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 598:

/* Line 1806 of yacc.c  */
#line 2380 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 599:

/* Line 1806 of yacc.c  */
#line 2382 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 600:

/* Line 1806 of yacc.c  */
#line 2391 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 602:

/* Line 1806 of yacc.c  */
#line 2394 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 603:

/* Line 1806 of yacc.c  */
#line 2399 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (6)].decl)->addParamList( (yyvsp[(4) - (6)].decl) ); }
    break;

  case 604:

/* Line 1806 of yacc.c  */
#line 2401 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 605:

/* Line 1806 of yacc.c  */
#line 2403 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 606:

/* Line 1806 of yacc.c  */
#line 2408 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 607:

/* Line 1806 of yacc.c  */
#line 2410 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 608:

/* Line 1806 of yacc.c  */
#line 2412 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 609:

/* Line 1806 of yacc.c  */
#line 2417 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 610:

/* Line 1806 of yacc.c  */
#line 2419 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 611:

/* Line 1806 of yacc.c  */
#line 2421 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 615:

/* Line 1806 of yacc.c  */
#line 2439 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (4)].decl)->addIdList( (yyvsp[(3) - (4)].decl) ); }
    break;

  case 616:

/* Line 1806 of yacc.c  */
#line 2441 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 617:

/* Line 1806 of yacc.c  */
#line 2443 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 618:

/* Line 1806 of yacc.c  */
#line 2448 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 619:

/* Line 1806 of yacc.c  */
#line 2450 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 620:

/* Line 1806 of yacc.c  */
#line 2452 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 621:

/* Line 1806 of yacc.c  */
#line 2457 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 622:

/* Line 1806 of yacc.c  */
#line 2459 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 623:

/* Line 1806 of yacc.c  */
#line 2461 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 624:

/* Line 1806 of yacc.c  */
#line 2476 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 626:

/* Line 1806 of yacc.c  */
#line 2479 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 627:

/* Line 1806 of yacc.c  */
#line 2481 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 629:

/* Line 1806 of yacc.c  */
#line 2487 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 630:

/* Line 1806 of yacc.c  */
#line 2492 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 631:

/* Line 1806 of yacc.c  */
#line 2494 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 632:

/* Line 1806 of yacc.c  */
#line 2496 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 633:

/* Line 1806 of yacc.c  */
#line 2501 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addArray( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 634:

/* Line 1806 of yacc.c  */
#line 2503 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 635:

/* Line 1806 of yacc.c  */
#line 2505 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 636:

/* Line 1806 of yacc.c  */
#line 2507 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 637:

/* Line 1806 of yacc.c  */
#line 2512 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (6)].decl)->addParamList( (yyvsp[(4) - (6)].decl) ); }
    break;

  case 638:

/* Line 1806 of yacc.c  */
#line 2514 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 639:

/* Line 1806 of yacc.c  */
#line 2516 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 640:

/* Line 1806 of yacc.c  */
#line 2526 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 642:

/* Line 1806 of yacc.c  */
#line 2529 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 643:

/* Line 1806 of yacc.c  */
#line 2531 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 644:

/* Line 1806 of yacc.c  */
#line 2536 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 645:

/* Line 1806 of yacc.c  */
#line 2538 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 646:

/* Line 1806 of yacc.c  */
#line 2540 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 647:

/* Line 1806 of yacc.c  */
#line 2545 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addArray( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 648:

/* Line 1806 of yacc.c  */
#line 2547 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 649:

/* Line 1806 of yacc.c  */
#line 2549 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 650:

/* Line 1806 of yacc.c  */
#line 2551 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 651:

/* Line 1806 of yacc.c  */
#line 2556 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (6)].decl)->addParamList( (yyvsp[(4) - (6)].decl) ); }
    break;

  case 652:

/* Line 1806 of yacc.c  */
#line 2558 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 653:

/* Line 1806 of yacc.c  */
#line 2560 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 654:

/* Line 1806 of yacc.c  */
#line 2573 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 656:

/* Line 1806 of yacc.c  */
#line 2576 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 657:

/* Line 1806 of yacc.c  */
#line 2578 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 658:

/* Line 1806 of yacc.c  */
#line 2583 "parser.yy"
    {
			typedefTable.setNextIdentifier( *(yyvsp[(1) - (1)].tok) );
			(yyval.decl) = DeclarationNode::newName( (yyvsp[(1) - (1)].tok) );
		}
    break;

  case 659:

/* Line 1806 of yacc.c  */
#line 2588 "parser.yy"
    {
			typedefTable.setNextIdentifier( *(yyvsp[(1) - (1)].tok) );
			(yyval.decl) = DeclarationNode::newName( (yyvsp[(1) - (1)].tok) );
		}
    break;

  case 660:

/* Line 1806 of yacc.c  */
#line 2596 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 661:

/* Line 1806 of yacc.c  */
#line 2598 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 662:

/* Line 1806 of yacc.c  */
#line 2600 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 663:

/* Line 1806 of yacc.c  */
#line 2605 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addArray( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 664:

/* Line 1806 of yacc.c  */
#line 2607 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 665:

/* Line 1806 of yacc.c  */
#line 2612 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (6)].decl)->addParamList( (yyvsp[(4) - (6)].decl) ); }
    break;

  case 666:

/* Line 1806 of yacc.c  */
#line 2614 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 668:

/* Line 1806 of yacc.c  */
#line 2632 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 669:

/* Line 1806 of yacc.c  */
#line 2634 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 670:

/* Line 1806 of yacc.c  */
#line 2639 "parser.yy"
    { (yyval.decl) = DeclarationNode::newPointer( 0 ); }
    break;

  case 671:

/* Line 1806 of yacc.c  */
#line 2641 "parser.yy"
    { (yyval.decl) = DeclarationNode::newPointer( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 672:

/* Line 1806 of yacc.c  */
#line 2643 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 673:

/* Line 1806 of yacc.c  */
#line 2645 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 674:

/* Line 1806 of yacc.c  */
#line 2647 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 676:

/* Line 1806 of yacc.c  */
#line 2653 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 677:

/* Line 1806 of yacc.c  */
#line 2655 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 678:

/* Line 1806 of yacc.c  */
#line 2657 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 679:

/* Line 1806 of yacc.c  */
#line 2662 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFunction( nullptr, nullptr, (yyvsp[(3) - (5)].decl), nullptr ); }
    break;

  case 680:

/* Line 1806 of yacc.c  */
#line 2664 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 681:

/* Line 1806 of yacc.c  */
#line 2666 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 682:

/* Line 1806 of yacc.c  */
#line 2672 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( 0, 0, false ); }
    break;

  case 683:

/* Line 1806 of yacc.c  */
#line 2674 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( 0, 0, false )->addArray( (yyvsp[(3) - (3)].decl) ); }
    break;

  case 685:

/* Line 1806 of yacc.c  */
#line 2680 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(3) - (5)].en), 0, false ); }
    break;

  case 686:

/* Line 1806 of yacc.c  */
#line 2682 "parser.yy"
    { (yyval.decl) = DeclarationNode::newVarArray( 0 ); }
    break;

  case 687:

/* Line 1806 of yacc.c  */
#line 2684 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (6)].decl)->addArray( DeclarationNode::newArray( (yyvsp[(4) - (6)].en), 0, false ) ); }
    break;

  case 688:

/* Line 1806 of yacc.c  */
#line 2686 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (6)].decl)->addArray( DeclarationNode::newVarArray( 0 ) ); }
    break;

  case 690:

/* Line 1806 of yacc.c  */
#line 2721 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 691:

/* Line 1806 of yacc.c  */
#line 2723 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 692:

/* Line 1806 of yacc.c  */
#line 2728 "parser.yy"
    { (yyval.decl) = DeclarationNode::newPointer( nullptr ); }
    break;

  case 693:

/* Line 1806 of yacc.c  */
#line 2730 "parser.yy"
    { (yyval.decl) = DeclarationNode::newPointer( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 694:

/* Line 1806 of yacc.c  */
#line 2732 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( nullptr ) ); }
    break;

  case 695:

/* Line 1806 of yacc.c  */
#line 2734 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 696:

/* Line 1806 of yacc.c  */
#line 2736 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 698:

/* Line 1806 of yacc.c  */
#line 2742 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 699:

/* Line 1806 of yacc.c  */
#line 2744 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 700:

/* Line 1806 of yacc.c  */
#line 2746 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 701:

/* Line 1806 of yacc.c  */
#line 2751 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFunction( nullptr, nullptr, (yyvsp[(3) - (5)].decl), nullptr ); }
    break;

  case 702:

/* Line 1806 of yacc.c  */
#line 2753 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 703:

/* Line 1806 of yacc.c  */
#line 2755 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 705:

/* Line 1806 of yacc.c  */
#line 2762 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addArray( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 707:

/* Line 1806 of yacc.c  */
#line 2773 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( 0, 0, false ); }
    break;

  case 708:

/* Line 1806 of yacc.c  */
#line 2776 "parser.yy"
    { (yyval.decl) = DeclarationNode::newVarArray( (yyvsp[(3) - (6)].decl) ); }
    break;

  case 709:

/* Line 1806 of yacc.c  */
#line 2778 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( 0, (yyvsp[(3) - (5)].decl), false ); }
    break;

  case 710:

/* Line 1806 of yacc.c  */
#line 2781 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(4) - (6)].en), (yyvsp[(3) - (6)].decl), false ); }
    break;

  case 711:

/* Line 1806 of yacc.c  */
#line 2783 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(5) - (7)].en), (yyvsp[(4) - (7)].decl), true ); }
    break;

  case 712:

/* Line 1806 of yacc.c  */
#line 2785 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(5) - (7)].en), (yyvsp[(3) - (7)].decl), true ); }
    break;

  case 714:

/* Line 1806 of yacc.c  */
#line 2800 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 715:

/* Line 1806 of yacc.c  */
#line 2802 "parser.yy"
    { (yyval.decl) = (yyvsp[(1) - (2)].decl)->addQualifiers( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 716:

/* Line 1806 of yacc.c  */
#line 2807 "parser.yy"
    { (yyval.decl) = DeclarationNode::newPointer( 0 ); }
    break;

  case 717:

/* Line 1806 of yacc.c  */
#line 2809 "parser.yy"
    { (yyval.decl) = DeclarationNode::newPointer( (yyvsp[(2) - (2)].decl) ); }
    break;

  case 718:

/* Line 1806 of yacc.c  */
#line 2811 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 719:

/* Line 1806 of yacc.c  */
#line 2813 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addPointer( DeclarationNode::newPointer( (yyvsp[(2) - (3)].decl) ) ); }
    break;

  case 720:

/* Line 1806 of yacc.c  */
#line 2815 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addQualifiers( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 722:

/* Line 1806 of yacc.c  */
#line 2821 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 723:

/* Line 1806 of yacc.c  */
#line 2823 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (4)].decl)->addArray( (yyvsp[(4) - (4)].decl) ); }
    break;

  case 724:

/* Line 1806 of yacc.c  */
#line 2825 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 725:

/* Line 1806 of yacc.c  */
#line 2830 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (8)].decl)->addParamList( (yyvsp[(6) - (8)].decl) ); }
    break;

  case 726:

/* Line 1806 of yacc.c  */
#line 2832 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (3)].decl); }
    break;

  case 729:

/* Line 1806 of yacc.c  */
#line 2842 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 732:

/* Line 1806 of yacc.c  */
#line 2853 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 733:

/* Line 1806 of yacc.c  */
#line 2855 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewPointer( DeclarationNode::newPointer( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 734:

/* Line 1806 of yacc.c  */
#line 2857 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 735:

/* Line 1806 of yacc.c  */
#line 2859 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewPointer( DeclarationNode::newPointer( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 736:

/* Line 1806 of yacc.c  */
#line 2861 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 737:

/* Line 1806 of yacc.c  */
#line 2863 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewPointer( DeclarationNode::newPointer( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 738:

/* Line 1806 of yacc.c  */
#line 2870 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewArray( DeclarationNode::newArray( 0, 0, false ) ); }
    break;

  case 739:

/* Line 1806 of yacc.c  */
#line 2872 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewArray( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 740:

/* Line 1806 of yacc.c  */
#line 2874 "parser.yy"
    { (yyval.decl) = (yyvsp[(4) - (4)].decl)->addNewArray( (yyvsp[(3) - (4)].decl) )->addNewArray( DeclarationNode::newArray( 0, 0, false ) ); }
    break;

  case 741:

/* Line 1806 of yacc.c  */
#line 2876 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewArray( (yyvsp[(2) - (3)].decl) )->addNewArray( (yyvsp[(1) - (3)].decl) ); }
    break;

  case 742:

/* Line 1806 of yacc.c  */
#line 2878 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewArray( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 743:

/* Line 1806 of yacc.c  */
#line 2881 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewArray( DeclarationNode::newArray( 0, 0, false ) ); }
    break;

  case 744:

/* Line 1806 of yacc.c  */
#line 2883 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewArray( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 745:

/* Line 1806 of yacc.c  */
#line 2885 "parser.yy"
    { (yyval.decl) = (yyvsp[(4) - (4)].decl)->addNewArray( (yyvsp[(3) - (4)].decl) )->addNewArray( DeclarationNode::newArray( 0, 0, false ) ); }
    break;

  case 746:

/* Line 1806 of yacc.c  */
#line 2887 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewArray( (yyvsp[(2) - (3)].decl) )->addNewArray( (yyvsp[(1) - (3)].decl) ); }
    break;

  case 747:

/* Line 1806 of yacc.c  */
#line 2889 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewArray( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 748:

/* Line 1806 of yacc.c  */
#line 2894 "parser.yy"
    { (yyval.decl) = DeclarationNode::newVarArray( (yyvsp[(3) - (6)].decl) ); }
    break;

  case 749:

/* Line 1806 of yacc.c  */
#line 2896 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(4) - (6)].en), (yyvsp[(3) - (6)].decl), false ); }
    break;

  case 750:

/* Line 1806 of yacc.c  */
#line 2901 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(4) - (6)].en), (yyvsp[(3) - (6)].decl), true ); }
    break;

  case 751:

/* Line 1806 of yacc.c  */
#line 2903 "parser.yy"
    { (yyval.decl) = DeclarationNode::newArray( (yyvsp[(5) - (7)].en), (yyvsp[(4) - (7)].decl)->addQualifiers( (yyvsp[(3) - (7)].decl) ), true ); }
    break;

  case 753:

/* Line 1806 of yacc.c  */
#line 2930 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addQualifiers( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 757:

/* Line 1806 of yacc.c  */
#line 2941 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 758:

/* Line 1806 of yacc.c  */
#line 2943 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewPointer( DeclarationNode::newPointer( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 759:

/* Line 1806 of yacc.c  */
#line 2945 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 760:

/* Line 1806 of yacc.c  */
#line 2947 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewPointer( DeclarationNode::newPointer( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 761:

/* Line 1806 of yacc.c  */
#line 2949 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewPointer( DeclarationNode::newPointer( 0 ) ); }
    break;

  case 762:

/* Line 1806 of yacc.c  */
#line 2951 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewPointer( DeclarationNode::newPointer( (yyvsp[(1) - (3)].decl) ) ); }
    break;

  case 763:

/* Line 1806 of yacc.c  */
#line 2958 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewArray( DeclarationNode::newArray( nullptr, nullptr, false ) ); }
    break;

  case 764:

/* Line 1806 of yacc.c  */
#line 2960 "parser.yy"
    { (yyval.decl) = (yyvsp[(4) - (4)].decl)->addNewArray( (yyvsp[(3) - (4)].decl) )->addNewArray( DeclarationNode::newArray( nullptr, nullptr, false ) ); }
    break;

  case 765:

/* Line 1806 of yacc.c  */
#line 2962 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewArray( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 766:

/* Line 1806 of yacc.c  */
#line 2964 "parser.yy"
    { (yyval.decl) = (yyvsp[(3) - (3)].decl)->addNewArray( DeclarationNode::newArray( nullptr, nullptr, false ) ); }
    break;

  case 767:

/* Line 1806 of yacc.c  */
#line 2966 "parser.yy"
    { (yyval.decl) = (yyvsp[(4) - (4)].decl)->addNewArray( (yyvsp[(3) - (4)].decl) )->addNewArray( DeclarationNode::newArray( nullptr, nullptr, false ) ); }
    break;

  case 768:

/* Line 1806 of yacc.c  */
#line 2968 "parser.yy"
    { (yyval.decl) = (yyvsp[(2) - (2)].decl)->addNewArray( (yyvsp[(1) - (2)].decl) ); }
    break;

  case 769:

/* Line 1806 of yacc.c  */
#line 2973 "parser.yy"
    { (yyval.decl) = DeclarationNode::newTuple( (yyvsp[(3) - (5)].decl) ); }
    break;

  case 770:

/* Line 1806 of yacc.c  */
#line 2980 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFunction( nullptr, (yyvsp[(1) - (6)].decl), (yyvsp[(4) - (6)].decl), nullptr ); }
    break;

  case 771:

/* Line 1806 of yacc.c  */
#line 2982 "parser.yy"
    { (yyval.decl) = DeclarationNode::newFunction( nullptr, (yyvsp[(1) - (6)].decl), (yyvsp[(4) - (6)].decl), nullptr ); }
    break;

  case 774:

/* Line 1806 of yacc.c  */
#line 3006 "parser.yy"
    { (yyval.en) = nullptr; }
    break;

  case 775:

/* Line 1806 of yacc.c  */
#line 3008 "parser.yy"
    { (yyval.en) = (yyvsp[(2) - (2)].en); }
    break;



/* Line 1806 of yacc.c  */
#line 9572 "Parser/parser.cc"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 3011 "parser.yy"

// ----end of grammar----

extern char *yytext;

void yyerror( const char * ) {
	cout << "Error ";
	if ( yyfilename ) {
		cout << "in file " << yyfilename << " ";
	} // if
	cout << "at line " << yylineno << " reading token \"" << (yytext[0] == '\0' ? "EOF" : yytext) << "\"" << endl;
}

// Local Variables: //
// mode: c++ //
// tab-width: 4 //
// compile-command: "make install" //
// End: //

